C
      SUBROUTINE GETDIM(INBAS,INTRK,IOUT,INPLOT,ISUM,NCOL,NROW,
     & NLAY,NPER,IUNIT,LCIB,LCH,LCKW,ISS,LCDELR,LCDELC,LCXBC,LCYBC,
     & LCZBC,LCTRPY,LCHY,LCVCON,LCHTOP,LCDZ,LCPR,MXWEL,LCWEL,
     & MXDRN,LCDRN,MXRIV,LCRIV,MXSTR,LCSTR,MXGHB,LCGHB,NRCHOP,
     & LCIRCH,LCRECH,NEVTOP,LCIEVT,LCEVTR,LCEXDP,LCSURF,LCQX,LCQY,LCQZ,
     & NCOUNT,NTRKOP,INIPOS,LCPP,LCPI,IFRONT,NFRONT,ICAPT,INCAPT,itime) !v4.6
C *********************************************************************
C THIS SUBROUTINE READS PROBLEM DIMENSIONS FROM INPUT FILES AND
C ALLOCATES SPACE FOR ALL DATA ARRAYS TO BE USED IN THE MODEL.
C *********************************************************************
C VER 3.50: 10-01-1992
C
      CHARACTER FINDEX*30,FLNAME*50,HEADNG(2)*80,TUNIT*10,tmpstr*70
      DIMENSION IUNIT(24)
      COMMON /UNIT/INBCF,INWEL,INDRN,INRIV,INEVT,INGHB,INRCH,INSTR
      COMMON /CONST/ROERR,TINY,IOPSS,SAFETY
      COMMON /STR/NSS,NTRIB,NDIV,ICALC
      COMMON /DRY/HDRY,IWDFLG
C
C     ---------------------------------------------------------------
      FINDEX='BAS Package Input File: '
      CALL OPENFL(INBAS,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ AND PRINT HEADING
      READ(INBAS,'(A80)') (HEADNG(I),I=1,2)
      WRITE(IOUT,'(1X,A80)') (HEADNG(I),I=1,2)
C
C--READ NO. OF LAYERS, ROWS, COLUMNS, STRESS PERIODS AND TIME UNIT
      READ(INBAS,'(5I10)') NLAY,NROW,NCOL,NPER,ITMUNI
C
C--PRINT NO. OF LAYERS, ROWS, COLUMNS AND STRESS PERIODS
      WRITE(IOUT,6) NLAY,NROW,NCOL
    6 FORMAT(1X,'FLOW MODEL CONSISTS OF ',
     & I5,' LAYERS',I5,' ROWS',I5,' COLUMNS')
      WRITE(IOUT,7) NPER
    7 FORMAT(1X,'NUMBER OF STRESS PERIOD(S) IN SIMULATION =',I10)
C
C--SELECT AND PRINT A MESSAGE SHOWING TIME UNIT
      IF(ITMUNI.LT.0 .OR. ITMUNI.GT.5) THEN
	TUNIT='UNDEFINED'
      ELSEIF (ITMUNI.EQ.1) THEN
	TUNIT='SECONDS'
      ELSEIF (ITMUNI.EQ.2) THEN
	TUNIT='MINUTES'
      ELSEIF (ITMUNI.EQ.3) THEN
	TUNIT='HOURS'
      ELSEIF (ITMUNI.EQ.4) THEN
	TUNIT='DAYS'
      ELSEIF (ITMUNI.EQ.5) THEN
	TUNIT='YEARS'
      ENDIF
      WRITE(IOUT,10) TUNIT
   10 FORMAT(1X,'TIME UNIT USED IN THE MODEL IS ',A10)
C
C--READ AND ASSIGN INPUT UNIT NUMBERS FOR MAJOR OPTIONS
      READ(INBAS,'(24I3)') (IUNIT(I),I=1,24)
      INBCF=IUNIT(1)
      INWEL=IUNIT(2)
      INDRN=IUNIT(3)
      INRIV=IUNIT(4)
      INEVT=IUNIT(5)
      INGHB=IUNIT(7)
      INRCH=IUNIT(8)
      INSTR=IUNIT(14)
      WRITE(IOUT,11) INBCF,INWEL,INDRN,INRIV,INEVT,INGHB,INRCH,INSTR
   11 FORMAT(1X,' PACKAGE:  BCF  WEL  DRN  RIV  EVT  GHB  RCH  STR'
     &      /1X,'    UNIT:',8(2X,I2,1X))
C
C--READ FLAGS IAPART AND ISTRT (NOT USED BY PATH3D)
      READ(INBAS,'(2I10)') IAPART,ISTRT
C
C4------ALLOCATE SPACE FOR ARRAYS.
      NCR=NCOL*NROW
      NODES=NCOL*NROW*NLAY
      NODEQX=(NCOL+1)*NROW*NLAY
      NODEQY=NCOL*(NROW+1)*NLAY
      NODEQZ=NCOL*NROW*(NLAY+1)
C
      LCIB=ISUM
      ISUM=ISUM+NODES
      LCH=ISUM
      ISUM=ISUM+NODES
      LCKW=ISUM
      ISUM=ISUM+NCR
C
C     -------------------------------------------------------------
      FINDEX='BCF Package Input File: '
      CALL OPENFL(INBCF,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ AND PRINT ISS (STEADY-STATE FLAG) AND IWDFLG (REWET FLAG)
      READ(INBCF,12,ERR=14) ISS,IBCFCB,HDRY,IWDFLG,WETFCT,IWETIT,IHDWET
   12 FORMAT(2I10,F10.0,I10,F10.0,2I10)
      GOTO 24
   14 HDRY=1.E30
      IWDFLG=0
      BACKSPACE (INBCF)
      READ(INBCF,12) ISS
   24 CONTINUE
      IF(ISS.NE.0) THEN
	WRITE(IOUT,25)
      ELSE
	WRITE(IOUT,26)
      ENDIF
   25 FORMAT(1X,'FLOW FIELD IS STEADY-STATE (ISS NOT 0)')
   26 FORMAT(1X,'FLOW FIELD IS TRANSIENT (ISS=0)')
      IF(IWDFLG.EQ.0) THEN
	WRITE(IOUT,31)
      ELSE
	WRITE(IOUT,32)
      ENDIF
   31 FORMAT(1X,'WETTING CAPABILITY IS NOT ACTIVE')
   32 FORMAT(1X,'WETTING CAPABILITY IS ACTIVE')
      WRITE(IOUT,33) HDRY
   33 FORMAT(1X,'HEAD AT CELLS THAT CONVERT TO DRY=',G13.5)
C
C--ALLOCATE SPACE FOR ARRAYS
      LCDELR=ISUM
      ISUM=ISUM+NCOL
      LCDELC=ISUM
      ISUM=ISUM+NROW
      LCXBC=ISUM
      ISUM=ISUM+NCOL
      LCYBC=ISUM
      ISUM=ISUM+NROW
      LCZBC=ISUM
      ISUM=ISUM+NODES
      LCHY=ISUM
      ISUM=ISUM+NODES
      LCTRPY=ISUM
      ISUM=ISUM+NLAY
      LCVCON=ISUM
      ISUM=ISUM+NCR*(NLAY-1)
      LCHTOP=ISUM
      ISUM=ISUM+NCR
      LCDZ=ISUM
      ISUM=ISUM+NODES
      LCPR=ISUM
      ISUM=ISUM+NODES
C
C     -------------------------------------------------------------
      IF(INWEL.EQ.0) THEN
	MXWEL=1
	LCWEL=ISUM
      GOTO 1100
      ENDIF
      FINDEX='WEL Package Input File: '
      CALL OPENFL(INWEL,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ MAX NUMBER OF WELLS
      READ(INWEL,'(I10)') MXWEL
      WRITE(IOUT,35) MXWEL
   35 FORMAT(1X,'MAXIMUM NUMBER OF WELLS =',I10)
C
C--ALLOCATE SPACE FOR WELL LOCATIONS IN Y ARRAY.
      LCWEL=ISUM
      ISUM=ISUM+4*MXWEL
C
C     ------------------------------------------------------------------
 1100 IF(INDRN.EQ.0) THEN
	MXDRN=1
	LCDRN=ISUM
	GOTO 1200
      ENDIF
      FINDEX='DRN Package Input File: '                                 !v4.6
      CALL OPENFL(INDRN,3,1,FLNAME,0,FINDEX)
C
C--READ MAX NUMBER OF DRAINS
      READ(INDRN,'(I10)') MXDRN
      WRITE(IOUT,45) MXDRN
   45 FORMAT(1X,'MAXIMUM NUMBER OF DRAINS =',I10)
C
C--LOCATE SPACE IN THE Y ARRAY
      LCDRN=ISUM
      ISUM=ISUM+5*MXDRN                                                 !v4.6
C
C     ------------------------------------------------------------------
 1200 IF(INRIV.EQ.0) THEN
	MXRIV=1
	LCRIV=ISUM
	GOTO 1250
      ENDIF
      FINDEX='RIV Package Input File: '
      CALL OPENFL(INRIV,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ MAX NUMBER OF RIVER REACHES
      READ(INRIV,'(I10)') MXRIV
      WRITE(IOUT,85) MXRIV
   85 FORMAT(1X,'MAXIMUM NUMBER OF RIVER CELLS =',I10)
C
C--ALLOCATE SPACE IN THE Y ARRAY
      LCRIV=ISUM
      ISUM=ISUM+5*MXRIV                                                 !v4.6
C
C     ------------------------------------------------------------------
 1250 IF(INSTR.EQ.0) THEN
	MXSTR=1
	LCSTR=ISUM
      GOTO 1300
      ENDIF
      FINDEX='STR Package Input File: '
      CALL OPENFL(INSTR,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ MAX NUMBER OF RIVER REACHES
      READ(INSTR,'(5I10)') MXSTR,NSS,NTRIB,NDIV,ICALC
      WRITE(IOUT,185) MXSTR
  185 FORMAT(1X,'MAXIMUM NUMBER OF STREAM CELLS =',I10)
C
C--ALLOCATE SPACE IN THE Y ARRAY
      LCSTR=ISUM
      ISUM=ISUM+5*MXSTR                                                 !v4.6
C
C     ------------------------------------------------------------------
 1300 IF(INRCH.EQ.0) THEN
        LCIRCH=ISUM
        LCRECH=ISUM
        GOTO 1400
      ENDIF
      FINDEX='RCH Package Input File: '
      CALL OPENFL(INRCH,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ FLAGS NRCHOP
      READ(INRCH,'(I10)') NRCHOP
      IF(NRCHOP.EQ.1) THEN
	WRITE(IOUT,55)
      ELSEIF(NRCHOP.EQ.2) THEN
	WRITE(IOUT,56)
      ELSEIF(NRCHOP.EQ.3) THEN
	WRITE(IOUT,57)
      ENDIF
   55 FORMAT(1X,'RCH OPTION 1: RECHARGE APPLIED TO THE TOP LAYER')
   56 FORMAT(1X,'RCH OPTION 2: RECHARGE APPLIED TO SPECIFIED LAYERS')
   57 FORMAT(1X,'RCH OPTION 3: ',
     & 'RECHARGE APPLIED TO TOP ACTIVE LAYER IN EACH VERTICAL COLUMN')
C
C--ALLOCATE SPACE FOR THE RECHARGE ARRAY(RECH)
      LCRECH=ISUM
      ISUM=ISUM+NCR
C
C--IF OPTION 2 THEN ALLOCATE SPACE FOR INDICATOR ARRAY(IRCH)
      LCIRCH=ISUM
      IF(NRCHOP.EQ.2) ISUM=ISUM+NCR
C
C     ------------------------------------------------------------------
 1400 IF(INEVT.EQ.0) THEN
        LCIEVT=ISUM
        LCEXDP=ISUM
        LCEVTR=ISUM
        LCSURF=ISUM
        GOTO 1500
      ENDIF
      FINDEX='EVT Package Input File: '
      CALL OPENFL(INEVT,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ NEVTOP
      READ(INEVT,'(I10)') NEVTOP
      IF(NEVTOP.EQ.1) THEN
          WRITE(IOUT,65)
      ELSEIF(NEVTOP.EQ.2) THEN
          WRITE(IOUT,66)
      ELSEIF(NEVTOP.EQ.3) THEN
          WRITE(IOUT,67)
      ENDIF
   65 FORMAT(1X,'EVT OPTION 1: EVAPOTRANSPIRATION APPLIED TO TOP LAYER')
   66 FORMAT(1X,'EVT OPTION 2: EVAPOTRANSPIRATION APPLIED TO ',
     & 'SPECIFIED LAYERS')
   67 FORMAT(1X,'EVT OPTION 3: ET RATES APPLIED TO ',
     & 'TOP ACTIVE LAYER IN EACH VERTICAL COLUMN')
C
C--ALLOCATE SPACE FOR THE ARRAYS EVTR, EXDP AND SURF.
      LCEVTR=ISUM
      ISUM=ISUM+NCR
      LCEXDP=ISUM
      ISUM=ISUM+NCR
      LCSURF=ISUM
      ISUM=ISUM+NCR
C
C--IF OPTION 2 THEN ALLOCATE SPACE FOR THE INDICATOR ARRAY(IEVT)
      LCIEVT=ISUM
      IF(NEVTOP.EQ.2) ISUM=ISUM+NCR
C
C     ------------------------------------------------------------------
 1500 IF(INGHB.EQ.0) THEN
          MXGHB=1
          LCGHB=ISUM
          GOTO 1600
      ENDIF
      FINDEX='GHB Package Input File: '
      CALL OPENFL(INGHB,3,1,FLNAME,0,FINDEX)                            !v4.6
C
C--READ MAX NUMBER OF GHB CELLS
      READ(INGHB,'(I10)') MXGHB
      WRITE(IOUT,75) MXGHB
   75 FORMAT(1X,'MAXIMUM NUMBER OF GHB CELLS =',I10)
C
C--ALLOCATE SPACE IN THE Y ARRAY
      LCGHB=ISUM
      ISUM=ISUM+5*MXGHB                                                 !v4.6
C
C     ------------------------------------------------------------------
 1600  CONTINUE
C
C     ---------------------------------------------------------------
C--READ PARTICLE NUMBER AND OPTION FLAGS
      IOPSS=1
      INIPOS=1
      NFRONT=0
      INCAPT=0
      itime=0                                                           !v4.6
c
c  v4.6 start
c-----------------------------------------------------------------------
c--Add new field in Record 1:  ITIME
c                              ITIME=0  no transient releases are specified
c                              ITIME<0  particle is released in specified stress period
c                              ITIME>0  particle is released at specified time
c
c--to ensure backward compatibility, check if ITIME is specified in Record 1
      read(intrk,'(a70)') tmpstr
      backspace(intrk)
      if (len(trim(tmpstr)) .gt. 60) then
          read(intrk,'(7I10)') ncount,ntrkop,
     +             nfront,inipos, iopss, incapt, itime
      else
          READ(INTRK,'(6I10)',ERR=1601) NCOUNT,NTRKOP,NFRONT,INIPOS,
     +             IOPSS,INCAPT
      end if
c-----------------------------------------------------------------------
c v4.6K end
c
 1601 IF(IOPSS.LT.1.OR.IOPSS.GT.4) IOPSS=1
      IF(INIPOS.LT.1.OR.INIPOS.GT.3) INIPOS=1
C
      WRITE(IOUT,1602) NCOUNT
 1602 FORMAT(1X,'MAXIMUM NUMBER OF PARTICLES ALLOWED =',I10)
      IF(NTRKOP.GT.0) THEN
	FLNAME='P3DPLOT.DAT'
      CALL OPENFL(INPLOT,3,0,FLNAME,1,FINDEX)                           !v4.6
	WRITE(IOUT,1603) INPLOT
      ENDIF
      IF(NFRONT.GT.0) THEN
	FLNAME='P3DFRONT.DAT'
      CALL OPENFL(IFRONT,3,0,FLNAME,1,FINDEX)                           !v4.6
	WRITE(IOUT,1604) IFRONT
      ENDIF
      IF(INCAPT.GT.0) THEN
	FLNAME='P3DCAPT.DAT'
      CALL OPENFL(ICAPT,3,0,FLNAME,1,FINDEX)                            !v4.6
	WRITE(IOUT,1610) ICAPT
      ENDIF
c v4.6     IF(NFRONT.GT.NFMAX) THEN
c v4.6     WRITE(IOUT,1605) NFMAX
c v4.6     STOP
c v4.6     ENDIF
      IF(INIPOS.EQ.1) THEN
	WRITE(IOUT,1606)
      ELSEIF(INIPOS.EQ.2) THEN
	WRITE(IOUT,1607)
      ENDIF
      IF(IOPSS.EQ.1) THEN
	WRITE(IOUT,1608)
      ELSEIF(IOPSS.EQ.2) THEN
	WRITE(IOUT,1609)
      ENDIF
 1603 FORMAT(1X,'FILE [P3DPLOT.DAT]  SAVED IN UNIT',I3,
     & ' FOR PLOTTING PATH LINES')
 1663 FORMAT(1X,'    NP       X             Y             Z',
     & '           TIME         J    I    K')
 1604 FORMAT(1X,'FILE [P3DFRONT.DAT] SAVED IN UNIT',I3,
     & ' FOR PLOTTING FRONT POSITIONS')
c1605 FORMAT(1X,'MAXIMUM NUMBER OF TIMES AT WHICH FRONT POSITIONS ARE ',!v4.6  del NFMAX
c     & 'SAVED IS',I5                                                   !v4.6
c     & /1X,'***** [NFMAX] MUST BE DIMENSIONED LARGER *****')           !v4.6
 1606 FORMAT(1X,'INITIAL PARTICLE POSITIONS ARE ENTERED IN ',
     & 'X, Y, Z COORDINATES')
 1607 FORMAT(1X,'INITIAL PARTICLE POSITIONS ARE ENTERED IN ',
     & 'J, I, K CELL INDICES')
 1608 FORMAT(1X,'PARTICLE REMOVAL OPTION [1] IS SELECTED')
 1609 FORMAT(1X,'PARTICLE REMOVAL OPTION [2] IS SELECTED')
 1610 FORMAT(1X,'FILE [P3DCAPT.DAT]  SAVED IN UNIT',I3,
     & ' WITH FINAL & INITIAL POSITIONS OF CAPTURED PARTICLES')
C
C--ALLOCATE SPACE FOR ARRAY PP AND NREMOV
      LCQX=ISUM
      ISUM=ISUM+NODEQX
      LCQY=ISUM
      ISUM=ISUM+NODEQY
      LCQZ=ISUM
      ISUM=ISUM+NODEQZ
      LCPP=ISUM
      ISUM=ISUM+3*NCOUNT
      LCPI=ISUM
      ISUM=ISUM+3*NCOUNT
C
      RETURN
      END
C
C
      SUBROUTINE GETDAT(INBAS,INBCF,INTRK,IOUT,NCOL,NROW,NLAY,IBOUND,
     & H,ISS,DELR,DELC,XBC,YBC,ZBC,TRPY,HY,VCON,HTOP,DZ,PRSITY,XMAX,
     & YMAX,ZMAX,NCOUNT,TIME1,TIME2,EPS,DT,MAXSTP,ISAV,IPRT,PP,PI,
     & NFRONT,IFRONT,TFRONT,NTRKOP,INIPOS,INPLOT,ICNFG,ICAPT,
     & INCAPT,HNOFLO,itime,nsp,ptime)                                   !v4.6
C ********************************************************************
C THIS SUBROUTINE READS AND PREPARES INPUT DATA REGARDING AQUIFER
C PROPERTIES AND PARTICLE TRACKING PARAMETERS.
C ********************************************************************
C V3.50: Tue  10-01-1992
C
      CHARACTER*24 ANAME(16),FLNAME*50,FINDEX*30
      DIMENSION IBOUND(NCOL,NROW,NLAY),H(NCOL,NROW,NLAY),
     & DELR(NCOL),DELC(NROW),HY(NCOL,NROW,NLAY),TRPY(NLAY),
     & VCON(NCOL,NROW,NLAY),HTOP(NCOL,NROW),DZ(NCOL,NROW,NLAY),
     & PRSITY(NCOL,NROW,NLAY),XBC(NCOL),YBC(NROW),PP(3,NCOUNT),
     & PI(3,NCOUNT),ZBC(NCOL,NROW,NLAY),TFRONT(NFRONT),nsp(ncount,2),   !v4.6
     + ptime(ncount,2)                                                  !v4.6
      COMMON /LC/LAYCON(80)
      COMMON /CONST/ROERR,TINY,IOPSS,SAFETY
      COMMON /DRY/HDRY,IWDFLG
C
C--ASSIGN NAMES TO CHARACTER ARRAY ANAME
      ANAME(1) ='WIDTH ALONG ROWS (DELR) '
      ANAME(2) ='WIDTH ALONG COL. (DELC) '
      ANAME(3) ='VERT. HYD. COND./THICK. '
      ANAME(4) ='BOUNDARY ARRAY (IBOUND) '
      ANAME(5) ='HY. COND. ALONG ROW (Kx)'
      ANAME(6) ='ANISOTROPY RATIO (Ky/Kx)'
      ANAME(7) ='STARTING HYDRAULIC HEADS'
      ANAME(8) ='TRANS. ALONG ROWS (Tx)  '
      ANAME(9) ='CELL THICKNESS (DZ)'
      ANAME(10)='TOP ELEV. OF 1ST LAYER  '
      ANAME(11)='POROSITY*RETARD. FACTOR '
      ANAME(12)='SC1 (NOT USED BY PATH3D)'
      ANAME(13)='SC2 (NOT USED BY PATH3D)'
      ANAME(14)='TOP (NOT USED BY PATH3D)'
      ANAME(15)='BOT (NOT USED BY PATH3D)'
      ANAME(16)='WETDRY ARRAY (NOT USED)'
C
C ---------------------------------------------------
C READ DATA FROM INPUT FILE FOR MODFLOW (BAS) PACKAGE
C ---------------------------------------------------
C
C--READ BOUNDARY ARRAY(IBOUND) ONE LAYER AT A TIME
      DO 21 K=1,NLAY
      CALL IARRAY(IBOUND(1,1,K),ANAME(4),NROW,NCOL,K,INBAS,IOUT)
   21 CONTINUE
C
C--READ HNOFLO (NOT USED)
      READ(INBAS,'(F10.0)')HNOFLO
      WRITE(IOUT,41) HNOFLO
   41 FORMAT(1X,'HEAD AT INACTIVE CELLS =',G15.7)
C
C--READ IN STARTING HEADS ONE LAYER AT A TIME
      DO 45 K=1,NLAY
      CALL RARRAY(H(1,1,K),ANAME(7),NROW,NCOL,K,INBAS,IOUT)
   45 CONTINUE
C
C ---------------------------------------------------
C READ DATA FROM INPUT FILE FOR MODFLOW (BCF) PACKAGE
C ---------------------------------------------------
C
C--READ AND PRINT LAYER TYPE CODES
      IF(NLAY.GT.80) THEN
	WRITE(IOUT,46)
   46   FORMAT(1X,'YOU HAVE SPECIFIED MORE THAN 80 MODEL LAYERS',
     &        /1X,'ARRAY LAYCON IS DIMENSIONED FOR A MAXIMUM OF 80')
	STOP
      ENDIF
      READ(INBCF,'(40I2)') (LAYCON(K),K=1,NLAY)
      WRITE(IOUT,48)
      DO 47 K=1,NLAY
      WRITE(IOUT,49) K,LAYCON(K)
   47 CONTINUE
   48 FORMAT(1X,'LAYER NUMBER  AQUIFER TYPE',
     &      /1X,'------------  ------------')
   49 FORMAT(1X,4X,I3,10X,I3)
C
C--READ ANISOTROPY RATIO Ky/Kx ONE VALUE FOR ONE LAYER
      CALL RARRAY(TRPY(1),ANAME(6),1,NLAY,0,INBCF,IOUT)
C
C--READ IN ARRAYS DELR AND DELC
      CALL RARRAY(DELR(1),ANAME(1),1,NCOL,0,INBCF,IOUT)
      CALL RARRAY(DELC(1),ANAME(2),1,NROW,0,INBCF,IOUT)
C
C--SELECT PARAMETERS NEEDED FOR PARTICLE TRACKING
      DO 200 K=1,NLAY
C
C--IGNORE PRIMARY STORAGE COEFFICIENT ARRAY (SC1) IF TRANSIENT
C--ARRAY HTOP IS USED TO STORE SC1 TEMPORARILY
      IF(ISS.EQ.0) THEN
	CALL RARRAY(HTOP,ANAME(12),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
C--COPY TRANSMISSIVITY INTO ARRAY HY IF LAYER TYPE IS 0 OR 2.
C--TRANSFER TRANSMISSIVITY INTO HYDRAULIC CONDUCTIVITY LATER
      IF(LAYCON(K).EQ.0 .OR. LAYCON(K).EQ.2) THEN
	CALL RARRAY(HY(1,1,K),ANAME(8),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
C--READ HYDRAULIC CONDUCTIVITY AND IGNORE BOTTOM ELEVATION (BOT)
C--IF LAYER TYPE IS 1 OR 3
      IF(LAYCON(K).EQ.1 .OR. LAYCON(K).EQ.3) THEN
	CALL RARRAY(HY(1,1,K),ANAME(5),NROW,NCOL,K,INBCF,IOUT)
	CALL RARRAY(HTOP,ANAME(15),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
C--READ VERTICAL HY. COND./THICK (VCON) IF NOT BOTTOM LAYER.
      IF(K.NE.NLAY) THEN
	CALL RARRAY(VCON(1,1,K),ANAME(3),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
C--IGNORE SECONDARY STORAGE COEFFICIENT (SC2)
C--IF FLOW FIELD IS TRANSIENT AND LAYER TYPE IS 2 OR 3
      IF( (LAYCON(K).EQ.3 .OR. LAYCON(K).EQ.2) .AND. ISS.EQ.0 ) THEN
	CALL RARRAY(HTOP,ANAME(13),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
C--IGNORE TOP ARRAY IF LAYER TYPE IS 2 OR 3
      IF(LAYCON(K).EQ.2 .OR. LAYCON(K).EQ.3) THEN
	CALL RARRAY(HTOP,ANAME(14),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
C--IGNORE WETDRY ARRAY
      IF(IWDFLG.NE.0.AND.(LAYCON(K).EQ.1.OR.LAYCON(K).EQ.3)) THEN
	CALL RARRAY(HTOP,ANAME(16),NROW,NCOL,K,INBCF,IOUT)
      ENDIF
C
  200 CONTINUE
C
C--READ THE TOP ELEVATION OF EACH CELL IN THE FIRST LAYER
C--AND THE THICKNESS OF ALL CELLS
      CALL RARRAY(HTOP(1,1),ANAME(10),NROW,NCOL,1,INBCF,IOUT)
      DO 250 K=1,NLAY
      CALL RARRAY(DZ(1,1,K),ANAME(9),NROW,NCOL,K,INBCF,IOUT)
  250 CONTINUE
C
C--READ POROSITY VALUES ONE LAYER AT A TIME
      DO 260 K=1,NLAY
      CALL RARRAY(PRSITY(1,1,K),ANAME(11),NROW,NCOL,K,INBCF,IOUT)
  260 CONTINUE
C
C--CLOSE BCF INPUT FILE
      CLOSE (INBCF)
C
C--CONVERT TRANSIMISIVITY TO HYDRAULIC CONDUCTIVITY
C--IF LAYER TYPE IS 0 OR 2.
      DO255 K=1,NLAY
      IF(LAYCON(K).EQ.0.OR.LAYCON(K).EQ.2) THEN
	DO251 I=1,NROW
	DO252 J=1,NCOL
	IF(IBOUND(J,I,K).EQ.0) GOTO 252
	IF(DZ(J,I,K).EQ.0.) THEN
	  HY(J,I,K)=0
	ELSE
	  HY(J,I,K)=HY(J,I,K)/DZ(J,I,K)
	ENDIF
  252   CONTINUE
  251   CONTINUE
      ENDIF
  255 CONTINUE
C
C--MAKE SURE IBOUND = 0 IF K =0 IN ALL DIRECTIONS
      HCNV=888.88
      DO 400 K=1,NLAY
      DO 401 I=1,NROW
      DO 402 J=1,NCOL
      IF(IBOUND(J,I,K).EQ.0) GOTO 402
      IF(HY(J,I,K).NE.0.) GOTO 402
      IF(K.EQ.NLAY) GOTO 410
      IF(VCON(J,I,K).NE.0.) GOTO 402
  410 IF(K.EQ.1) GOTO 411
      IF(VCON(J,I,K-1).NE.0.) GOTO 402
  411 IBOUND(J,I,K)=0
      H(J,I,K)=HCNV
  402 CONTINUE
  401 CONTINUE
  400 CONTINUE
C
C--CALCULATE COORDINATE ARRAYS XBC, YBC AND ZBC
C--AND MAXIMUN WIDTHS ALONG ROWS, COLUMNS AND LAYERS
      XBC(1)=DELR(1)/2.
      YBC(1)=DELC(1)/2.
      DO261 J=2,NCOL
      XBC(J)=XBC(J-1)+(DELR(J-1)+DELR(J))/2.
  261 CONTINUE
      DO263 I=2,NROW
      YBC(I)=YBC(I-1)+(DELC(I-1)+DELC(I))/2.
  263 CONTINUE
      XMAX=XBC(NCOL)+DELR(NCOL)/2.
      YMAX=YBC(NROW)+DELC(NROW)/2.
      ZMAX=0
      DO265 I=1,NROW
      DO266 J=1,NCOL
      ZBC(J,I,1)=DZ(J,I,1)/2.+(HTOP(1,1)-HTOP(J,I))
      ZZ=DZ(J,I,1)
      DO267 K=2,NLAY
      ZBC(J,I,K)=ZBC(J,I,K-1)+(DZ(J,I,K-1)+DZ(J,I,K))/2.
      ZZ=ZZ+DZ(J,I,K)
  267 CONTINUE
      ZMAX=MAX(ZMAX,ZZ)
  266 CONTINUE
  265 CONTINUE
C
C--WRITE COORDINATE TRANSFORMATION INFORMATION
C--TO "P3DPLOT.DAT", "P3DFRONT.DAT", AND "P3DCAPT.DAT"
      XTRANS=0
      YTRANS=YBC(NROW)+0.5*DELC(NROW)
      ZTRANS=HTOP(1,1)
      IF(NTRKOP.GT.0)
     & WRITE(INPLOT,270) NCOL,NROW,NLAY,XTRANS,YTRANS,ZTRANS
      IF(NFRONT.GT.0)
     & WRITE(IFRONT,270) NCOL,NROW,NLAY,XTRANS,YTRANS,ZTRANS
      IF(INCAPT.GT.0)
     & WRITE(ICAPT,270) NCOL,NROW,NLAY,XTRANS,YTRANS,ZTRANS
  270 FORMAT(1X,I6,1X,I6,1X,I5,4X,
     & '''+''',1X,G13.6,4X,'''-''',1X,G13.6,4X,'''-''',1X,G13.6)
C
C--WRITE GRID SPATIAL DISCRETIZATION DATA TO "P3DCNFG.DAT"
      IF(ICNFG.GT.0) THEN
	FLNAME='P3DCNFG.DAT'
	FINDEX=' '
      CALL OPENFL(ICNFG,3,0,FLNAME,1,FINDEX)                            !v4.6
	WRITE(ICNFG,*) NLAY,NROW,NCOL
	WRITE(ICNFG,*) (DELR(J),J=1,NCOL)
	WRITE(ICNFG,*) (DELC(I),I=1,NROW)
	WRITE(ICNFG,*) ((HTOP(J,I),J=1,NCOL),I=1,NROW)
	WRITE(ICNFG,*) (((DZ(J,I,K),J=1,NCOL),I=1,NROW),K=1,NLAY)
	WRITE(ICNFG,*) HNOFLO
	CLOSE (ICNFG)
      ENDIF
C
C ---------------------------------------------
C READ DATA FROM PARTICLE TRACKING INPUT FILE
C ---------------------------------------------
C
C--READ AND PRINT TRACKING CONTROL RECORD
      READ(INTRK,300) TIME1,TIME2,EPS,DT,MAXSTP,ISAV,IPRT
  300 FORMAT(4F10.0,3I10)
      WRITE(IOUT,301) TIME1,TIME2,EPS,DT,MAXSTP,ISAV,IPRT
  301 FORMAT(//17X,'TRACKING START TIME (TIME1) = ',G15.7,
     &        /17X,'TRACKING END TIME (TIME2) = ',G15.7,
     &        /17X,'ERROR CRITERION (EPS) = ',G15.7,
     &        /17X,'INITIAL TRACKING STEPSIZE = ',G15.7,
     &        /17X,'MAXIMUM TRACKING STEPS ALLOWED = ',I10,
     &        /17X,'INTERVAL FOR SAVING INTERMEDIATE RESULTS = ',I3,
     &        /17X,'OPTION FOR PRINTING INTERMEDIATE RESULTS = ',I3)
C
C--READ AND ECHO TIMES AT WHICH FRONT POSITIONS ARE SAVED
      IF(NFRONT.LE.0) GOTO 379
C
      READ(INTRK,310) (TFRONT(I),I=1,NFRONT)
      WRITE(IOUT,312) (TFRONT(I),I=1,NFRONT)
  310 FORMAT(8F10.0)
  312 FORMAT(1X,'FRONT POSITIONS ARE SAVED AT THE FOLLOWING TIMES:'
     & /1X,5G15.7)
C
C--MAKE SURE ELEMENTS IN ARRAY [TFRONT] ARE MONOTONIC
C--AND WITHIN LIMIT OF TRACKING TIME INTERVAL
      DO 322 I=1,NFRONT-1
	DO 324 II=I+1,NFRONT
	  IF(TIME2.GT.TIME1.AND.TFRONT(I).GT.TFRONT(II) .OR.
     &      TIME2.LT.TIME1.AND.TFRONT(I).LT.TFRONT(II)) THEN
	    TEMP=TFRONT(I)
	    TFRONT(I)=TFRONT(II)
	    TFRONT(II)=TEMP
	  ENDIF
  324   CONTINUE
  322 CONTINUE
      NDEL=0
      NCHK=1
 325  IF(NCHK.LT.NFRONT.AND.TFRONT(NCHK).EQ.TFRONT(NCHK+1).OR.
     &  TIME2.GT.TIME1.AND.
     &  (TFRONT(NCHK).LT.TIME1.OR.TFRONT(NCHK).GT.TIME2).OR.
     &  TIME2.LT.TIME1.AND.
     &  (TFRONT(NCHK).GT.TIME1.OR.TFRONT(NCHK).LT.TIME2)) THEN
	NDEL=NDEL+1
	DO 326 II=NCHK,NFRONT-NDEL
	  TFRONT(II)=TFRONT(II+1)
 326    CONTINUE
	TFRONT(NFRONT-NDEL+1)=0
      ELSE
	NCHK=NCHK+1
      ENDIF
      IF(NCHK+NDEL.LE.NFRONT) GOTO 325
      NFRONT=NFRONT-NDEL
C
C--CHECK AND MAKE SURE INPUT VALUES ARE VALID.
C--IF NOT, USE DEFAULTS OR STOP
  379 IF(IPRT.NE.1.AND.IPRT.NE.2.AND.IPRT.NE.3) THEN
	WRITE(IOUT,380)
  380   FORMAT(/1X,'PRINTING OPTION (IPRT) MUST BE EITHER 1, 2 OR 3',
     &         /1X,'DEFAULT VALUE EQUAL TO 1 IS USED')
	IPRT=1
      ENDIF
      IF(MAXSTP.LE.0) THEN
	WRITE(IOUT,382)
  382   FORMAT(/1X,'MAXIMUM TRACKING STEPS (MAXSTP) MUST BE POSITIVE',
     &         /1X,'DEFAULT VALUE EQUAL TO 100 IS USED')
	MAXSTP=100
      ENDIF
      IF(ISAV.LT.0) THEN
	WRITE(IOUT,384)
  384   FORMAT(/1X,'INTERVAL FOR SAVING RESULTS (ISAV) ',
     &             'MUST BE GREATER OR EQUAL TO ZERO',
     &         /1X,'DEFAULT VALUE EQUAL TO ZERO IS USED')
	ISAV=0
      ENDIF
      IF(DT.EQ.0) THEN
	WRITE(IOUT,386)
  386   FORMAT(/1X,'INITIAL TRACKING STEPSIZE (DT) ',
     &             'CANNOT BE EQUAL TO ZERO',
     &         /1X,'DEFAULT VALUE EQUAL TO 1 IS USED')
	DT=1
      ENDIF
      IF(EPS.LE.0) THEN
	WRITE(IOUT,388)
  388   FORMAT(/1X,'ERROR CRITERION (EPS) MUST BE GREATER THAN ZERO',
     &         /1X,'DEFAULT VALUE EQUAL TO 1E-3 IS USED')
	EPS=1.E-3
      ENDIF
c v4.6 -- disable this check to allow transient reverse tracking
c         will need to have another check to ensure that forward and
c         reverse tracking are not mixed
c
c      IF(ISS.EQ.0) THEN                                                !v4.6
c          IF(TIME2.LT.TIME1) THEN                                      !v4.6
c              WRITE(IOUT,390)                                          !v4.6
c  390         FORMAT(/1X,'TIME2 MUST BE GREATER THAN TIME1 ',          !v4.6
c     &               'IN TRANSIENT SIMULATION')                        !v4.6
c              STOP                                                     !v4.6
c          ELSEIF(TIME1*TIME2.LT.0) THEN                                !v4.6
c              WRITE(IOUT,392)                                          !v4.6
c  392         FORMAT(/1X,'TIME1 AND TIME2 MUST BE POSITIVE ',          !v4.6
c     &               'IN TRANSIENT SIMULATION')                        !v4.6
c          STOP                                                         !v4.6
c          ENDIF                                                        !v4.6
c      ENDIF                                                            !v4.6
C
C--INITIAL PARTICLE POSITIONS ENTERED AS X,Y,Z COORDINATES
  320 IF(INIPOS.GE.2) GOTO 600                                          !v4.6
      NP=1
 351  if(itime.eq.0) then                                               !v4.6
          READ(INTRK,FMT=352,END=490) XP,YP,ZP
      elseif(itime.gt.0) then                                           !v4.6
          read(intrk,fmt=353,end=490) xp,yp,zp,ptime(np,1),ptime(np,2)  !v4.6
      else                                                              !v4.6
          read(intrk,fmt=354,end=490) xp,yp,zp,nsp(np,1),nsp(np,2)      !v4.6
      end if                                                            !v4.6
      IF(NP.GT.NCOUNT) GOTO 490
      PP(1,NP)=XP
      PP(2,NP)=YP
      PP(3,NP)=ZP
  352 FORMAT(3F10.0)
  353 format(5f10.0)                                                    !v4.6
  354 format(3f10.0,2i10)                                               !v4.6
      NP=NP+1
      GOTO 351
C
  490 IF(NP-1.GT.NCOUNT) THEN
	WRITE(IOUT,492) NCOUNT
	STOP
      ELSE
	NCOUNT=NP-1
      ENDIF
  492 FORMAT(1X,'MAXIMUM NUMBER OF PARTICLED ALLOWED IS',I10
     & /1X,'PLEASE INCREASE [NCOUNT] IN THE INPUT FILE')
      GOTO 500
C
C--INITIAL PARTICLE POSITIONS ENTERED AS J,I,K CELL INDICES
  600 if(inipos.eq.3) goto 700                                          !v4.6
      NP=0
      ISEED=-1
      ZFAC=0.5
  601 if(itime.eq.0) then                                               !v4.6
          READ(INTRK,610,END=650) JJ,II,KK,NPCELL,koption
      elseif(itime.gt.0) then                                           !v4.6
          read(intrk,fmt=611,end=650) jj,ii,kk,npcell,koption,          !v4.6
     +            ptime1,ptime2                                         !v4.6
      else                                                              !v4.6
          read(intrk,fmt=612,end=650) jj,ii,kk,npcell,koption,          !v4.6
     +    nsp1,nsp2                                                     !v4.6
      endif                                                             !v4.6

      if(jj.gt.ncol) then
          jj=ncol
      elseif(jj.lt.1) then
          jj=1
      endif
      if(ii.gt.nrow) then
          ii=nrow
      elseif(ii.lt.1) then
          ii=1
      endif
      if(kk.gt.nlay) then
          kk=nlay
      elseif(kk.lt.1) then
          kk=1
      endif

      if(koption.eq.10001) then                                         !v4.6
          zfac=0.10                                                     !v4.6
      elseif(koption.eq.10002.or.koption.eq.0) then                     !v4.6
          zfac=0.5                                                      !v4.6
      elseif(koption.eq.10003) then                                     !v4.6
          zfac=0.90                                                     !v4.6
      endif                                                             !v4.6

  610 FORMAT(5I10)
  611 format(5i10,2f10.0)                                               !v4.6
  612 format(7i10)                                                      !v4.6
      IF(NPCELL.EQ.0) NPCELL=1
      npold=np
      IF(NPCELL.GE.1) THEN
          CALL GENPTC(NCOL,NROW,NLAY,NCOUNT,NP,JJ,II,KK,
     &  PP,DELR,DELC,DZ,XBC,YBC,ZBC,NPCELL,ZFAC,ptime1,ptime2,nsp1,nsp2)!v4.6
          IF(NP.GT.NCOUNT) GOTO 650
          if (itime.ne.0) then                                          !v4.6
              do n=npold+1,np                                           !v4.6
                  ptime(n,1)=ptime1                                     !v4.6
                  ptime(n,2)=ptime2                                     !v4.6
                  nsp(n,1)=nsp1                                         !v4.6
                  nsp(n,2)=nsp2                                         !v4.6
              end do                                                    !v4.6
          endif                                                         !v4.6
      ELSE if (npcell .lt. 0) then                                      !v4.6
          NPCELL=-NPCELL
          CALL GENPTR(NCOL,NROW,NLAY,NCOUNT,NP,JJ,II,KK,
     & PP,DELR,DELC,DZ,XBC,YBC,ZBC,NPCELL,ISEED,ptime1,ptime2,nsp1,nsp2)!v4.6
          IF(NP.GT.NCOUNT) GOTO 650
          if (itime.ne.0) then                                          !v4.6
              do n=npold+1,np                                           !v4.6
                  ptime(n,1)=ptime1                                     !v4.6
                  ptime(n,2)=ptime2                                     !v4.6
                  nsp(n,1)=nsp1                                         !v4.6
                  nsp(n,2)=nsp2                                         !v4.6
              end do                                                    !v4.6
          endif                                                         !v4.6
      else                                                              !v4.6
          np=np+1                                                       !v4.6
          if (itime .gt. 0) then                                        !v4.6
              ptime(np,1)=ptime1                                        !v4.6
              ptime(np,2)=ptime2                                        !v4.6
          else if (itime .lt. 0) then                                   !v4.6
              nsp(np,1)=nsp1                                            !v4.6
              nsp(np,2)=nsp2                                            !v4.6
          end if                                                        !v4.6
      ENDIF
      GOTO 601
  650 IF(NP.GT.NCOUNT) THEN
          WRITE(IOUT,492) NCOUNT
          STOP
      ELSE
          NCOUNT=NP
      ENDIF
      goto 500                                                          !v4.6
C--INITIAL PARTICLE POSITIONS ENTERED AS X,Y,K                          !v4.6
c  v4.6 expanded options for specifying initial particle locations
  700 NP=0
      ISEED=-1
      ZFAC=0.5
  701 if(itime.eq.0) then                                               !v4.6
          READ(INTRK,710,END=750) xp,yp,kk,koption
      elseif(itime.gt.0) then                                           !v4.6
          read(intrk,fmt=711,end=750) xp,yp,kk,koption,                 !v4.6
     +    ptime1,ptime2                                                 !v4.6
      else                                                              !v4.6
          read(intrk,fmt=712,end=750) xp,yp,kk,koption,                 !v4.6
     +    nsp1,nsp2                                                     !v4.6
      end if                                                            !v4.6

      if(kk.gt.nlay) then
	kk=nlay
      elseif(kk.lt.1) then
	kk=1
      endif

      if(koption.eq.10001) then
          zfac=0.01
      elseif(koption.eq.10002.or.koption.eq.0) then
          zfac=0.5
      elseif(koption.eq.10003) then
          zfac=0.99
      endif
  710 FORMAT(2f10.0,2I10)
  711 format(2f10.0,2i10,2f10.0)                                        !v4.6
  712 format(2f10.0,4i10)                                               !v4.6
      np=np+1                                                           !v4.6
      IF(NP.GT.NCOUNT) GOTO 650
      PP(1,NP)=XP
      PP(2,NP)=YP
c    PP(3,NP+1)=ZBC(JJ,II,KK)-0.5*DZ(JJ,II,KK)+ZFAC*DZ(JJ,II,KK)        !problem to resolve here
      PP(3,NP)=ZP
      print*,np,zp
      if(itime .gt. 0) then                                             !v4.6
          ptime(np,1)=ptime1                                            !v4.6
          ptime(np,2)=ptime2                                            !v4.6
      else if (itime .lt. 0) then                                       !v4.6
          nsp(np,1)=nsp1                                                !v4.6
          nsp(np,2)=nsp2                                                !v4.6
      end if                                                            !v4.6
      GOTO 701
  750 IF(NP.GT.NCOUNT) THEN
        WRITE(IOUT,492) NCOUNT
        STOP
      ELSE
        NCOUNT=NP
      ENDIF
C
C--PRINT AND SAVE PARTICLE STARTING POSITIONS

c  v4.6  -should alter this code to output starting time/stress period


  500 WRITE(IOUT,505)
  505 FORMAT(/17X,'          PARTICLE STARTING POSITIONS         ',
     &       /17X,'PARTICLE NO.      X           Y           Z     ')
C
      DO 530 N=1,NCOUNT
	WRITE(IOUT,554) N,(PP(I,N),I=1,3)
	PI(1,N)=PP(1,N)
	PI(2,N)=PP(2,N)
	PI(3,N)=PP(3,N)
  530 CONTINUE
  554 FORMAT(17X,I8,6X,3G11.5)
C
      RETURN
      END
C
C
      SUBROUTINE GETSS(IOUT,NCOL,NROW,MXWEL,NWELLS,WELL,
     & MXDRN,NDRAIN,DRAIN,MXRIV,NRIVER,RIVER,MXSTR,NSTREM,STREAM,
     & MXGHB,NBOUND,GHBND,NRCHOP,IRCH,RECH,NEVTOP,IEVT,EVTR,EXDP,SURF)
C **********************************************************************
C THIS SUBROUTINE READS INPUT DATA RELATED TO SINKS OR SOURCES,
C INCLUDING WELLS, DRAINS, RIVERS, STREAM, RECHARGE, EVAPOTRANSPORATION,
C OR GENERAL-HEAD BOUNDARY IF THEY ARE PRESENT IN THE HEAD SOLUTION.
C **********************************************************************
C VER 3.10: 06-01-1992
C
      CHARACTER*24 ANAME(6)
      real Stage,Cond,tmp3                                              !v4.6
      integer tmp1,tmp2                                                 !v4.6
      DIMENSION WELL(4,MXWEL),DRAIN(5,MXDRN),RIVER(5,MXRIV),
     & STREAM(5,MXSTR),GHBND(5,MXGHB),RECH(NCOL,NROW),IRCH(NCOL,NROW),
     & IEVT(NCOL,NROW),EVTR(NCOL,NROW),EXDP(NCOL,NROW),
     & SURF(NCOL,NROW)
      COMMON /UNIT/INBCF,INWEL,INDRN,INRIV,INEVT,INGHB,INRCH,INSTR
      COMMON /STR/NSS,NTRIB,NDIV,ICALC
C
      ANAME(1)='RECHARGE RATES (RECH)'
      ANAME(2)='RECHARGE LAYER INDEX'
      ANAME(3)='ET SURFACE ELEVATION'
      ANAME(4)='EVAPOTRANSPIRATION RATES'
      ANAME(5)='ET EXTINCTION DEPTH'
      ANAME(6)='ET LAYER INDEX (IEVT)'
C
C--READ WELL LOCATIONS AND RATES FROM 'WEL' PACKAGE
C--------------------------------------------------
      IF(INWEL.EQ.0) THEN
	NWELLS=0
	GOTO 1
      ENDIF
      READ(INWEL,'(I10)') IWEL
      IF(IWEL.GE.0) THEN
	WRITE(IOUT,11) IWEL
      ELSE
	WRITE(IOUT,12)
      ENDIF
   11 FORMAT(/1X,'NUMBER OF WELLS IN CURRENT STRESS PERIOD =',I5,
     &       /1X,'WELL NO.   LAYER   ROW   COLUMN        Q')
   12 FORMAT(1X,'WELLS REUSED FROM LAST STRESS PERIOD')
      IF(IWEL.GE.0) THEN
	DO 20 I=1,IWEL
	READ(INWEL,'(3I10,F10.0)') KK,II,JJ,QQ
	  WELL(1,I)=KK
	  WELL(2,I)=II
	  WELL(3,I)=JJ
	  WELL(4,I)=QQ
	  WRITE(IOUT,31) I,KK,II,JJ,QQ
   20   CONTINUE
	NWELLS=IWEL
      ENDIF
   30 FORMAT(3I10)
   31 FORMAT(3X,I5,3X,I5,2X,I5,1X,I5,3X,G15.7)
C
C--READ DRAIN LOCATIONS FROM 'DRN' PACKAGE
C-----------------------------------------
    1 IF(INDRN.EQ.0) THEN
	NDRAIN=0
	GOTO 2
      ENDIF
      READ(INDRN,'(I10)') IDRN
      IF(IDRN.GE.0) THEN
	WRITE(IOUT,45) IDRN
      ELSE
	WRITE(IOUT,46)
      ENDIF
   45 FORMAT(/1X,'NUMBER OF DRAINS IN CURRENT STRESS PERIOD =',I5,
     &       /1X,'DRAIN NO.  LAYER   ROW   COLUMN')
   46 FORMAT(/1X,'DRAINS REUSED FROM LAST STRESS PERIOD')
      IF(IDRN.GE.0) THEN
	DO 40 I=1,IDRN
      READ(INDRN,'(3I10,2f10.0)') KK,II,JJ,Stage,Cond                   !v4.6
	  DRAIN(1,I)=KK
	  DRAIN(2,I)=II
	  DRAIN(3,I)=JJ
        DRAIN(4,I)=Stage                                                !v4.6
        DRAIN(5,I)=Cond                                                 !v4.6
	  WRITE(IOUT,41) I,KK,II,JJ
   40   CONTINUE
	NDRAIN=IDRN
      ENDIF
   41 FORMAT(3X,I5,3X,I5,2X,I5,1X,I5)
C
C--READ RIVER LOCATIONS FROM 'RIV' PACKAGE
C-----------------------------------------
    2 IF(INRIV.EQ.0) THEN
	NRIVER=0
	GOTO 22
      ENDIF
      READ(INRIV,'(I10)') IRIV
      IF(IRIV.GE.0) THEN
	WRITE(IOUT,55) IRIV
      ELSE
	WRITE(IOUT,56)
      ENDIF
   55 FORMAT(/1X,'NUMBER OF RIVER CELLS IN CURRENT STRESS PERIOD =',I5,
     &       /1X,'RIVER NO.  LAYER   ROW   COLUMN')
   56 FORMAT(/1X,'RIVERS REUSED FROM LAST STRESS PERIOD')
      IF(IRIV.GE.0) THEN
	DO 50 I=1,IRIV
        READ(INRIV,'(3I10,2f10.0)') KK,II,JJ,Stage,Cond                 !v4.6
	  RIVER(1,I)=KK
	  RIVER(2,I)=II
	  RIVER(3,I)=JJ
        RIVER(4,I)=Stage                                                !v4.6
        RIVER(5,I)=Cond                                                 !v4.6
	  WRITE(IOUT,51) I,KK,II,JJ
   50   CONTINUE
	NRIVER=IRIV
      ENDIF
   51 FORMAT(3X,I5,3X,I5,2X,I5,1X,I5)
C
C--READ STREAM LOCATIONS FROM 'STR' PACKAGE
C------------------------------------------
   22 IF(INSTR.EQ.0) THEN
	NSTREM=0
	GOTO 3
      ENDIF
      READ(INSTR,'(I10)') ISTR
      IF(ISTR.GE.0) THEN
	WRITE(IOUT,255) ISTR
      ELSE
	WRITE(IOUT,256)
      ENDIF
  255 FORMAT(/1X,'NUMBER OF STREAM CELLS IN CURRENT STRESS PERIOD =',I5,
     &       /1X,'STREAM NO.  LAYER   ROW   COLUMN')
  256 FORMAT(/1X,'STREAM REUSED FROM LAST STRESS PERIOD')
      IF(ISTR.GE.0) THEN
	DO 250 I=1,ISTR
          READ(INSTR,'(5I5,f15.0,2f10.0)') KK,II,JJ,tmp1,tmp2,tmp3,
     +          Stage,Cond                                              !v4.6
	  STREAM(1,I)=KK
	  STREAM(2,I)=II
	  STREAM(3,I)=JJ
        STREAM(4,I)=Stage                                               !v4.6
        STREAM(5,I)=Cond                                                !v4.6
	  WRITE(IOUT,251) I,KK,II,JJ
  250   CONTINUE
	NSTREM=ISTR
	IF(ICALC.GT.0) THEN
	  DO 252 N=1,ISTR
	    READ(INSTR,'(F10.0)') DUMMY
  252     CONTINUE
	ENDIF
	IF(NTRIB.GT.0) THEN
	  DO 253 N=1,NSS
	    READ(INSTR,'(I5)') IGNORE
  253     CONTINUE
	ENDIF
	IF(NDIV.GT.0) THEN
	  DO 254 N=1,NSS
	    READ(INSTR,'(I10)') IGNORE
  254     CONTINUE
	ENDIF
      ENDIF
  251 FORMAT(3X,I5,3X,I5,2X,I5,1X,I5)
C
C--READ GENERAL-HEAD-BOUNDARY LOCATIONS FROM 'GHB' PACKAGE
C---------------------------------------------------------
    3 IF(INGHB.EQ.0) THEN
	NBOUND=0
	GOTO 4
      ENDIF
      READ(INGHB,'(I10)') IGHB
      IF(IGHB.GE.0) THEN
	WRITE(IOUT,65) IGHB
      ELSE
	WRITE(IOUT,66)
      ENDIF
   65 FORMAT(/1X,'NUMBER OF GHB CELLS IN CURRENT STRESS PERIOD =',I5,
     &       /1X,'G-H-B NO.  LAYER   ROW   COLUMN')
   66 FORMAT(1X,'GHB CELLS REUSED FROM LAST STRESS PERIOD')
      IF(IGHB.GE.0) THEN
	DO 60 I=1,IGHB
        READ(INGHB,'(3I10,2f10.0)') KK,II,JJ,Stage,Cond                 !v4.6
	  GHBND(1,I)=KK
	  GHBND(2,I)=II
	  GHBND(3,I)=JJ
        GHBND(4,I)=Stage                                                !v4.6
        GHBND(5,I)=Cond                                                 !v4.6
	  WRITE(IOUT,61) I,KK,II,JJ
   60   CONTINUE
	NBOUND=IGHB
      ENDIF
   61 FORMAT(3X,I5,3X,I5,2X,I5,1X,I5)
C
C--READ RECHARGE INFO AND RATES FROM 'RCH' PACKAGE
C-------------------------------------------------
    4 IF(INRCH.EQ.0) GOTO 5
      READ(INRCH,70) INRECH,INIRCH
   70 FORMAT(2I10)
      WRITE(IOUT,*)
C
C--IF INRECH=>0 THEN CALL RARRAY TO READ RECHARGE RATES
      IF(INRECH.GE.0) THEN
	CALL RARRAY(RECH,ANAME(1),NROW,NCOL,0,INRCH,IOUT)
      ELSE
	WRITE(IOUT,75)
      ENDIF
   75 FORMAT(1X,'RECHARGE RATES REUSED FROM LAST STRESS PERIOD')
C
C--IF NRCHOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.
      IF(NRCHOP.EQ.2.AND.INIRCH.GE.0) THEN
	CALL IARRAY(IRCH,ANAME(2),NROW,NCOL,0,INRCH,IOUT)
      ELSEIF(NRCHOP.EQ.2.AND.INIRCH.LT.0) THEN
	WRITE(IOUT,76)
   76   FORMAT(1X,'LAYER INDEX REUSED FROM LAST STRESS PERIOD')
      ENDIF
C
C--READ ET INFORMATION FROM 'EVT' PACKAGE
C----------------------------------------
    5 IF(INEVT.EQ.0) GOTO 6
C
C--READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.
      READ(INEVT,80) INSURF,INEVTR,INEXDP,INIEVT
   80 FORMAT(4I10)
      WRITE(IOUT,*)
C
C--IF INSURF=>0 THEN CALL MODULE RARRAY TO READ SURFACE.
      IF(INSURF.GE.0) THEN
	CALL RARRAY(SURF,ANAME(3),NROW,NCOL,0,INEVT,IOUT)
      ELSE
	WRITE(IOUT,85)
      ENDIF
   85 FORMAT(1X,'ET SURFACE REUSED FROM LAST STRESS PERIOD')
C
      IF(INEVTR.GE.0) THEN
	CALL RARRAY(EVTR,ANAME(4),NROW,NCOL,0,INEVT,IOUT)
      ELSE
	WRITE(IOUT,86)
      ENDIF
   86 FORMAT(1X,'ET RATES REUSED FROM LAST STRESS PERIOD')
C
C---IF INEXDP=>0 CALL MODULE RARRAY TO READ EXTINCTION DEPTH
      IF(INEXDP.GE.0) THEN
	CALL RARRAY(EXDP,ANAME(5),NROW,NCOL,0,INEVT,IOUT)
      ELSE
	WRITE(IOUT,87)
      ENDIF
   87 FORMAT(1X,'ET EXDP REUSED FROM LAST STRESS PERIOD')
C
C--IF OPTION(NEVTOP) IS 2 THEN WE NEED AN INDICATOR ARRAY.
      IF(NEVTOP.EQ.2.AND.INIEVT.GE.0) THEN
	CALL IARRAY(IEVT,ANAME(6),NROW,NCOL,0,INEVT,IOUT)
      ELSEIF(NEVTOP.EQ.2.AND.INIEVT.LT.0) THEN
	WRITE(IOUT,88)
      ENDIF
   88 FORMAT(1X,'ET LAYER INDEX REUSED FROM LAST STRESS PERIOD')
C
C--RETURN
    6 RETURN
      END
C
C
      SUBROUTINE GENPTR(NCOL,NROW,NLAY,MXPART,NCOUNT,JJ,II,KK,
     & PP,DELR,DELC,DZ,XBC,YBC,ZBC,NADD,ISEED)
C *****************************************************************
C THIS SUBROUTINE INSERTS [NADD] NEW PARTICLES AT CELL (JJ,II,KK)
C RANDOMLY INSIDE THE CELL BLOCK.
C *****************************************************************
C VER 3.00: Tue  06-25-1991
C
      DIMENSION PP(3,MXPART),DELR(NCOL),XBC(NCOL),
     & DELC(NROW),YBC(NROW),ZBC(NCOL,NROW,NLAY),DZ(NCOL,NROW,NLAY)
      EXTERNAL  RAN2
C
C--SAVE NUMBER OF PARTICLES BEFORE INSERTION
      NP=NCOUNT
C
C--RETURN IF NUMBER OF PARTICLES AFTER INSERTION WILL CAUSE
C--TOTAL NUMBER OF PARTICLES TO EXCEED PREDEFINED MAXIMUM.
      NCOUNT=NP+NADD
      IF(NCOUNT.GT.MXPART) RETURN
C
C--RANDOMLY INSERT NEW PARTICLES
      DO 20 N=NP+1,NCOUNT
	IF(NCOL.GT.1) THEN
	  PP(1,N)=XBC(JJ)+(RAN2(ISEED)-0.5)*DELR(JJ)
	ELSE
	  PP(1,N)=XBC(JJ)
	ENDIF
	IF(NROW.GT.1) THEN
	  PP(2,N)=YBC(II)+(RAN2(ISEED)-0.5)*DELC(II)
	ELSE
	  PP(2,N)=YBC(II)
	ENDIF
	IF(NLAY.GT.1) THEN
	  PP(3,N)=ZBC(JJ,II,KK)+(RAN2(ISEED)-0.5)*DZ(JJ,II,KK)
	ELSE
	  PP(3,N)=ZBC(JJ,II,KK)
	ENDIF
   20 CONTINUE
C
      RETURN
      END
C
C
      FUNCTION RAN2(IDUM)
C ************************************************************
C THIS FUNCTION RETURNS A RANDOM NUMBER BETWEEN 0.0 AND 1.0.
C SET IDUM TO ANY NEGATIVE VALUE TO INITIALIZE THE SEQUENCE.
C (Modified from Press et. al., 1986).
C ************************************************************
C VER 3.00: Mon  06-10-1991
C
      PARAMETER (M=714025,IA=1366,IC=150889,RM=1.4005112E-6)
      DIMENSION IR(97)
      SAVE
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
	IFF=1
	IDUM=MOD(IC-IDUM,M)
	DO 11 J=1,97
	  IDUM=MOD(IA*IDUM+IC,M)
	  IR(J)=IDUM
   11   CONTINUE
	IDUM=MOD(IA*IDUM+IC,M)
	IY=IDUM
      ENDIF
      J=1+(97*IY)/M
      IF(J.GT.97.OR.J.LT.1) J=49
      IY=IR(J)
      RAN2=IY*RM
      IDUM=MOD(IA*IDUM+IC,M)
      IR(J)=IDUM
C
      RETURN
      END
C
C
      SUBROUTINE GENPTC(NCOL,NROW,NLAY,MXPART,NCOUNT,JJ,II,KK,
     & PP,DELR,DELC,DZ,XBC,YBC,ZBC,NADD,ZFAC)
C ****************************************************************
C THIS SUBROUTINE INSERTS [NADD] NEW PARTICLES AT CELL (JJ,II,KK)
C AROUND THE RADIUS OF THE CELL CENTER.
C ****************************************************************
C VER 3.00: Tue  06-25-1991
C
      DIMENSION PP(3,MXPART),DELR(NCOL),XBC(NCOL),
     &  DELC(NROW),YBC(NROW),ZBC(NCOL,NROW,NLAY),DZ(NCOL,NROW,NLAY)
C
C--SAVE NUMBER OF PARTICLES BEFORE INSERTION
      NP=NCOUNT
C
C--RETURN IF NUMBER OF PARTICLES AFTER INSERTION WILL CAUSE
C--TOTAL NUMBER OF PARTICLES TO EXCEED PREDEFINED MAXIMUM.
      NCOUNT=NP+NADD
      IF(NCOUNT.GT.MXPART) RETURN
C
C--IF NADD=1, PUT PARTICLE AT CELL CENTER
      IF(NADD.EQ.1) THEN
	PP(1,NP+1)=XBC(JJ)
	PP(2,NP+1)=YBC(II)
	PP(3,NP+1)=ZBC(JJ,II,KK)-0.5*DZ(JJ,II,KK)+ZFAC*DZ(JJ,II,KK)
	RETURN
      ENDIF
C
C--CALCULATE AN EFFECTIVE RADIUS
      RR=SQRT(DELR(JJ)*DELC(II))/4.81
      ANGL=2.*3.14159/NADD
C
C--PLACE [NADD] PARTICLES IN EQUAL INTERVAL [ANGL] AROUND THE RADIUS
      DO 10 INS=1,NADD
	XX=RR*COS(ANGL*INS)
	YY=RR*SIN(ANGL*INS)
	NP=NP+1
	IF(NCOL.GT.1) THEN
	  PP(1,NP)=XBC(JJ)+XX
	ELSE
	  PP(1,NP)=XBC(JJ)
	ENDIF
	IF(NROW.GT.1) THEN
	  PP(2,NP)=YBC(II)+YY
	ELSE
	  PP(2,NP)=YBC(II)
	ENDIF
	PP(3,NP)=ZBC(JJ,II,KK)-0.5*DZ(JJ,II,KK)+ZFAC*DZ(JJ,II,KK)
   10 CONTINUE
C
      RETURN
      END
C
C
      SUBROUTINE READH(INH,IOUT,NCOL,NROW,NLAY,IBOUND,H,HNOFLO,
     &  HPRT,HDFORM)
C *************************************************************
C THIS SUBROUTIN READS HEAD FILE SOLVED BY THE FLOW MODEL.
C *************************************************************
C VER 3.50: Tue  10-01-1992
C
      CHARACTER*80 HDFORM,HPRT*1,TEXT*16
      DIMENSION H(NCOL,NROW,NLAY),IBOUND(NCOL,NROW,NLAY)
      COMMON /CONST/ROERR,TINY,IOPSS,SAFETY
      COMMON /DRY/HDRY,IWDFLG
      integer*4 tmpkper,tmpkstp,tmpncol,tmpnrow,tmpnlay                 !v4.6
      real*4 tmppertim,tmptotim                                         !v4.6
      character*16 tmptext                                              !v4.6
      DATA HCNV/888.88/
C
C--IF HDFORM WAS ASSIGNED 'U', READ HEADS UNFORMATTED;
C--OTHERWISE, READ HEAD FILE WITH FORMAT GIVEN BY HDFORM
      LEN=INDEX(HDFORM,' ')-1
      IF(HDFORM(1:LEN).EQ.'U'.OR.HDFORM.EQ.'u'.or.hdform.eq.'b'         !v4.6
     +    .or.hdform.eq.'B') THEN                                       !v4.6
         if(HDFORM(1:LEN).EQ.'U'.OR.HDFORM.EQ.'u') then
           WRITE(IOUT,11) INH
   11   FORMAT(/1X,'HEADS FOR CURRENT TIME STEP READ UNFORMATTED',
     &  ' ON UNIT ',I3)
         else
           WRITE(IOUT,12) INH
   12   FORMAT(/1X,'HEADS FOR CURRENT TIME STEP READ BINARY',           !v4.6
     &  ' ON UNIT ',I3)
         end if                                                         !v4.6
	DO 10 K=1,NLAY
      READ(INH) tmpkper,tmpkstp,tmppertim,tmptotim,tmptext,tmpncol,     !v4.6
     +           tmpnrow,tmpnlay
	READ(INH) ((H(J,I,K),J=1,NCOL),I=1,NROW)
   10   CONTINUE
      ELSE
	WRITE(IOUT,21) INH,HDFORM
   21   FORMAT(/1X,'HEADS FOR CURRENT TIME STEP READ ON UNIT',I3,
     &  ' USING FORMAT ',A24/80X)
	DO 20 K=1,NLAY
	DO 22 I=1,NROW
	READ(INH,FMT=HDFORM(1:LEN)) (H(J,I,K),J=1,NCOL)
   22   CONTINUE
   20   CONTINUE
      ENDIF
C
C--IF HEAD IN A CELL IS EQUAL TO 'HNOFLO' OR 'HDRY' OR 'HCNV',
C--THE IBOUND VALUE IN THIS CELL MUST BE ZERO (INACTIVE CELL).
C--OTHERWISE, IT MUST BE POSITIVE (VARIABLE HEAD CELL).
      DO 31 K=1,NLAY
      DO 32 I=1,NROW
      DO 33 J=1,NCOL
	IF(ABS(H(J,I,K)-HNOFLO).LT.ROERR.OR.
     &     ABS(H(J,I,K)-HDRY).LT.ROERR.OR.
     &     ABS(H(J,I,K)-HCNV).LT.ROERR) THEN
	  IBOUND(J,I,K)=0
	ELSEIF(IBOUND(J,I,K).EQ.0) THEN
	  IBOUND(J,I,K)=30000
	ENDIF
   33 CONTINUE
   32 CONTINUE
   31 CONTINUE
C
C--PRINT HEADS TO ENSURE HEADS ARE READ PROPERLY
C--IF FLAG HPRT IS EQUAL TO 'Y'
      IF(HPRT.EQ.'N'.OR.HPRT.EQ.'n') GOTO 100
      TEXT='HEADS'
      IPRTFM=1
      DO 40 K=1,NLAY
	WRITE(IOUT,41) K
	CALL RPRINT(H(1,1,K),TEXT,
     &    0,KSTP,KPER,NCOL,NROW,0,IPRTFM,IOUT)
   40 CONTINUE
   41 FORMAT(61X,'LAYER ',I3)
C
  100 RETURN
      END
