C
      SUBROUTINE MOVE(IOUT,INPLOT,NCOUNT,NRC,NTRKOP,PP,PI,TIME1,TIME2,
     & EPS,DT1,MAXSTP,ISAV,IPRT,NCOL,NROW,NLAY,IBOUND,H,KWTBL,DELR,DELC,
     & XBC,YBC,ZBC,HTOP,DZ,PRSITY,XMAX,YMAX,ZMAX,QX,QY,QZ,
     & ISS,NBOUND,MXGHB,GHBND,
     & NRIVER,MXRIV,RIVER,NSTREM,MXSTR,STREAM,NDRAIN,MXDRN,DRAIN,
     & NWELLS,MXWEL,WELL,IFRONT,NFRONT,TFRONT,NF,ICAPT,INCAPT,itime,    !v4.6 del NFMAX
     + nsp,ptime,kper,idirection)
C **********************************************************************
C THIS ROUTINE MOVES PARTICLES FROM TIME1 TO TIME2 WITHIN ACCURACY EPS,
C STORES INTERMEDIATE POSITIONS AND TIMES, AND REMOVES PARTICLES WHEN
C NECESSARY.
C **********************************************************************
C VER 3.50: Sat  09-26-1992
C
      LOGICAL SAVED,WELLCP
      CHARACTER WHERE*5
      DIMENSION PP(3,NCOUNT),PI(3,NCOUNT),PSCAL(3),V(3),
     &  IBOUND(NCOL,NROW,NLAY),DELR(NCOL),DELC(NROW),
     &  DZ(NCOL,NROW,NLAY),XBC(NCOL),YBC(NROW),ZBC(NCOL,NROW,NLAY),
     &  H(NCOL,NROW,NLAY),HTOP(NCOL,NROW),PRSITY(NCOL,NROW,NLAY),
     &  QX(NCOL+1,NROW,NLAY),QY(NCOL,NROW+1,NLAY),
     &  QZ(NCOL,NROW,NLAY+1),KWTBL(NCOL,NROW),GHBND(5,MXGHB),           !v4.6
     &  RIVER(5,MXRIV),STREAM(5,MXSTR),DRAIN(5,MXDRN),WELL(4,MXWEL),    !v4.6
     &  TFRONT(NFRONT),nsp(ncount,2),ptime(ncount,2)                    !v4.6
      COMMON /LC/LAYCON(80)
      COMMON /VP/JP,IP,KP
      COMMON /WT/ICW,KWT,HWT
      COMMON /CONST/ROERR,TINY,IOPSS,SAFETY
      COMMON /DRY/HDRY,IWDFLG
C
C--PRINT A HEADER IN OUTPUT FILE
      IF(IPRT.EQ.1) THEN
        WRITE(IOUT,901)
      ELSEIF(IPRT.EQ.2) THEN
        WRITE(IOUT,902)
      ELSE
        WRITE(IOUT,903)
      ENDIF
  901 FORMAT(/12X,37('='),/12X,'PARTICLE COORDINATES AND TRAVEL TIMES',
     &       /12X,37('='))
  902 FORMAT(/12X,58('='),/12X,'PARTICLE COORDINATES, TRAVEL TIMES',
     & ' AND VELOCITY COMPONENTS',/12X,58('='))
  903 FORMAT(/14X,53('='),/14X,'PARTICLE COORDINATES, TRAVEL TIMES,',
     & ' AND NODAL INDICES',/14X,53('='))
C
C--INITIALIZE PSCAL
      PSCAL(1)=XMAX
      PSCAL(2)=YMAX
      PSCAL(3)=ZMAX
c v4.6 need temporary variables to hold TIME1 and TIME2
      time1orig=time1                                                   !v4.6
      time2orig=time2                                                   !v4.6
C
C--MOVE ACTIVE PARTICLES ONE AT A TIME
      DO 1000 NP=1,NCOUNT
          WRITE(*,909) NP
          WRITE(IOUT,910) NP
          IF(IPRT.EQ.1) THEN
              WRITE(IOUT,911)
          ELSEIF(IPRT.EQ.2) THEN
              WRITE(IOUT,912)
          ELSE
              WRITE(IOUT,913)
          ENDIF
  909     FORMAT('+Particle No.',I5,' in progress')
  910     FORMAT(/1X,'PARTICLE NO.',I10)
  911     FORMAT(8X,'X',14X,'Y',14X,'Z',12X,'TIME')
  912   FORMAT(7X,'X',11X,'Y',11X,'Z',9X,'TIME',8X,'Vx',8X,'Vy',8X,'Vz')
  913   FORMAT(8X,'X',14X,'Y',14X,'Z',12X,'TIME',11X,'J',5X,'I',5X,'K')
c-----------------------------------------------------------------------
c  v4.6 section start here
c  check if ITIME flag is invoked and then check if particle is active yet
          if (itime.lt.0) then                                          ! using option to specify startring and ending stress periods
              if (idirection.eq.1) then                                 ! forward tracking
                  !write(*,*)
                  !write(*,*) 'np=',np
                  !write(*,*) 'nsp(np,1)=',nsp(np,1)
                  !write(*,*) 'nsp(np,2)=',nsp(np,2)
                  !write(*,*) 'kper=',kper
                  !write(*,*)
                  if(nsp(np,1).gt.kper) then
                     write(iout,*) 'Particle has not yet been released.'
                     goto 1000
                  else if(kper.gt.nsp(np,2)) then
                     write(iout,*) 'Particle has been tracked to'//
     +                      ' end of specified stress period.'
                     goto 1000
                  end if
              else                                                      !v4.6  need to check these
                  !write(*,*)
                  !write(*,*) 'np=',np
                  !write(*,*) 'nsp(np,1)=',nsp(np,1)
                  !write(*,*) 'nsp(np,2)=',nsp(np,2)
                  !write(*,*) 'kper=',kper
                  !write(*,*)
                  if(nsp(np,1).lt.kper) then
                     write(iout,*) 'Particle has not yet been released.'
                     goto 1000
                  else if(kper.lt.nsp(np,2)) then
                     write(iout,*) 'Particle has been tracked to'//
     +                      ' end of specified stress period.'
                     goto 1000
                  end if
              end if
          else if (itime.gt.0) then                                     ! specifying start and end times for each particle
              if (idirection.eq.1) then                                 ! forward tracking
                  if(ptime(np,1).ge.time2orig) then
                     write(iout,*) 'Particle has not yet been released.'
                     goto 1000
                  elseif(ptime(np,2).lt.time1orig)then
                      write(iout,*) 'Particle has already been'//
     +                  ' tracked over specified time.'
                      goto 1000
                  elseif(ptime(np,1).ge.time1orig.and.ptime(np,2).le.
     +                time2orig) then
                  write(iout,*) 'Particle tracked only within current'//
     +                  ' time step.'
                  time1=ptime(np,1)
                  time2=ptime(np,2)
                  elseif(ptime(np,1).lt.time1orig.and.ptime(np,2).gt.
     +             time1orig.and.ptime(np,2).lt.time2orig) then
                  write(iout,*) 'Particle tracking ends in current'//
     +                   ' time step.'
                      time2=ptime(np,2)
                  elseif(ptime(np,1).gt.time1orig.and.ptime(np,1).lt.
     +             time2orig.and.ptime(np,2).gt.time2orig) then
                  write(iout,*) 'Particle tracking starts in current'//
     +                    ' time step.'
                      time1=ptime(np,1)
                  else
                      write(iout,*) 'Track particle over entire'//
     +                    ' time step.'
                  end if
              else                                                      ! backward tracking
                  if(ptime(np,1).le.time2orig) then
                     write(iout,*) 'Particle has not yet been released.'
                     goto 1000
                  elseif(ptime(np,2).gt.time1orig)then
                      write(iout,*) 'Particle has already been'//
     +                  ' tracked over specified time.'
                      goto 1000
                  elseif(ptime(np,1).le.time1orig.and.ptime(np,2).ge.
     +                time2orig) then
                  write(iout,*) 'Particle tracked only within current'//
     +                  ' time step.'
                  time1=ptime(np,1)
                  time2=ptime(np,2)
                  elseif(ptime(np,1).ge.time1orig.and.ptime(np,2).lt.
     +             time1orig.and.ptime(np,2).gt.time2orig) then
                  write(iout,*) 'Particle tracking ends in current'//
     +                   ' time step.'
                      time2=ptime(np,2)
                  elseif(ptime(np,1).le.time1orig.and.ptime(np,1).gt.
     +             time2orig.and.ptime(np,2).lt.time2orig) then
                  write(iout,*) 'Particle tracking starts in current'//
     +                    ' time step.'
                      time1=ptime(np,1)
                  else
                      write(iout,*) 'Track particle over entire'//
     +                    ' time step.'
                  end if
              end if
          endif
c v4.6 section end here
c ----------------------------------------------------------------------
C
C--SKIP IF PARTICLE HAS BEEN MARKED FOR REMOVAL
          IF( ABS(PP(1,NP)-1.E30).LT.ROERR .AND.
     &        ABS(PP(2,NP)-1.E30).LT.ROERR .AND.
     &        ABS(PP(3,NP)-1.E30).LT.ROERR) THEN
              WRITE(IOUT,905)
              GOTO 1000
          ENDIF
  905     FORMAT(1X,'PARTICLE HAS ALREADY BEEN REMOVED')
C
          TIME=TIME1
          DT=SIGN(DT1,TIME2-TIME1)
          SAVED=.FALSE.
          NF1=NF
          DO 500 NSTP=1,MAXSTP
              CALL VPOINT(PP(1,NP),V,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,
     +            KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,
     +            PRSITY,QX,QY,QZ,idirection)
C
C--IF PARTICLE IS ABOVE WATER TABLE BUT THERE IS NO UPWARD
C--GRADIENT AT WATER TABLE, PLACE PARTICLE BACK ON WATER TABLE
              IF(ICW.LT.0) THEN
                  KP=KWT
                  PP(3,NP)=HWT
              ENDIF
C
C--POSITION OUT OF ACTIVE FLOW DOMAIN? IF SO REMOVE AND
C--GO TO NEXT PARTICLE
              IF(IEXIT.NE.0) THEN
                  IF(IEXIT.EQ.1) THEN
                      WRITE(IOUT,15)
   15             FORMAT(1X,'REMOVED: PARTICLE AT INACTIVE OR DRY CELL')
                  ELSEIF(IEXIT.EQ.2) THEN
                      WRITE(IOUT,16)
   16     FORMAT(1X,'REMOVED: INITIAL POSITION OUTSIDE MODEL EDGE')
                  ELSEIF(IEXIT.EQ.3) THEN
                      WRITE(IOUT,17)
   17     FORMAT(1X,'REMOVED: INITIAL POSITION ABOVE WATER TABLE')
                  ENDIF
C
C--MARK REMOVED PARTICLE AND GOTO NEXT PARTICLE
        NRC=NRC+1
        PP(1,NP)=1.E30
        PP(2,NP)=1.E30
        PP(3,NP)=1.E30
        GOTO 1000
      ENDIF
C
C--STORE INTERMEDIATE RESULTS IF REQUIRED
C--(FIRST STEP IS ALWAYS SAVED)
      if (isav.gt.0) then                                               !v4.6
          modcheck=MOD(NSTP,ISAV)                                       !v4.6
      endif                                                             !v4.6
      IF(NSTP.EQ.1.AND.modcheck.EQ.0) THEN                              !v4.6
        IF(IPRT.EQ.1) THEN
          WRITE(IOUT,1001) PP(1,NP),PP(2,NP),PP(3,NP),TIME
        ELSEIF(IPRT.EQ.2) THEN
          WRITE(IOUT,1002) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                     V(1),V(2),V(3)
        ELSE
          WRITE(IOUT,1003) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                     JP,IP,KP
        ENDIF
        SAVED=.TRUE.
      ELSE
        SAVED=.FALSE.
      ENDIF
      IF(NTRKOP.GT.0) THEN
        IF(NSTP.EQ.1.OR.MOD(NSTP,NTRKOP).EQ.0)
     &  WRITE(INPLOT,1113) NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,JP,IP,KP
      ENDIF
C
C--CHECK IF TRACKING STEPSIZE IS SIGNIFICANT
      IRCODE=0
      IF(ABS(DT).LE.TINY) THEN
        IRCODE=7
        GOTO 200
C
C--CHECK IF PARTICLE IS AT A STAGNATION POINT
      ELSEIF(ABS(V(1)).LE.TINY .AND. ABS(V(2)).LE.TINY
     &  .AND. ABS(V(3)).LE.TINY .AND. ISS.NE.0 .AND. IWDFLG.EQ.0) THEN
        IRCODE=6
        GOTO 200
      ENDIF
C
C--CHECK IF PARTICLE IS AT A RIVER, STREAM, DRAIN OR WELL CELL
      WHERE='CELL'
      DO 1 N=1,NRIVER
        KK=RIVER(1,N)
        II=RIVER(2,N)
        JJ=RIVER(3,N)
        QQ=RIVER(5,N) * (RIVER(4,N)-H(JJ,II,KK))                         !v4.6
        IF(KP.EQ.KK.AND.IP.EQ.II.AND.JP.EQ.JJ.AND.QQ*DT.LT.0) THEN       !v4.6
          IRCODE=1
          WHERE='RIVER'
          GOTO 100
        ENDIF
    1 CONTINUE
      DO 4 N=1,NBOUND                                                   !v4.6  add tracking options for GHB
        KK=GHBND(1,N)
        II=GHBND(2,N)
        JJ=GHBND(3,N)
        QQ=GHBND(5,N) * (GHBND(4,N)-H(JJ,II,KK))                         !v4.6
        IF(KP.EQ.KK.AND.IP.EQ.II.AND.JP.EQ.JJ.AND.QQ*DT.LT.0)THEN        !v4.6
          IRCODE=4
          WHERE=' GHB '
          GOTO 100
        ENDIF
    4 CONTINUE                                                          !v4.6  add tracking options for STREAM
      DO 11 N=1,NSTREM
        KK=STREAM(1,N)
        II=STREAM(2,N)
        JJ=STREAM(3,N)
        QQ=STREAM(5,N) * (STREAM(4,N)-H(JJ,II,KK))                       !v4.6
        IF(KP.EQ.KK.AND.IP.EQ.II.AND.JP.EQ.JJ.AND.QQ*DT.LT.0)THEN        !v4.6
          IRCODE=1
          WHERE='STR.'
          GOTO 100
        ENDIF
   11 CONTINUE
      DO 2 N=1,NDRAIN
        KK=DRAIN(1,N)
        II=DRAIN(2,N)
        JJ=DRAIN(3,N)
        QQ=DRAIN(5,N) * (DRAIN(4,N)-H(JJ,II,KK))                        !v4.6
        IF(KP.EQ.KK.AND.IP.EQ.II.AND.JP.EQ.JJ.AND.QQ*DT.LT.0)THEN       !v4.6
          IRCODE=2
          WHERE='DRAIN'
          GOTO 100
        ENDIF
    2 CONTINUE
      DO 3 N=1,NWELLS
        KK=WELL(1,N)
        II=WELL(2,N)
        JJ=WELL(3,N)
        QQ=WELL(4,N)
        IF(KP.EQ.KK.AND.IP.EQ.II.AND.JP.EQ.JJ.AND.QQ*DT.LT.0) THEN
          IRCODE=3
          WHERE='WELL'
C......call 'wellcp' to determine if particle inside dividing streamline
          IF(IOPSS.GT.2.AND.NCOL.GT.1.AND.NROW.GT.1) THEN
            THKSAT=DZ(JJ,II,KK)
            IF(LAYCON(KK).EQ.1.OR.LAYCON(KK).EQ.3) THEN
              WTBL=HTOP(1,1)-H(JJ,II,KK)
              THKSAT=ZBC(JJ,II,KK)+DZ(JJ,II,KK)/2.-WTBL
              IF(THKSAT.GT.DZ(JJ,II,KK)) THKSAT=DZ(JJ,II,KK)
            ENDIF
            DUDX=-0.5*(QX(JJ,II,KK)+QX(JJ+1,II,KK))*THKSAT
            DUDY=-0.5*(QY(JJ,II,KK)+QY(JJ,II+1,KK))*THKSAT
            IF(WELLCP(DUDX,DUDY,QQ,XBC(JJ),YBC(II),
     &           PP(1,NP),PP(2,NP))) THEN
              IRCODE=-IRCODE
            ELSE
              IRCODE=0
            ENDIF
          ENDIF
C.......................................................................
          GOTO 100
        ENDIF
    3 CONTINUE
  100 CONTINUE
C
C--CHECK IF PARTICLE IS AT A CELL WITH COMPLETELY INWARD GRADIENT
C--ON ALL CELL INTERFACES
      IF(NCOL.GT.1 .AND.
     & (QX(JP,IP,KP)*DT.LT.0.OR.QX(JP+1,IP,KP)*DT.GT.0) ) GOTO 200
      IF(NROW.GT.1 .AND.
     & (QY(JP,IP,KP)*DT.LT.0.OR.QY(JP,IP+1,KP)*DT.GT.0) ) GOTO 200
      IF(NLAY.GT.1 .AND.
     & (QZ(JP,IP,KP)*DT.LT.0.OR.QZ(JP,IP,KP+1)*DT.GT.0) ) GOTO 200
      IRCODE=5
C
C--REMOVE PARTICLE ACCORDING TO OPTION SPECIFIED IN IOPSS
C--AND SAVE FINAL STEP IF NOT ALREADY SAVED
  200 IF( (IOPSS.EQ.2.OR.IOPSS.EQ.4).AND.IRCODE.GT.0 .OR.
     &    (IOPSS.EQ.1.OR.IOPSS.EQ.3).AND.IRCODE.GE.5 .OR.
     &     IOPSS.GT.2.AND.IRCODE.LT.0) THEN
        IF(.NOT.SAVED) THEN
          IF(IPRT.EQ.1) THEN
            WRITE(IOUT,1001) PP(1,NP),PP(2,NP),PP(3,NP),TIME
          ELSEIF(IPRT.EQ.2) THEN
            WRITE(IOUT,1002) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                       V(1),V(2),V(3)
          ELSE
            WRITE(IOUT,1003) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                       JP,IP,KP
          ENDIF
        ENDIF
        IF(NTRKOP.GT.0) WRITE(INPLOT,1113)
     &      NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,JP,IP,KP
C
C--SAVE CAPTURED PARTICLE IF REQUESTED
        IF(INCAPT.GT.0) THEN
          WRITE(ICAPT,1200) NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &     PI(1,NP),PI(2,NP),PI(3,NP),WHERE,ircode
        ENDIF
C
C--PRINT OUT A MESSAGE INDICATING REASON FOR REMOVAL
       IF(IRCODE.EQ.5) THEN
          WRITE(IOUT,135) WHERE,KP,IP,JP
  135     FORMAT(1X,'REMOVED: PARTICLE TRAPPED AT ',A5,
     &    ' K=',I5,',  I=',I5,',  J=',I5)
        ELSEIF(IRCODE.EQ.6) THEN
          WRITE(IOUT,137) KP,IP,JP
  137     FORMAT(1X,'REMOVED: PARTICLE STAGNATED AT CELL ',
     &    ' K=',I5,',  I=',I5,',  J=',I5)
        ELSEIF(IRCODE.EQ.7) THEN
          WRITE(IOUT,138)
  138     FORMAT(1X,'REMOVED: TRACKING STEPSIZE NOT SIGNIFICANT')
        ELSEIF(IRCODE.GT.0.AND.(IOPSS.EQ.2.OR.IOPSS.EQ.4)) THEN
          WRITE(IOUT,136) WHERE,KP,IP,JP
  136     FORMAT(1X,'REMOVED: PARTICLE ENTERS ',A5,
     &    ' K=',I5,',  I=',I5,',  J=',I5)
        ELSEIF(IRCODE.LT.0.AND.IOPSS.GT.2) THEN
          WRITE(IOUT,139) WHERE,KP,IP,JP
  139     FORMAT(1X,'REMOVED: PARTICLE INSIDE DIVIDING STREAMLINE',
     &      ' AT ',A5,' K=',I5,',  I=',I5,',  J=',I5)
        ENDIF
C
C--MARK REMOVED PARTICLE AND GO TO NEXT PARTICLE
        NRC=NRC+1
        PP(1,NP)=1.E30
        PP(2,NP)=1.E30
        PP(3,NP)=1.E30
        GOTO 1000
      ENDIF
C
C--IF NEXT STEP CAN EXCEED UPPER LIMIT OF TRACKING TIME INTERVAL,
C--OR IF IT DOES NOT COINCIDE WITH THE SPECIFIED TIMES AT WHICH
C--FRONT POSITIONS ARE SAVED, CUT DOWN STEPSIZE
      IF(TIME2.GT.TIME1.AND.TIME+DT.GT.TIME2 .OR.
     &  TIME2.LT.TIME1.AND.TIME+DT.LT.TIME2) DT=TIME2-TIME
      IF(NFRONT.GT.0.AND.NF1.LE.NFRONT) THEN
        IF(TFRONT(NF1).GT.TIME1.AND.TFRONT(NF1).LT.TIME+DT.OR.
     &     TFRONT(NF1).LT.TIME1.AND.TFRONT(NF1).GT.TIME+DT) THEN
           DT=TFRONT(NF1)-TIME
        ENDIF
      ENDIF
C
C--TAKE ONE ACCURACY-ASSURED STEP
      CALL RKASC(PP(1,NP),V,TIME,DT,EPS,PSCAL,DTNEXT,IDEND,
     &  NCOL,NROW,NLAY,KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,
     &  HTOP,PRSITY,QX,QY,QZ)
C
C--IF PARTICLE HAS REACHED A BOUNDARY, STORE THE FINAL STEP
C--IF NOT ALREADY SAVED, AND GO TO THE NEXT PARTICLE
      IF(IDEND.NE.0) THEN
        IF(.NOT.SAVED.OR.IDEND.LT.0) THEN
          IF(IPRT.EQ.1) THEN
            WRITE(IOUT,1001) PP(1,NP),PP(2,NP),PP(3,NP),TIME
          ELSEIF(IPRT.EQ.2) THEN
            WRITE(IOUT,1002) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                       V(1),V(2),V(3)
          ELSE
            WRITE(IOUT,1003) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                       JP,IP,KP
          ENDIF
        ENDIF
        IF(NTRKOP.GT.0) WRITE(INPLOT,1113)
     &      NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,JP,IP,KP
        IF(IDEND.EQ.1) THEN
          WRITE(IOUT,20)
   20     FORMAT(1X,'REMOVED: NEXT POSITION EXIT FROM MODEL EDGE')
        ELSEIF(IDEND.EQ.11) THEN
          WRITE(IOUT,21)
   21     FORMAT(1X,'REMOVED: NEXT POSITION INTO INACTIVE OR DRY CELL')
        ELSEIF(IDEND.EQ.2) THEN
          WRITE(IOUT,22)
   22     FORMAT(1X,'REMOVED: NEXT POSITION ABOVE WATER TABLE')
        ELSEIF(IDEND.EQ.3) THEN
          WRITE(IOUT,23)
   23     FORMAT(1X,'REMOVED: NEXT POSITION AT STAGNATION POINT')
        ELSEIF(IDEND.EQ.4) THEN
          WRITE(IOUT,24)
   24     FORMAT(1X,'REMOVED: NEXT POSITION OUT OF FLOW DOMAIN')
        ELSEIF(IDEND.EQ.-2) THEN
          WRITE(IOUT,32)
   32     FORMAT(1X,'REMOVED: LAST POSITION EXIT FROM MODEL EDGE')
        ELSEIF(IDEND.EQ.-1) THEN
          WRITE(IOUT,31)
   31     FORMAT(1X,'REMOVED: LAST POSITION INTO INACTIVE OR DRY CELL')
        ELSEIF(IDEND.EQ.-3) THEN
          WRITE(IOUT,33)
   33     FORMAT(1X,'REMOVED: LAST POSITION ABOVE WATER TABLE')
        ENDIF
        NRC=NRC+1
        PP(1,NP)=1.E30
        PP(2,NP)=1.E30
        PP(3,NP)=1.E30
        GOTO 1000
      ENDIF
C
C--IF DONE, STORE FINAL STEP AND GO TO THE NEXT PARTICLE
      IF(TIME2.GT.TIME1.AND.TIME.GE.TIME2.OR.
     &  TIME2.LT.TIME1.AND.TIME.LE.TIME2) THEN
        IF(IPRT.EQ.1) THEN
          WRITE(IOUT,1001) PP(1,NP),PP(2,NP),PP(3,NP),TIME
        ELSEIF(IPRT.EQ.2) THEN
          WRITE(IOUT,1002) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                     V(1),V(2),V(3)
        ELSE
          WRITE(IOUT,1003) PP(1,NP),PP(2,NP),PP(3,NP),TIME,
     &                     JP,IP,KP
        ENDIF
        IF(NTRKOP.GT.0) WRITE(INPLOT,1113)
     &    NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,JP,IP,KP
        IF(NFRONT.GT.0.AND.NF1.LE.NFRONT) THEN
          IF(TIME2.GT.TIME1.AND.TIME.GE.TFRONT(NF1).OR.
     &      TIME2.LT.TIME1.AND.TIME.LE.TFRONT(NF1)) THEN
            WRITE(IFRONT,1113)
     &      NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,NF1
            NF1=NF1+1
          ENDIF
        ENDIF
        GOTO 1000
      ENDIF
      IF(NFRONT.GT.0.AND.NF1.LE.NFRONT) THEN
        IF(TIME2.GT.TIME1.AND.TIME.GE.TFRONT(NF1).OR.
     &    TIME2.LT.TIME1.AND.TIME.LE.TFRONT(NF1)) THEN
          WRITE(IFRONT,1113)
     &    NP,PP(1,NP),PP(2,NP),PP(3,NP),TIME,NF1
          NF1=NF1+1
        ENDIF
      ENDIF
C
C--ASSIGN DTNEXT TO DT FOR THE NEXT STEP
      DT=DTNEXT
  500 CONTINUE
C
C--REMOVE IF MAXSTP EXCEEDED
      WRITE(IOUT,50)
   50 FORMAT(1X,'REMOVED: MAXIMUM NUMBER OF TRACKING STEPS EXCEEDED')
      NRC=NRC+1
      PP(1,NP)=1.E30
      PP(2,NP)=1.E30
      PP(3,NP)=1.E30
C
 1000 CONTINUE
      NF=NF1
C
 1001 FORMAT(1X,4G15.7)
 1002 FORMAT(1X,4G12.5,3E10.3)
 1003 FORMAT(1X,4G15.7,1X,I5,1X,I5,1X,I5)
 1113 FORMAT(1X,I6,1X,1P,4(G13.5,1X),I4,1X,I4,1X,I4)
 1200 FORMAT(1X,I6,1X,1P,7(G13.5,1X),2X,'''',A5,'''',1x,i2)
C
      RETURN
      END
C
C
      SUBROUTINE RKASC(P,V,TIME,DTRY,EPS,PSCAL,DTNEXT,IDEND,
     &  NCOL,NROW,NLAY,KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,
     &  HTOP,PRSITY,QX,QY,QZ)
C ********************************************************************
C THIS ROUTINE MONITORS TRUNCATION ERRORS OF THE RUNGE-KUTTA SOLUTION
C AND ADJUSTS THE STEPSIZE TO ENSURE THE REQUIRED ACCURACY.
C ON OUTPUT, P AND TIME ARE REPLACED BY THEIR NEW VALUES AND DTNEXT
C IS THE ESTIMATED NEXT STEPSIZE.
C *******************************************************************
C VER 3.01: Tue  09-10-1991
C
      DIMENSION P(3),V(3),PSCAL(3),PTMP(3),PSAV(3),VSAV(3),
     &  IBOUND(NCOL,NROW,NLAY),DELR(NCOL),DELC(NROW),
     &  DZ(NCOL,NROW,NLAY),XBC(NCOL),YBC(NROW),ZBC(NCOL,NROW,NLAY),
     &  H(NCOL,NROW,NLAY),HTOP(NCOL,NROW),PRSITY(NCOL,NROW,NLAY),
     &  QX(NCOL+1,NROW,NLAY),QY(NCOL,NROW+1,NLAY),
     &  QZ(NCOL,NROW,NLAY+1),KWTBL(NCOL,NROW)
      COMMON /VP/JP,IP,KP
      COMMON /LC/LAYCON(80)
      COMMON /CONST/ROERR,TINY,IOPSS,SAFETY
C
C--SET ORIGN OF PARTICLE LOCATION AND CALCULATE ROUND-OFF ERRORS
      HORIGN=HTOP(1,1)
      XERR=ROERR*PSCAL(1)
      YERR=ROERR*PSCAL(2)
      ZERR=ROERR*PSCAL(3)
C
C--SAVE INITIAL VALUES
      DO11 I=1,3
      PSAV(I)=P(I)
      VSAV(I)=V(I)
   11 CONTINUE
      JPSAV=JP
      IPSAV=IP
      KPSAV=KP
C
C--SET STEPSIZE TO THE INITIAL TRIAL VALUE
      DT=DTRY
C
C--TAKE TWO HALF STEPS
    1 DTHALF=0.5*DT
      CALL RK4(PSAV,VSAV,DTHALF,PTMP,IEXIT,
     & NCOL,NROW,NLAY,PSCAL,KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,
     & HTOP,PRSITY,QX,QY,QZ)
      IF(IEXIT.NE.0) GOTO 100
C
      CALL VPOINT(PTMP,V,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,KWTBL,
     &  IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,PRSITY,QX,QY,QZ,
     +  idirection)
      IF(IEXIT.NE.0) GOTO 100
      CALL RK4(PTMP,V,DTHALF,P,IEXIT,
     & NCOL,NROW,NLAY,PSCAL,KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,
     & HTOP,PRSITY,QX,QY,QZ)
      IF(IEXIT.NE.0) GOTO 100
C
C--TAKE THE LARGE STEP
      CALL RK4(PSAV,VSAV,DT,PTMP,IEXIT,
     & NCOL,NROW,NLAY,PSCAL,KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,
     & HTOP,PRSITY,QX,QY,QZ)
      IF(IEXIT.NE.0) GOTO 100
C
C--EVALUATE ACCURACY
      ERRMAX=0
      DO12 I=1,3
      PTMP(I)=P(I)-PTMP(I)
      ERRMAX=MAX(ERRMAX,ABS(PTMP(I)/PSCAL(I)))
   12 CONTINUE
C
C--SCALE RELATIVE TO REQUIRED TOLERANCE
      ERRMAX=ERRMAX/EPS
C
C--IF TRUNCATION ERROR TOO LARGE, REDUCE STEPSIZE
      IF(ERRMAX.GT.1.) THEN
        DT=SAFETY*DT/ERRMAX**0.2
        GOTO 1
c
c--else if particle moves more than one cell, cut stepsize in half      !CZ
      else if (abs(p(1)-psav(1)).gt.delr(jpsav).or.                     !CZ
     +         abs(p(2)-psav(2)).gt.delc(ipsav).or.                     !CZ
     +         abs(p(3)-psav(3)).gt.dz(jpsav,ipsav,kpsav)) then         !CZ
        dt=dt/2.                                                        !CZ
        goto 1                                                          !CZ
C
C--ELSE IF STEP SUCCEEDED, COMPUTE SIZE OF NEXT STEP
      ELSE
        IF(ERRMAX.GT.0) DTNEXT=SAFETY*DT/ERRMAX**0.2
        IF(ERRMAX.EQ.0.OR.ABS(DTNEXT).GT.ABS(4.*DT)) DTNEXT=4.*DT
      ENDIF
C
C--MOP UP FIFTH-ORDER TRUNCATION ERROR
      DO13 I=1,3
      P(I)=P(I)+PTMP(I)/15.
   13 CONTINUE
C
C--FIND CELL INDICES OF THE FINAL POSITION P
      CALL LOCATE(P,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,DELR,DELC,DZ,
     & XBC,YBC,ZBC,IBOUND,H,KWTBL,HTOP,QZ)
C
C--ADJUSTED FOR VERTICALLY DISTORTED GRID
      IF(ABS(ZBC(JP,IP,KPSAV)-ZBC(JPSAV,IPSAV,KPSAV)).GT.ROERR
     & .OR.ABS(DZ(JP,IP,KPSAV)-DZ(JPSAV,IPSAV,KPSAV)).GT.ROERR) THEN
        IF(DZ(JPSAV,IPSAV,KPSAV).GT.0) THEN
          CF=DZ(JP,IP,KPSAV)/DZ(JPSAV,IPSAV,KPSAV)
     &     *(PSAV(3)-ZBC(JPSAV,IPSAV,KPSAV))
          P(3)=P(3)-PSAV(3)+CF+ZBC(JP,IP,KPSAV)
          CALL LOCATE(P,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,DELR,DELC,DZ,
     &     XBC,YBC,ZBC,IBOUND,H,KWTBL,HTOP,QZ)
        ENDIF
      ENDIF
C
C--IF FIANL POSITION P IS OUTSIDE ACTIVE FLOW DOMAIN, GO TO LABEL 100
C--AND DETERMINE THE EXIT POINT AND EXIT TIME
      IF(IEXIT.NE.0) GOTO 100
C
C--UPDATE TIME
      TIME=TIME+DT
      GOTO 200
C
C--PARTICLE TO REACH BOUNDARY.  MOVE PARTICLE TO CELL EDGE
  100 JP=JPSAV
      IP=IPSAV
      KP=KPSAV
      IF(NCOL.LT.2) THEN
         DT1=1.E30
      ELSEIF(ABS(VSAV(1)).LE.TINY) THEN
         DT1=1.E30
      ELSEIF(VSAV(1)*DT.GT.0) THEN
         DT1=(XBC(JP)+DELR(JP)/2.-PSAV(1))/VSAV(1)
         IF(ABS(PSAV(1)-XBC(JP)-DELR(JP)/2.).LE.XERR) THEN
           IF(JP.EQ.NCOL.AND.QX(JP+1,IP,KP)*DT.GT.0) THEN
             IDEND=1
             RETURN
           ELSEIF(JP.LT.NCOL.AND.IBOUND(JP+1,IP,KP).EQ.0
     &       .AND.QX(JP+1,IP,KP)*DT.GT.0) THEN
             IDEND=11
             RETURN
           ELSEIF(JP.EQ.NCOL.OR.
     &       IBOUND(JP+1,IP,KP).EQ.0) THEN
             DT1=1.E30
           ELSE
             DT1=(XBC(JP+1)+DELR(JP+1)/2.-PSAV(1))/VSAV(1)
           ENDIF
         ENDIF
      ELSE
         DT1=(XBC(JP)-DELR(JP)/2.-PSAV(1))/VSAV(1)
         IF(ABS(PSAV(1)-XBC(JP)+DELR(JP)/2.).LE.XERR) THEN
           IF(JP.EQ.1.AND.QX(JP,IP,KP)*DT.LT.0) THEN
             IDEND=1
             RETURN
           ELSEIF(JP.GT.1.AND.IBOUND(JP-1,IP,KP).EQ.0.AND.
     &       QX(JP,IP,KP)*DT.LT.0) THEN
             IDEND=11
             RETURN
           ELSEIF(JP.EQ.1.OR.IBOUND(JP-1,IP,KP).EQ.0) THEN
             DT1=1.E30
           ELSE
             DT1=(XBC(JP-1)-DELR(JP-1)/2.-PSAV(1))/VSAV(1)
           ENDIF
         ENDIF
      ENDIF
C
      IF(NROW.LT.2) THEN
         DT2=1.E30
      ELSEIF(ABS(VSAV(2)).LE.TINY) THEN
         DT2=1.E30
      ELSEIF(VSAV(2)*DT.GT.0) THEN
         DT2=(YBC(IP)+DELC(IP)/2.-PSAV(2))/VSAV(2)
         IF(ABS(PSAV(2)-YBC(IP)-DELC(IP)/2.).LE.YERR) THEN
           IF(IP.EQ.NROW.AND.QY(JP,IP+1,KP)*DT.GT.0) THEN
             IDEND=1
             RETURN
           ELSEIF(IP.LT.NROW.AND.IBOUND(JP,IP+1,KP).EQ.0
     &       .AND.QY(JP,IP+1,KP)*DT.GT.0) THEN
             IDEND=11
             RETURN
           ELSEIF(IP.EQ.NROW.OR.
     &       IBOUND(JP,IP+1,KP).EQ.0) THEN
             DT2=1.E30
           ELSE
             DT2=(YBC(IP+1)+DELC(IP+1)/2.-PSAV(2))/VSAV(2)
           ENDIF
         ENDIF
      ELSE
         DT2=(YBC(IP)-DELC(IP)/2.-PSAV(2))/VSAV(2)
         IF(ABS(PSAV(2)-YBC(IP)+DELC(IP)/2.).LE.YERR) THEN
           IF(IP.EQ.1.AND.QY(JP,IP,KP)*DT.LT.0) THEN
             IDEND=1
             RETURN
           ELSEIF(IP.GT.1.AND.IBOUND(JP,IP-1,KP).EQ.0.AND.
     &       QY(JP,IP,KP)*DT.LT.0) THEN
             IDEND=11
             RETURN
           ELSEIF(IP.EQ.1.OR.IBOUND(JP,IP-1,KP).EQ.0) THEN
             DT2=1.E30
           ELSE
             DT2=(YBC(IP-1)-DELC(IP-1)/2.-PSAV(2))/VSAV(2)
           ENDIF
         ENDIF
      ENDIF
C
      IF(NLAY.LT.2) THEN
        DT3=1.E30
      ELSEIF(ABS(VSAV(3)).LT.TINY) THEN
         DT3=1.E30
      ELSEIF(VSAV(3)*DT.GT.0) THEN
         DT3=(ZBC(JP,IP,KP)+DZ(JP,IP,KP)/2.
     &   -PSAV(3))/VSAV(3)
         IF(ABS(PSAV(3)-ZBC(JP,IP,KP)
     &     -DZ(JP,IP,KP)/2.).LE.ZERR) THEN
           IF(KP.EQ.NLAY.AND.QZ(JP,IP,KP+1)*DT.GT.0) THEN
             IDEND=1
             RETURN
           ELSEIF(KP.LT.NLAY.AND.IBOUND(JP,IP,KP+1).EQ.0
     &       .AND.QZ(JP,IP,KP+1)*DT.GT.0) THEN
             IDEND=11
             RETURN
           ELSEIF(KP.EQ.NLAY.OR.
     &       IBOUND(JP,IP,KP+1).EQ.0) THEN
             DT3=1.E30
           ELSE
             DT3=(ZBC(JP,IP,KP+1)
     &       +DZ(JP,IP,KP+1)/2.-PSAV(3))/VSAV(3)
           ENDIF
         ENDIF
      ELSEIF(VSAV(3)*DT.LT.0.AND.KP.EQ.KWTBL(JP,IP)
     &   .AND.LAYCON(KP).NE.0
     &   .AND.HORIGN-H(JP,IP,KP).GT.ZBC(JP,IP,KP)
     &    -DZ(JP,IP,KP)/2.) THEN
         DT3=(HORIGN-H(JP,IP,KP)-PSAV(3))/VSAV(3)
         IF(ABS(HORIGN-H(JP,IP,KP)-PSAV(3)).LE.ZERR
     &     .AND.QZ(JP,IP,KP)*DT.LT.0) THEN
           IDEND=2
           RETURN
         ENDIF
      ELSE
         DT3=(ZBC(JP,IP,KP)-DZ(JP,IP,KP)/2.
     &   -PSAV(3))/VSAV(3)
         IF(ABS(PSAV(3)-ZBC(JP,IP,KP)
     &   +DZ(JP,IP,KP)/2.).LE.ZERR) THEN
           IF(KP.EQ.1.AND.QZ(JP,IP,KP)*DT.LT.0) THEN
             IDEND=1
             RETURN
           ELSEIF(KP.GT.1.AND.IBOUND(JP,IP,KP-1).EQ.0
     &       .AND.QZ(JP,IP,KP)*DT.LT.0) THEN
             IDEND=11
             RETURN
           ELSEIF(KP.EQ.1.OR.
     &       IBOUND(JP,IP,KP-1).EQ.0) THEN
             DT3=1.E30
           ELSE
             DT3=(ZBC(JP,IP,KP-1)-DZ(JP,IP,KP-1)/2.
     &       -PSAV(3))/VSAV(3)
             DT3W=(HORIGN-H(JP,IP,KP-1)-PSAV(3))/VSAV(3)
             IF(ABS(DT3).GT.ABS(DT3W)) DT3=DT3W
           ENDIF
         ENDIF
      ENDIF
C
      IF(DT1.EQ.1.E30.AND.DT2.EQ.1.E30.AND.DT3.EQ.1.E30) THEN
         IDEND=3
         RETURN
      ELSE
         DTMP=MIN(ABS(DT1),ABS(DT2),ABS(DT3))
         DTMP=DT/ABS(DT)*ABS(DTMP)
         IF(DTMP.EQ.0) THEN
           IDEND=4
           RETURN
         ENDIF
         DO 110 I=1,3
         P(I)=PSAV(I)+DTMP*VSAV(I)
  110    CONTINUE
         TIME=TIME+DTMP
         DTNEXT=DTRY
C
C--CHECK IF P IS CALCULATED AS OUTSIDE ACTIVE FLOW DOMAIN
C--DUE TO MACHINE ROUND-OFF ERRORS. IF SO RETURN
         CALL LOCATE(P,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,
     &   DELR,DELC,DZ,XBC,YBC,ZBC,IBOUND,H,KWTBL,HTOP,QZ)
         IF(IEXIT.NE.0) THEN
           IF(IEXIT.EQ.1) THEN
             IDEND=-1
           ELSEIF(IEXIT.EQ.2) THEN
             IDEND=-2
           ELSE
             IDEND=-3
           ENDIF
           RETURN
         ENDIF
      ENDIF
C
C--NORMAL RETURN
  200 IDEND=0
      RETURN
      END
C
C
      SUBROUTINE RK4(P,V,DT,POUT,IEXIT,NCOL,NROW,NLAY,PSCAL,
     & KWTBL,IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,PRSITY,QX,QY,QZ)
C *********************************************************************
C THIS ROUTINE ADVANCES A PARTICLE FROM POINT P(X,Y,Z) TO POUT(X,Y,Z)
C OVER AN INTERVAL DT BY USING THE FOURTH-ORDER RUNGE-KUTTA SOLUTION.
C *********************************************************************
C VER 3.00: Tue  06-25-1991
C
      DIMENSION DELR(NCOL),DELC(NROW),DZ(NCOL,NROW,NLAY),
     & XBC(NCOL),YBC(NROW),ZBC(NCOL,NROW,NLAY),H(NCOL,NROW,NLAY),
     & HTOP(NCOL,NROW),IBOUND(NCOL,NROW,NLAY),PRSITY(NCOL,NROW,NLAY),
     & QX(NCOL+1,NROW,NLAY),QY(NCOL,NROW+1,NLAY),
     & QZ(NCOL,NROW,NLAY+1),KWTBL(NCOL,NROW),
     & P(3),POUT(3),V(3),PT(3),VM(3),VT(3),PSCAL(3)
      COMMON /VP/JP,IP,KP
C
      DTHALF=DT*0.5
      DT6=DT/6.
C
C--FIRST STEP
      DO 11 I=1,3
      PT(I)=P(I)+DTHALF*V(I)
   11 CONTINUE
C
C--SECOND STEP
      CALL VPOINT(PT,VT,DT,IEXIT,
     &   NCOL,NROW,NLAY,PSCAL,KWTBL,IBOUND,H,
     &   DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,PRSITY,QX,QY,QZ,idirection)
      IF(IEXIT.NE.0) RETURN
      DO12 I=1,3
      PT(I)=P(I)+DTHALF*VT(I)
   12 CONTINUE
C
C--THIRD STEP
      CALL VPOINT(PT,VM,DT,IEXIT,
     &   NCOL,NROW,NLAY,PSCAL,KWTBL,IBOUND,H,
     &   DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,PRSITY,QX,QY,QZ,idirection)
      IF(IEXIT.NE.0) RETURN
      DO13 I=1,3
      PT(I)=P(I)+DT*VM(I)
      VM(I)=VT(I)+VM(I)
   13 CONTINUE
C
C--FOURTH STEP
      CALL VPOINT(PT,VT,DT,IEXIT,
     &   NCOL,NROW,NLAY,PSCAL,KWTBL,IBOUND,H,
     &   DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,PRSITY,QX,QY,QZ,idirection)
      IF(IEXIT.NE.0) RETURN
C
C--ACCUMULATE INCREMENTS WITH PROPER WEIGHT
      DO14 I=1,3
      POUT(I)=P(I)+DT6*(V(I)+VT(I)+2.*VM(I))
   14 CONTINUE
C
C--NORMAL EXIT
      RETURN
      END
C
C
      SUBROUTINE LOCATE(P,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,
     &  DELR,DELC,DZ,XBC,YBC,ZBC,IBOUND,H,KWTBL,HTOP,QZ)
C ***********************************************************
C THIS ROUTINE DETERMINES THE LOCATION OF POINT P IN THE
c THREE-DIMENSIONAL FINITE-DIFFERENCE GRID.  IF P IS OUTSIDE
C THE ACTIVE FLOW DOMAIN, THE ROUTINE RETURNS WITH IEXIT
C EQUAL TO A NON-ZERO VALUE.
C ***********************************************************
C VER 3.11: Sun  06-21-1992
C
      DIMENSION DELR(NCOL),DELC(NROW),DZ(NCOL,NROW,NLAY),
     & XBC(NCOL),YBC(NROW),ZBC(NCOL,NROW,NLAY),HTOP(NCOL,NROW),
     & IBOUND(NCOL,NROW,NLAY),KWTBL(NCOL,NROW),H(NCOL,NROW,NLAY),
     & QZ(NCOL,NROW,NLAY+1),P(3),PSCAL(3)
      COMMON /VP/JP,IP,KP
      COMMON /LC/LAYCON(80)
      COMMON /WT/ICW,KWT,HWT
C
C--SET ORIGN OF PARTICLE LOCATION
      HORIGN=HTOP(1,1)
C
C--FIND THE J INDEX ALONG THE ROW (X) DIRECTION
      IF(NCOL.LE.1) THEN
        JP=1
        GOTO 20
      ELSE
        JL=0
        JU=NCOL+1
      ENDIF
    1 IF(JU-JL.GT.1) THEN
        JM=(JU+JL)/2
        IF(P(1).GE.XBC(JM)) THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
        GOTO 1
      ENDIF
C
      IF(JL.EQ.0) THEN
        JP=1
      ELSEIF(JL.EQ.NCOL) THEN
        JP=NCOL
      ELSEIF(ABS(P(1)-XBC(JL)).LE.DELR(JL)/2.) THEN
        JP=JL
      ELSE
        JP=JL+1
      ENDIF
C
C--FIND THE I INDEX ALONG THE COLUMN (Y) DIRECTION
   20 IF(NROW.LE.1) THEN
        IP=1
        GOTO 30
      ELSE
        IL=0
        IU=NROW+1
      ENDIF
C
    2 IF(IU-IL.GT.1) THEN
        IM=(IU+IL)/2
        IF(P(2).GE.YBC(IM)) THEN
          IL=IM
        ELSE
          IU=IM
        ENDIF
        GOTO 2
      ENDIF
C
      IF(IL.EQ.0) THEN
        IP=1
      ELSEIF(IL.EQ.NROW) THEN
        IP=NROW
      ELSEIF(ABS(P(2)-YBC(IL)).LE.DELC(IL)/2.) THEN
        IP=IL
      ELSE
        IP=IL+1
      ENDIF
C
C--FIND THE K INDEX ALONG THE LAYER (Z) DIRECTION
   30 IF(NLAY.LE.1) THEN
        KP=1
        GOTO 40
      ELSE
        KL=0
        KU=NLAY+1
      ENDIF
C
    3 IF(KU-KL.GT.1) THEN
        KM=(KU+KL)/2
        IF(P(3).GE.ZBC(JP,IP,KM)) THEN
          KL=KM
        ELSE
          KU=KM
        ENDIF
        GOTO 3
      ENDIF
C
      IF(KL.EQ.0) THEN
        KP=1
      ELSEIF(KL.EQ.NLAY) THEN
        KP=NLAY
      ELSEIF(ABS(P(3)-ZBC(JP,IP,KL)).LE.DZ(JP,IP,KL)/2.) THEN
        KP=KL
      ELSE
        KP=KL+1
      ENDIF
C
C--PARTICLE ABOVE WATER TABLE? IF SO BUT THERE IS NO UPWARD
C--GRADIENT AT WATER TABLE, INVOKE OPTION TO PLACE PARTICLE BACK ON
C--WATER TABLE BY SETTING FLAG [ICW] TO A NEGTIVE VALUE.
C--OTHERWISE, SET IEXIT=3 AND RETURN.
   40 KWT=KWTBL(JP,IP)
      HWT=HORIGN-H(JP,IP,KWT)
      ICW=0
      IF(LAYCON(KP).NE.0 .AND. NLAY.GE.2 .AND. P(3).LT.HWT) THEN
        IF(QZ(JP,IP,KWT)*DT.GE.0) THEN
          ICW=-1
        ELSE
          IEXIT=3
          RETURN
        ENDIF
      ENDIF
C
C--PARTICLE WITHIN INACTIVE NODE?  IF SO SET IEXIT=1 AND RETURN.
      IF(IBOUND(JP,IP,KP).EQ.0) THEN
        IEXIT=1
        RETURN
      ENDIF
C
C--PARTICLE OUT OF FLOW DOMAIN?  IF SO SET IEXIT=2 AND RETURN.
      IF(P(1).LT.0 .OR. P(1).GT.PSCAL(1)) THEN
        IF(NCOL.GT.1) THEN
          IEXIT=2
          RETURN
        ELSE
          P(1)=XBC(JP)
        ENDIF
      ENDIF
      IF(P(2).LT.0 .OR. P(2).GT.PSCAL(2)) THEN
        IF(NROW.GT.1) THEN
          IEXIT=2
          RETURN
        ELSE
          P(2)=YBC(IP)
        ENDIF
      ENDIF
      IF(P(3).LT.HORIGN-HTOP(JP,IP) .OR.
     &  P(3).GT.ZBC(JP,IP,NLAY)+DZ(JP,IP,NLAY)/2.) THEN
        IF(NLAY.GT.1) THEN
          IEXIT=2
          RETURN
        ELSE
          P(3)=ZBC(JP,IP,KP)
        ENDIF
      ENDIF
C
C--NORMAL RETURN
      IEXIT=0
      RETURN
      END
C
C
      FUNCTION WELLCP(DUDX,DUDY,QW,XW,YW,XP,YP)
C ***********************************************************
C WELLCP: Function to determine if a particle is inside the
C ======  dividing streamline of a well using an analytical
C         solution.
C                     INPUT VARIABLES
C DUDX:  VOLUMETRIC FLOW RATE PER UNIT WIDTH IN X DIRECTION;
C DUDY:  VOLUMETRIC FLOW RATE PER UNIT WIDTH IN Y DIRECTION;
C QW:    VOLUMETRIC FLOW RATE AT WELL, SOURCE(+), SINK(-1);
C XW,YW: X AND Y COORDINATES OF WELL RELATIVE TO ORIGIN;
C XP,YP: X AND Y COORDINATES OF PARTICLE RELATIVE TO ORIGIN.
C                     OUTPUT FUNCTION
C WELLCP=.TRUE.  IF PARTICLE IS INSIDE DIVIDING STREAMLINE;
C WELLCP=.FALSE. IF PARTICLE IS OUTSIDE DIVIDING STREAMLINE.
C ***********************************************************
C VER 3.50: Sat  09-26-1992
C
      IMPLICIT NONE
      INTEGER  ICAP
      REAL     DUDX,DUDY,QW,XW,YW,XP,YP,PI,
     &         ALPHA,GRAD,XMIN,YMIN,YMAX,XX,YY,X0
      LOGICAL  WELLCP
C
      PI=4.*ATAN(1.)
      IF(DUDX.NE.0) ALPHA=ATAN( ABS(DUDY/DUDX) )
      IF(DUDX.EQ.0 .AND. DUDY.GT.0) THEN
        ALPHA=PI/2.
      ELSEIF(DUDX.EQ.0 .AND. DUDY.LT.0) THEN
        ALPHA=3.*PI/2.
      ELSEIF(DUDX.GT.0 .AND. DUDY.EQ.0) THEN
       ALPHA=0
      ELSEIF(DUDX.LT.0 .AND. DUDY.EQ.0) THEN
       ALPHA=PI
      ELSEIF(DUDX.LT.0 .AND. DUDY.GT.0) THEN
        ALPHA=PI-ALPHA
      ELSEIF(DUDX.LT.0 .AND. DUDY.LT.0) THEN
        ALPHA=PI+ALPHA
      ELSEIF(DUDX.GT.0 .AND. DUDY.LT.0) THEN
        ALPHA=2.*PI-ALPHA
      ENDIF
      IF(QW.GT.0) ALPHA=PI+ALPHA
      GRAD=SQRT(DUDX**2+DUDY**2)
      IF(GRAD.EQ.0) THEN
        WELLCP=.TRUE.
        GOTO 100
      ENDIF
C
      YMAX=ABS(QW)/(2*GRAD)
      YMIN=-ABS(QW)/(2*GRAD)
      XMIN=-ABS(QW)/(2*PI*GRAD)
      XX=(XP-XW)*COS(ALPHA)+(YP-YW)*SIN(ALPHA)
      YY=-(XP-XW)*SIN(ALPHA)+(YP-YW)*COS(ALPHA)
      IF(XX.LT.XMIN) THEN
        ICAP=0
      ELSEIF(YY.GT.YMAX.OR.YY.LT.YMIN) THEN
        ICAP=0
      ELSE
        IF(YY.EQ.0) THEN
          X0=XMIN
        ELSE
          X0=YY/TAN(-GRAD*YY*2.*PI/ABS(QW))
        ENDIF
        IF(XX.LT.X0) THEN
          ICAP=0
        ELSE
          ICAP=1
        ENDIF
      ENDIF
      IF(ICAP.GT.0) THEN
        WELLCP=.TRUE.
      ELSE
        WELLCP=.FALSE.
      ENDIF
C
  100 RETURN
      END
