      SUBROUTINE OPENFL(IN,FileFormat,ISTAT,FLNAME,IDFL,FINDEX)         !v4.6 added FileFormat
C ******************************************************************
C THIS SUBROUTINE OPENS AN INPUT/OUTPUT FILE ASSOCIATED WITH
C UNIT [IN], STATUS [ISTAT], AND FILE NAME [FLNAME].
C FILE IS OPENED AS 'FORMATTED' IF [IN]>0; 'UNFORMATTED' IF [IN]<0.
C FILE STATUS IS 'OLD' IF [ISTAT]>0; 'NEW' IF <0; 'UNKNOWN' IF =0.
C IF [IDFL]>0, FILE WILL BE GIVEN THE DEFAULT NAME [FLNAME],
C OTHERWISE, THE SUBROUTINE WILL PROPMT FOR THE FILE NAME.
C THE CONTENT OF THE PROMPT IS IN [FINDEX].
C ******************************************************************
C last modified: 17-May-1991
C
      INTEGER*4 IN,ISTAT,I,IDFL
      integer*4 FileFormat                                              !v4.6
      CHARACTER FINDEX*30,FLNAME*50,FLFORM*15,FLSTAT*15,flaccess*15     !v4.6
      character exform*1                                                ! format of external file
C
      IF(ISTAT.GT.0) THEN
        FLSTAT='OLD'
      ELSEIF(ISTAT.LT.0) THEN
        FLSTAT='NEW'
      ELSEIF(ISTAT.EQ.0) THEN
        FLSTAT='UNKNOWN'
      ENDIF
  100 FORMAT(1X,'Error: File Cannot Opened on Unit 0.')
C
C--GET FILE NAME IF NO DEFAULT NAME GIVEN
      IF(IDFL.GT.0) GOTO 200
C
      IF(FINDEX.EQ.' ') THEN
        IF(IN.GT.0) WRITE(*,101) IN
        IF(IN.LT.0) WRITE(*,102) -IN
      ELSE
        WRITE(*,103) FINDEX
      ENDIF
   10 READ(*,'(A50)') FLNAME
      IF(FLNAME.EQ.' ') THEN
        WRITE(*,*) 'Error: File Name Not Given.'
        WRITE(*,*) 'Please Try Again =>'
        GOTO 10
      ENDIF
  101 FORMAT(1X,'Enter Name of Formatted File for Unit',I3,': ')
  102 FORMAT(1X,'Enter Name of Unformatted File for Unit',I3,': ')
  103 FORMAT(1X,'Enter Name for ',A30)

C--DETERMINE FILE FORM AND STATUS
  200 Select Case (FileFormat)
          Case (1)
c         Unformatted Sequential
              FLFORM='UNFORMATTED'
              flaccess='sequential'

          Case (2)
c         Unformatted Transparent (TRUE BINARY)
              FLFORM='UNFORMATTED'
              flaccess='transparent'

          Case (3)
c         Formatted Sequential
              FLFORM='FORMATTED'
              flaccess='sequential'

          Case (4)
c         Prompt user for file format
              FLFORM='UNFORMATTED'
              write(*,104) -IN
              WRITE(*,*) 'Enter U if the external file is UNFORMATTED;'
              write(*,*) 'Enter B in the external file is TRUE BINARY;'
              write(*,*)
              READ(*,'(A1)') EXFORM
              IF(EXFORM.EQ.'U'.OR.EXFORM.EQ.'u') THEN                   ! Unformatted
                  flaccess='sequential'
              ELSEIF(EXFORM.eq.'B'.or.EXFORM.eq.'b') then               ! True Binary
                  flaccess='transparent'
              ENDIF
  104 FORMAT(1X,'Enter Format of Unformatted File for Unit',I3,': ')

          Case Default
c         Inappropriate Input
          WRITE(*,100)
          STOP
      End Select

C
C--OPEN FILE
      I=INDEX(FLNAME,' ')-1
      OPEN(ABS(IN),FILE=FLNAME(1:I),ERR=20,
     &  FORM=FLFORM,access=flaccess,STATUS=FLSTAT)                      !v4.6 added access spec.
      GOTO 30
   20 IF(IDFL.GT.0) THEN
        WRITE(*,2) FLNAME
        STOP
      ELSE
        WRITE(*,3) FLNAME
        GOTO 10
      ENDIF
    2 FORMAT(1X,'Error: File Cannot Be Found or Opened =>',A50)
    3 FORMAT(1X,'Error: File Cannot Be Found or Opened =>',A50
     &      /1X,'Please Try Again =>')
C
C--FILE OPENED SUCCESSFUL, REWIND AND RETURN
   30 REWIND (ABS(IN))
      RETURN
      END
C
C
      SUBROUTINE IARRAY(IA,ANAME,II,JJ,K,IN,IOUT)
C ************************************************************
C THIS SUBROUTINE IS USED TO INPUT 1 OR 2D INTEGER ARRAYS
C BY BLOCK, ZONAL, LIST-DIRECTED, UNFORMATTED,
C OR ANY USER-SPECIFIED FORMAT.
C ************************************************************
C last modified: 17-May-1991
c JPK 2005 08 15 : Added change in how external unformatted array is read
C
      PARAMETER (NZMAX=200)
      INTEGER*4 IA,II,JJ,K,IN,IOUT,IZV,IREAD,ICONST,IPRN,
     &          NBLOCK,NZONES,I1,I2,J1,J2,IZ,NN,I,J,N
      LOGICAL*4 OPD
      CHARACTER ANAME*24,FMTIN*20,FINDEX*30,FLNAME*50
      DIMENSION IA(JJ,II),IZV(NZMAX)
      integer*4 tmpkper,tmpkstp,tmpncol,tmpnrow,tmpnlay                 !v4.6
      real*4 tmppertim,tmptotim                                         !v4.6
      character*16 tmptext                                              !v4.6
C
C--READ ARRAY CONTROL RECORD
C  =========================
      READ (IN,1) IREAD,ICONST,FMTIN,IPRN
    1 FORMAT(I10,I10,A20,I10)
C
C--IF IREAD=0, SET ALL ARRAY VALUES EQUAL TO ICONST.
C  =================================================
      IF(IREAD.NE.0) GOTO 50
C
      DO 10 I=1,II
        DO 12 J=1,JJ
          IA(J,I)=ICONST
   12   CONTINUE
   10 CONTINUE
      IF(K.GT.0) WRITE(IOUT,14) ANAME,ICONST,K
   14 FORMAT(39X,A24,' =',I15,' FOR LAYER',I3)
      IF(K.LE.0) WRITE(IOUT,16) ANAME,ICONST
   16 FORMAT(39X,A24,' =',I15)
      GOTO 500
C
C--IF IREAD=100, INPUT ARRAY USING FORMAT FMTIN
C  ============================================
   50 IF(IREAD.NE.100) GOTO 90
C
      IF(K.GT.0) WRITE(IOUT,20) ANAME,K,IN,FMTIN
      IF(K.LE.0) WRITE(IOUT,22) ANAME,IN,FMTIN
   20 FORMAT(/21X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING FORMAT: "',A20,'"'/21X,90('-'))
   22 FORMAT(/27X,A24,' READ ON UNIT',
     & I3,' USING FORMAT: "',A20,'"'/27X,77('-'))
      DO 30 I=1,II
        READ (IN,FMTIN) (IA(J,I),J=1,JJ)
   30 CONTINUE
      GOTO 300
C
C--IF IREAD=101, INPUT ARRAY USING BLOCK FORMAT
C  ============================================
   90 IF(IREAD.NE.101) GOTO 100
C
      IF(K.GT.0) WRITE(IOUT,55) ANAME,K,IN
      IF(K.LE.0) WRITE(IOUT,60) ANAME,IN
   55 FORMAT(/29X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING BLOCK FORMAT'/29X,72('-'))
   60 FORMAT(/35X,A24,' READ ON UNIT',
     & I3,' USING BLOCK FORMAT'/35X,59('-'))
C
C--READ NUMBER OF BLOCKS
      READ(IN,*) NBLOCK
C
C--READ VALUE OF EACH BLOCK
C--AND ASSIGN VALUE TO CELLS WITHIN THE BLOCK
      DO 70 N=1,NBLOCK
        READ(IN,*) I1,I2,J1,J2,IZ
        DO 72 I=I1,I2
          DO 74 J=J1,J2
            IA(J,I)=IZ
   74     CONTINUE
   72   CONTINUE
   70 CONTINUE
      GOTO 300
C
C--IF IREAD=102, INPUT ARRAY USING ZONAL FORMAT
C  ============================================
  100 IF(IREAD.NE.102) GOTO 200
C
      IF(K.GT.0) WRITE(IOUT,150) ANAME,K,IN
      IF(K.LE.0) WRITE(IOUT,160) ANAME,IN
  150 FORMAT(/29X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING ZONAL FORMAT'/29X,72('-'))
  160 FORMAT(/35X,A24,' READ ON UNIT',
     & I3,' USING ZONAL FORMAT'/35X,59('-'))
C
C--READ NUMBER OF ZONES
      READ(IN,*) NZONES
      IF(NZONES.GT.NZMAX) THEN
        WRITE(IOUT,165)
        STOP
      ENDIF
  165 FORMAT(1X,'ERROR: MAXIMUM NUMBER OF ZONES EXCEEDED'
     & /1X,'PLEASE INCREASE [NZMAX] IN SUBROUTINE [IARRAY]')
C
C--READ ZONAL MAP WITH FORMAT FMTIN
      READ(IN,*) (IZV(N),N=1,NZONES)
      DO 175 I=1,II
        READ(IN,FMTIN) (IA(J,I),J=1,JJ)
  175 CONTINUE
C
C--ASSIGN ZONAL VALUES
      DO 176 I=1,II
        DO 177 J=1,JJ
          NN=IA(J,I)
          IF(NN.EQ.0) THEN
            IA(J,I)=0
          ELSE
            IA(J,I)=IZV(NN)
          ENDIF
  177   CONTINUE
  176 CONTINUE
      GOTO 300
C
C--IF IREAD=103, INPUT ARRAY USING FREE FORMAT
C  ===========================================
  200 IF(IREAD.NE.103) GOTO 250
C
      IF(K.GT.0) WRITE(IOUT,210) ANAME,K,IN
      IF(K.LE.0) WRITE(IOUT,220) ANAME,IN
  210 FORMAT(/29X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING FREE FORMAT'/29X,71('-'))
  220 FORMAT(/35X,A24,' READ ON UNIT',
     & I3,' USING FREE FORMAT'/35X,58('-'))
C
C--READ ARRAY VALUES WITH FREE FORMAT
      READ(IN,*) ((IA(J,I),J=1,JJ),I=1,II)
      GOTO 300
C
C--IF IREAD IS EQUAL TO ANY OTHER VALUES,
C--READ ARRAY VALUES FROM AN EXTERNAL FILE ON UNIT [IREAD]
C  =======================================================
C
C--CHECK IF THE EXTERNAL FILE HAS BEEN OPENED.  IF NOT, OPEN
  250 INQUIRE(UNIT=IABS(IREAD),OPENED=OPD)
      IF(.NOT.OPD) THEN
        FINDEX=' '
        if (iread .lt. 0) then
          CALL OPENFL(IREAD,4,1,FLNAME,0,FINDEX)                        !JPK fileformat = 4
        else                                                            !v4.6
          CALL OPENFL(IREAD,3,1,FLNAME,0,FINDEX)                        !v4.6
        end if                                                          !v4.6
      ENDIF
C
C--IF IREAD<0, INPUT ARRAY FROM AN UNFORMATTED FILE OM UNIT [-IREAD]
      IF(IREAD.LT.0) THEN
        IF(K.GT.0) WRITE(IOUT,256) ANAME,K,-IREAD
        IF(K.LE.0) WRITE(IOUT,258) ANAME,-IREAD
  256   FORMAT(/33X,A24,' FOR LAYER',I3,' READ UNFORMATTED',
     &  ' ON UNIT',I3/33X,65('-'))
  258   FORMAT(/40X,A24,' READ UNFORMATTED ON UNIT',
     &  I3/40X,52('-'))
C
C--READ AN UNFORMATTED DUMMY RECORD FIRST.
c  v4.6 need to read these records explicitly because BINARY format does
c       not write CR to files
        READ(-IREAD) tmpkstp,tmpkper,tmppertim,tmptotim,tmptext,        !v4.6
     &               tmpncol,tmpnrow,tmpilay                            !v4.6
        READ(-IREAD) IA
      ELSE
C
C--ELSE IF IREAD>0, INPUT ARRAY FROM AN FORMATTED FILE ON UNIT [IREAD]
C--WITH FORMAT FMTIN
        IF(K.GT.0) WRITE(IOUT,20) ANAME,K,IREAD,FMTIN
        IF(K.LE.0) WRITE(IOUT,22) ANAME,IREAD,FMTIN
        DO 270 I=1,II
          READ (IREAD,FMTIN) (IA(J,I),J=1,JJ)
  270   CONTINUE
      ENDIF
C
C--IF ICONST NOT ZERO THEN MULTIPLY ARRAY VALUES BY ICONST.
  300 IF(ICONST.EQ.0) GO TO 320
      DO 302 I=1,II
      DO 304 J=1,JJ
        IA(J,I)=IA(J,I)*ICONST
  304 CONTINUE
  302 CONTINUE
C
C--IF PRINT CODE (IPRN) =>0 THEN PRINT ARRAY VALUES
CJPK  320 GOTO 500                                                      ! jpk There is a problem in the iprint subroutine, so don't use it
  320 IF(IPRN.LT.0) GOTO 500
      CALL IPRINT(IA,ANAME,0,0,0,JJ,II,0,IPRN,IOUT)
C
C--RETURN
  500 RETURN
      END
C
C
      SUBROUTINE RARRAY(A,ANAME,II,JJ,K,IN,IOUT)
C ********************************************************
C THIS SUBROUTINE IS USED TO INPUT 1 OR 2D REAL ARRAYS,
C BY BLOCK, ZONAL, LIST-DIRECTED, UNFORMATTED,
C OR ANY USER-SPECIFIED FORMAT.
C ********************************************************
C last modified: 17-May-1990
c JPK 2005 08 15 : Added change in how external unformatted array is read
C
      PARAMETER (NZMAX=200)
      INTEGER*4 II,JJ,K,IN,IOUT,IREAD,IPRN,
     &          NBLOCK,NZONES,I1,I2,J1,J2,NN
      REAL*4    A,ZV,CONST,ZZ
      LOGICAL*4 OPD
      CHARACTER ANAME*24,FMTIN*20,FINDEX*30,FLNAME*50
      DIMENSION A(JJ,II),ZV(NZMAX)
      integer*4 tmpkper,tmpkstp,tmpncol,tmpnrow,tmpnlay                 !v4.6
      real*4 tmppertim,tmptotim                                         !v4.6
      character*16 tmptext                                              !v4.6

C
C--READ ARRAY CONTROL RECORD
C  =========================
      READ (IN,1) IREAD,CONST,FMTIN,IPRN
    1 FORMAT(I10,F10.0,A20,I10)
C
C--IF IREAD=0, SET ALL ARRAY VALUES EQUAL TO CONST.
C  ================================================
      IF(IREAD.NE.0) GOTO 50
C
      DO 10 I=1,II
        DO 12 J=1,JJ
          A(J,I)=CONST
   12   CONTINUE
   10 CONTINUE
      IF(K.GT.0) WRITE(IOUT,14) ANAME,CONST,K
   14 FORMAT(39X,A24,' =',G15.7,' FOR LAYER',I3)
      IF(K.LE.0) WRITE(IOUT,16) ANAME,CONST
   16 FORMAT(39X,A24,' =',G15.7)
      GOTO 500
C
C--IF IREAD=100, INPUT ARRAY USING FORMAT FMTIN
C  ============================================
   50 IF(IREAD.NE.100) GOTO 90
C
      IF(K.GT.0) WRITE(IOUT,20) ANAME,K,IN,FMTIN
      IF(K.LE.0) WRITE(IOUT,22) ANAME,IN,FMTIN
   20 FORMAT(/21X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING FORMAT: "',A20,'"'/21X,90('-'))
   22 FORMAT(/27X,A24,' READ ON UNIT',
     & I3,' USING FORMAT: "',A20,'"'/27X,77('-'))
      DO 30 I=1,II
        READ (IN,FMTIN) (A(J,I),J=1,JJ)
   30 CONTINUE
      GOTO 300
C
C--IF IREAD=101, INPUT ARRAY USING BLOCK FORMAT
C  ============================================
   90 IF(IREAD.NE.101) GOTO 100
C
      IF(K.GT.0) WRITE(IOUT,55) ANAME,K,IN
      IF(K.LE.0) WRITE(IOUT,60) ANAME,IN
   55 FORMAT(/29X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING BLOCK FORMAT'/29X,72('-'))
   60 FORMAT(/35X,A24,' READ ON UNIT',
     & I3,' USING BLOCK FORMAT'/35X,59('-'))
C
C--READ NUMBER OF BLOCKS
      READ(IN,*) NBLOCK
C
C--READ VALUE OF EACH BLOCK
C--AND ASSIGN VALUE TO CELLS WITHIN THE BLOCK
      DO 70 N=1,NBLOCK
        READ(IN,*) I1,I2,J1,J2,ZZ
        DO 72 I=I1,I2
          DO 74 J=J1,J2
            A(J,I)=ZZ
   74     CONTINUE
   72   CONTINUE
   70 CONTINUE
      GOTO 300
C
C--IF IREAD=102, INPUT ARRAY USING ZONAL FORMAT
C  ============================================
  100 IF(IREAD.NE.102) GOTO 200
C
      IF(K.GT.0) WRITE(IOUT,150) ANAME,K,IN
      IF(K.LE.0) WRITE(IOUT,160) ANAME,IN
  150 FORMAT(/29X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING ZONAL FORMAT'/29X,72('-'))
  160 FORMAT(/35X,A24,' READ ON UNIT',
     & I3,' USING ZONAL FORMAT'/35X,59('-'))
C
C--READ NUMBER OF ZONES
      READ(IN,*) NZONES
      IF(NZONES.GT.NZMAX) THEN
        WRITE(IOUT,165)
        STOP
      ENDIF
  165 FORMAT(1X,'ERROR: MAXIMUM NUMBER OF ZONES EXCEEDED'
     & /1X,'PLEASE INCREASE [NZMAX] IN SUBROUTINE [RARRAY]')
C
C--READ ZONAL MAP WITH FORMAT FMTIN
      READ(IN,*) (ZV(N),N=1,NZONES)
      DO 175 I=1,II
        READ(IN,FMTIN) (A(J,I),J=1,JJ)
  175 CONTINUE
C
C--ASSIGN ZONAL VALUES
      DO 176 I=1,II
        DO 177 J=1,JJ
          NN=A(J,I)
          IF(NN.EQ.0) THEN
            A(J,I)=0
          ELSE
            A(J,I)=ZV(NN)
          ENDIF
  177   CONTINUE
  176 CONTINUE
      GOTO 300
C
C--IF IREAD=103, INPUT ARRAY USING FREE FORMAT
C  ===========================================
  200 IF(IREAD.NE.103) GOTO 250
C
      IF(K.GT.0) WRITE(IOUT,210) ANAME,K,IN
      IF(K.LE.0) WRITE(IOUT,220) ANAME,IN
  210 FORMAT(/29X,A24,' FOR LAYER',I3,' READ ON UNIT',
     & I3,' USING FREE FORMAT'/29X,71('-'))
  220 FORMAT(/35X,A24,' READ ON UNIT',
     & I3,' USING FREE FORMAT'/35X,58('-'))
C
C--READ ARRAY VALUES WITH FREE FORMAT
      READ(IN,*) ((A(J,I),J=1,JJ),I=1,II)
      GOTO 300
C
C--IF IREAD IS EQUAL TO ANY OTHER VALUES,
C--READ ARRAY VALUES FROM AN EXTERNAL FILE ON UNIT [IREAD]
C  =======================================================
C
C--CHECK IF THE EXTERNAL FILE HAS BEEN OPENED.  IF NOT, OPEN
  250 INQUIRE(UNIT=IABS(IREAD),OPENED=OPD)
      IF(.NOT.OPD) THEN
        FINDEX=' '
        if (iread .lt. 0) then
          CALL OPENFL(IREAD,4,1,FLNAME,0,FINDEX)                        !JPK fileformat = 4
        else                                                            !v4.6
          CALL OPENFL(IREAD,3,1,FLNAME,0,FINDEX)                        !v4.6
        end if                                                          !v4.6
      ENDIF
C
C--IF IREAD<0, INPUT ARRAY FROM AN UNFORMATTED FILE OM UNIT [-IREAD]
      IF(IREAD.LT.0) THEN
        IF(K.GT.0) WRITE(IOUT,256) ANAME,K,-IREAD
        IF(K.LE.0) WRITE(IOUT,258) ANAME,-IREAD
  256   FORMAT(/33X,A24,' FOR LAYER',I3,' READ UNFORMATTED',
     &  ' ON UNIT',I3/33X,65('-'))
  258   FORMAT(/40X,A24,' READ UNFORMATTED ON UNIT',
     &  I3/40X,52('-'))
C
C--READ AN UNFORMATTED DUMMY RECORD FIRST.
c  v4.6 need to read these records explicitly because BINARY format does
c       not write CR to files
        READ(-IREAD) tmpkstp,tmpkper,tmppertim,tmptotim,tmptext,        !v4.6
     &               tmpncol,tmpnrow,tmpilay                            !v4.6
        READ(-IREAD) A
      ELSE
C
C--ELSE IF IREAD>0, INPUT ARRAY FROM AN FORMATTED FILE ON UNIT [IREAD]
C--WITH FORMAT FMTIN
        IF(K.GT.0) WRITE(IOUT,20) ANAME,K,IREAD,FMTIN
        IF(K.LE.0) WRITE(IOUT,22) ANAME,IREAD,FMTIN
        DO 270 I=1,II
          READ (IREAD,FMTIN) (A(J,I),J=1,JJ)
  270   CONTINUE
      ENDIF
C
C--IF CONST NOT ZERO THEN MULTIPLY ARRAY VALUES BY CONST.
  300 IF(CONST.EQ.0) GO TO 320
      DO 302 I=1,II
      DO 304 J=1,JJ
        A(J,I)=A(J,I)*CONST
  304 CONTINUE
  302 CONTINUE
C
C--IF PRINT CODE (IPRN) =>0 THEN PRINT ARRAY VALUES.
  320 IF(IPRN.LT.0) RETURN
      CALL RPRINT(A,ANAME,0,0,0,JJ,II,0,IPRN,IOUT)
C
C8------RETURN
  500 RETURN
      END
C
C
      SUBROUTINE IPRINT(IA,TEXT,KTRN,KSTP,KPER,NCOL,NROW,
     & ILAY,IPRN,IOUT)
C ************************************************************
C PRINT AN INTEGER 1 OR 2D ARRAY IN WRAP OR STRIP FORM.
C (Modified from McDonald and Harbaugh, 1988).
C *******************                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 WRITE(IOUT,2) TEXT,ILAY,KTRN,KSTP,KPER
    2 FORMAT(/21X,A16,' IN LAYER',I3,' AT END OF TRANSPORT STEP',I5,
     & ', TIME STEP',I3,', STRESS PERIOD',I3/21X,90('-'))
C
C--MAKE SURE IPRN VALUE IS WITHIN PRINT FORMAT-CODE RANGE
    5 IP=IPRN
      IF(IP.GT.5.OR.IP.LT.-5) IP=0
      IF(IP.GE.0) IP=IP+1
      IF(IP.LT.0) IP=IP-1

      write (*,*) 'iprn = ', ip
C
C--DETERMINE THE NUMBER OF VALUES (NCAP) PRINTED ON ONE LINE,
C--NUMBER OF BLANK SPACES TO LEAVE AT START OF THE LINE (ISP)
C--AND NUMBER OF SPACES IN EACH COLUMN FIELD (NCPF)
c      IF(IABS(IP).EQ.1) THEN
c        NCPF=12
c        ISP=4
c        NCAP=10
c      ELSEIF(IABS(IP).GT.1) THEN
c        NCPF=IABS(IP)
c        ISP=4
c        NCAP=125/IABS(IP)/5*5
c      ENDIF
C
C--IF IP>0, ARRAY IS PRINTED IN WRAP FORMAT
C      IF(IP.GT.0.OR.NCOL.LE.NCAP) THEN
C        NSTRIP=1
C        J1=1
C        J2=NCOL
C
C--ELSE IF IP<0, ARRAY IS PRINTED IN STRIP FORMAT.
C--NUMBER OF STRIPS IS CALCULATED AS [NSTRIP]
C      ELSE
C        NSTRIP=(NCOL-1)/NCAP+1
C        J1=1-NCAP
C        J2=0
C      ENDIF
C
C--LOOP THROUGH THE STRIPS
C      DO 400 N=1,NSTRIP
C
C--CALCULATE FIRST(J1) & LAST(J2) COLUMNS FOR THIS STRIP
C--IF STRIP FORM IS USED
C      IF(NSTRIP.GT.1) THEN
C        J1=J1+NCAP
C        J2=J2+NCAP
C        IF(J2.GT.NCOL) J2=NCOL
C      ENDIF
C
C--PRINT COLUMN NUMBERS ABOVE THE STRIP.
C      CALL UCOLNO(1,NCOL,ISP,NCAP,NCPF,IOUT)
C
C--PRINT EACH ROW
      DO I=1,NROW
C
C--SELECT THE FORMAT
      select case (iabs(ip))
c        GOTO (401,402,403,404,405,406), IABS(IP)
C
C--FORMAT 10I11
      case(1)
  401   IF(IP.GT.0) WRITE(IOUT,1001) I,(IA(J,I),J=1,NCOL)
c        IF(IP.LT.0) WRITE(IOUT,2001) I,(IA(J,I),J=1,NCOL)
 1001   FORMAT(1X,I3,2X,I11,9(1X,I11):/(5X,10(1X,I11)))
c 2001   FORMAT(1X,I3,2X,I11,9(1X,I11))
c        GO TO 410
C
C--FORMAT 60I1
      case(2)
  402   IF(IP.GT.0) WRITE(IOUT,1002) I,(IA(J,I),J=1,NCOL)
c        IF(IP.LT.0) WRITE(IOUT,2002) I,(IA(J,I),J=1,NCOL)
 1002   FORMAT(1X,I3,1X,60(1X,I1):/(5X,60(1X,I1)))
c 2002   FORMAT(1X,I3,1X,60(1X,I1))
c        GO TO 410

C
C--FORMAT 40I2
      case(3)
  403   IF(IP.GT.0) WRITE(IOUT,1003) I,(IA(J,I),J=1,NCOL)
c        IF(IP.LT.0) WRITE(IOUT,2003) I,(IA(J,I),J=1,NCOL)
 1003   FORMAT(1X,I3,1X,40(1X,I2):/(5X,40(1X,I2)))
c 2003   FORMAT(1X,I3,1X,40(1X,I2))
c        GO TO 410
C
C--FORMAT 30I3
      case(4)
  404   IF(IP.GT.0) WRITE(IOUT,1004) I,(IA(J,I),J=1,NCOL)
c        IF(IP.LT.0) WRITE(IOUT,2004) I,(IA(J,I),J=1,NCOL)
 1004   FORMAT(1X,I3,1X,30(1X,I3):/(5X,30(1X,I3)))
c 2004   FORMAT(1X,I3,1X,30(1X,I3))
c        GO TO 410
C
C--FORMAT 25I4
      case(5)
  405   IF(IP.GT.0) WRITE(IOUT,1005) I,(IA(J,I),J=1,NCOL)
c        IF(IP.LT.0) WRITE(IOUT,2005) I,(IA(J,I),J=1,NCOL)
 1005   FORMAT(1X,I3,1X,25(1X,I4):/(5X,25(1X,I4)))
c 2005   FORMAT(1X,I3,1X,25(1X,I4))
c        GO TO 410
C
C--FORMAT 20I5
      case(6)
      write (*,*) 'format = 20I5'
      write (*,*) 'row ',i
c  406   IF(IP.GT.0) then
          WRITE(IOUT,1006) I,(IA(J,I),J=1,20)
          write(iout,1007) (IA(J,I),J=21,NCOL)
c        endif

c        IF(IP.LT.0) WRITE(IOUT,2006) I,(IA(J,I),J=1,NCOL)
 1006   FORMAT(1X,I3,1X,20(1X,I5))
 1007   FORMAT(5X,20(1X,I5))
c 2006   FORMAT(1X,I3,1X,20(1X,I5))
        end select
      enddo
C
C 400 CONTINUE
C
C--RETURN
      RETURN
      END
C
C
      SUBROUTINE RPRINT(BUFF,TEXT,KTRN,KSTP,KPER,NCOL,NROW,
     & ILAY,IPRN,IOUT)
C ****************************************************************
C PRINT A REAL 1 OR 2D ARRAY IN WRAP OR STRIP FORM.
C (Modified from McDonald and Harbaugh, 1988).
C ****************************************************************
C last modified: 14-Oct-1990
C
      IMPLICIT  NONE
      INTEGER*4 KTRN,KSTP,KPER,NCOL,NROW,ILAY,IPRN,IOUT,IP,J,I,
     &          J1,J2,NCPF,NCAP,NSTRIP,ISP,N
      REAL*4    BUFF
      CHARACTER TEXT*16
      DIMENSION BUFF(NCOL,NROW)
C
C--PRINT A HEADER
      IF(ILAY.LE.0) GO TO 5
      IF(KTRN.GT.0) GO TO 4
      WRITE(IOUT,1) TEXT,ILAY,KSTP,KPER
    1 FORMAT(/35X,A16,' IN LAYER',I3,
     & ' FOR TIME STEP',I3,', STRESS PERIOD',I3/35X,63('-'))
      GOTO 5
C
    4 WRITE(IOUT,2) TEXT,ILAY,KTRN,KSTP,KPER
    2 FORMAT(/21X,A16,' IN LAYER',I3,' AT END OF TRANSPORT STEP',I5,
     & ', TIME STEP',I3,', STRESS PERIOD',I3/21X,90('-'))
C
C--MAKE SURE IPRN VALVE IS WITHIN PRINT-FORMAT CODE RANGE
    5 IP=IPRN
      IF(IP.GT.12) IP=12
      IF(IP.LT.-12) IP=-12
      IF(IP.EQ.0) IP=12
C
C--DETERMINE THE NUMBER OF VALUES (NCAP) PRINTED ON ONE LINE,
C--NUMBER OF BLANK SPACES TO LEAVE AT START OF THE LINE (ISP)
C--AND NUMBER OF SPACES IN EACH COLUMN FIELD (NCPF)
      IF(IABS(IP).EQ.1) NCAP=11
      IF(IABS(IP).EQ.2) NCAP=9
      IF(IABS(IP).GT.2 .AND. IABS(IP).LT.7) NCAP=15
      IF(IABS(IP).GT.6 .AND. IABS(IP).LT.12) NCAP=20
      IF(IABS(IP).EQ.12) NCAP=10
      NCPF=129/NCAP
      ISP=0
      IF(NCAP.GT.12) ISP=3
C
C--IF IP>0, ARRAY IS PRINTED IN WRAP FORM
      IF(IP.GT.0.OR.NCOL.LE.NCAP) THEN
        NSTRIP=1
        J1=1
        J2=NCOL
C
C--ELSE IF IP<0, ARRAY IS PRINTED IN STRIP FORM.
C--NUMBER OF STRIPS IS CALCULATED AS [NSTRIP]
      ELSE
        NSTRIP=(NCOL-1)/NCAP + 1
        J1=1-NCAP
        J2=0
      ENDIF
C
C--LOOP THROUGH THE STRIPS
      DO 2000 N=1,NSTRIP
C
C--CALCULATE FIRST(J1) & LAST(J2) COLUMNS FOR THIS STRIP
C--IF STRIP FORM IS USED
      IF(NSTRIP.GT.1) THEN
        J1=J1+NCAP
        J2=J2+NCAP
        IF(J2.GT.NCOL) J2=NCOL
      ENDIF
C
C--PRINT COLUMN NUMBERS ABOVE THE STRIP
      CALL UCOLNO(J1,J2,ISP,NCAP,NCPF,IOUT)
C
C--LOOP THROUGH THE ROWS PRINTING COLS J1 THRU J2 WITH FORMAT IP
      DO 1000 I=1,NROW
      GO TO(10,20,30,40,50,60,70,80,90,100,110,120), IABS(IP)
C
C--FORMAT 11G10.3
   10 IF(IP.GT.0) WRITE(IOUT,11) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,12) I,(BUFF(J,I),J=J1,J2)
   11 FORMAT(1X,I3,2X,1PG10.3,10(1X,G10.3)/(5X,11(1X,G10.3)))
   12 FORMAT(1X,I3,2X,1PG10.3,10(1X,G10.3))
      GO TO 1000
C
C--FORMAT 9G13.6
   20 IF(IP.GT.0) WRITE(IOUT,21) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,22) I,(BUFF(J,I),J=J1,J2)
   21 FORMAT(1X,I3,2X,1PG13.6,8(1X,G13.6)/(5X,9(1X,G13.6)))
   22 FORMAT(1X,I3,2X,1PG13.6,8(1X,G13.6))
      GO TO 1000
C
C--FORMAT 15F7.1
   30 IF(IP.GT.0) WRITE(IOUT,31) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,32) I,(BUFF(J,I),J=J1,J2)
   31 FORMAT(1X,I3,1X,15(1X,F7.1)/(5X,15(1X,F7.1)))
   32 FORMAT(1X,I3,1X,15(1X,F7.1))
      GO TO 1000
C
C--FORMAT 15F7.2
   40 IF(IP.GT.0) WRITE(IOUT,41) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,42) I,(BUFF(J,I),J=J1,J2)
   41 FORMAT(1X,I3,1X,15(1X,F7.2)/(5X,15(1X,F7.2)))
   42 FORMAT(1X,I3,1X,15(1X,F7.2))
      GO TO 1000
C
C--FORMAT 15F7.3
   50 IF(IP.GT.0) WRITE(IOUT,51) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,52) I,(BUFF(J,I),J=J1,J2)
   51 FORMAT(1X,I3,1X,15(1X,F7.3)/(5X,15(1X,F7.3)))
   52 FORMAT(1X,I3,1X,15(1X,F7.3))
      GO TO 1000
C
C--FORMAT 15F7.4
   60 IF(IP.GT.0) WRITE(IOUT,61) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,62) I,(BUFF(J,I),J=J1,J2)
   61 FORMAT(1X,I3,1X,15(1X,F7.4)/(5X,15(1X,F7.4)))
   62 FORMAT(1X,I3,1X,15(1X,F7.4))
      GO TO 1000
C
C--FORMAT 20F5.0
   70 IF(IP.GT.0) WRITE(IOUT,71) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,72) I,(BUFF(J,I),J=J1,J2)
   71 FORMAT(1X,I3,1X,20(1X,F5.0)/(5X,20(1X,F5.0)))
   72 FORMAT(1X,I3,1X,20(1X,F5.0))
      GO TO 1000
C
C--FORMAT 20F5.1
   80 IF(IP.GT.0) WRITE(IOUT,81) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,82) I,(BUFF(J,I),J=J1,J2)
   81 FORMAT(1X,I3,1X,20(1X,F5.1)/(5X,20(1X,F5.1)))
   82 FORMAT(1X,I3,1X,20(1X,F5.1))
      GO TO 1000
C
C--FORMAT 20F5.2
   90 IF(IP.GT.0) WRITE(IOUT,91) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,92) I,(BUFF(J,I),J=J1,J2)
   91 FORMAT(1X,I3,1X,20(1X,F5.2)/(5X,20(1X,F5.2)))
   92 FORMAT(1X,I3,1X,20(1X,F5.2))
      GO TO 1000
C
C--FORMAT 20F5.3
  100 IF(IP.GT.0) WRITE(IOUT,101) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,102) I,(BUFF(J,I),J=J1,J2)
  101 FORMAT(1X,I3,1X,20(1X,F5.3)/(5X,20(1X,F5.3)))
  102 FORMAT(1X,I3,1X,20(1X,F5.3))
      GO TO 1000
C
C--FORMAT 20F5.4
  110 IF(IP.GT.0) WRITE(IOUT,111) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,112) I,(BUFF(J,I),J=J1,J2)
  111 FORMAT(1X,I3,1X,20(1X,F5.4)/(5X,20(1X,F5.4)))
  112 FORMAT(1X,I3,1X,20(1X,F5.4)/(5X,20(1X,F5.4)))
      GO TO 1000
C
C--FORMAT 10G11.4
  120 IF(IP.GT.0) WRITE(IOUT,121) I,(BUFF(J,I),J=J1,J2)
      IF(IP.LT.0) WRITE(IOUT,122) I,(BUFF(J,I),J=J1,J2)
  121 FORMAT(1X,I3,2X,1PG11.4,9(1X,G11.4)/(5X,10(1X,G11.4)))
  122 FORMAT(1X,I3,2X,1PG11.4,9(1X,G11.4))
C
 1000 CONTINUE
 2000 CONTINUE
C
C--RETURN
      RETURN
      END
C
C
      SUBROUTINE UCOLNO(NLBL1,NLBL2,NSPACE,NCPL,NDIG,IOUT)
C ****************************************************************
C OUTPUT COLUMN NUMBERS ABOVE A MATRIX PRINTOUT.
C (Modified from McDonald and Harbaugh, 1988).
C ****************************************************************
C last modified: 14-Oct-1990
C
      IMPLICIT  NONE
      INTEGER*4 NLBL1,NLBL2,NSPACE,NCPL,NDIG,IOUT,N,
     &          J1,J2,J,I1,I2,I3,I,NTOT,NWRAP,NBF,NLBL
      CHARACTER DOT*4,SPACE*4,DG*4,BF*4
      DIMENSION BF(130),DG(10)
C
C--ASSIGN CHARACTER STRING
      DG(1)='0   '
      DG(2)='1   '
      DG(3)='2   '
      DG(4)='3   '
      DG(5)='4   '
      DG(6)='5   '
      DG(7)='6   '
      DG(8)='7   '
      DG(9)='8   '
      DG(10)='9   '
      DOT='.  '
      SPACE='    '
C
C--CALCULATE # OF COLUMNS TO BE PRINTED (NLBL), WIDTH
C--OF A LINE (NTOT), NUMBER OF LINES (NWRAP).
      WRITE(IOUT,1)
    1 FORMAT(1X)
      NLBL=NLBL2-NLBL1+1
      N=NLBL
      IF(NLBL.GT.NCPL) N=NCPL
      NTOT=NSPACE+N*NDIG
      IF(NTOT.GT.130) GO TO 50
      NWRAP=(NLBL-1)/NCPL + 1
      J1=NLBL1-NCPL
      J2=NLBL1-1
C
C--BUILD AND PRINT EACH LINE
      DO 40 N=1,NWRAP
C
C--CLEAR THE BUFFER (BF).
      DO 20 I=1,130
      BF(I)=SPACE
   20 CONTINUE
      NBF=NSPACE
C
C--DETERMINE FIRST (J1) AND LAST (J2) COLUMN # FOR THIS LINE.
      J1=J1+NCPL
      J2=J2+NCPL
      IF(J2.GT.NLBL2) J2=NLBL2
C
C--LOAD THE COLUMN #'S INTO THE BUFFER.
      DO 30 J=J1,J2
      NBF=NBF+NDIG
      I2=J/10
      I1=J-I2*10+1
      BF(NBF)=DG(I1)
      IF(I2.EQ.0) GO TO 30
      I3=I2/10
      I2=I2-I3*10+1
      BF(NBF-1)=DG(I2)
      IF(I3.EQ.0) GO TO 30
      BF(NBF-2)=DG(I3+1)
   30 CONTINUE
C
C--PRINT THE CONTENTS OF THE BUFFER (I.E. PRINT THE LINE).
      WRITE(IOUT,31) (BF(I),I=1,NBF)
   31 FORMAT(1X,130A1)
C
   40 CONTINUE
C
C--PRINT A LINE OF DOTS (FOR ESTHETIC PURPOSES ONLY).
   50 NTOT=NTOT+5
      IF(NTOT.GT.130) NTOT=130
      WRITE(IOUT,51) (DOT,I=1,NTOT)
   51 FORMAT(1X,130A1)
C
C--RETURN
      RETURN
      END


      function fmtreal(outputvalue)
c this function determines the best output format for a real number
c based on an record length of 10
      character*6 fmtreal
      real outputvalue
      integer jchk

      jchk=ifix(alog10(abs(outputvalue)))
                select case (jchk)
                        case (7:)
                                fmtreal='es10.2'
                        case (6)
                                fmtreal=' f10.1'
                        case(5)
                                fmtreal=' f10.2'
                        case(4)
                                fmtreal=' f10.3'
                        case(3)
                                fmtreal=' f10.4'
                        case(2)
                                fmtreal=' f10.5'
                        case(-1:1)
                                fmtreal=' f10.6'
                        case(-4:-2)
                                fmtreal=' f10.7'
                        case(:-5)
                                fmtreal='es10.2'
                end select
      end function fmtreal


      subroutine reverseHeads(INH,inbas,NCOL,NROW,NLAY,HDFORM,nsper)
C *************************************************************
C THIS SUBROUTINE READS HEAD FILE SAVED BY THE FLOW MODEL and
c reverses it for use with reverse transient tracking
C *************************************************************
C
      CHARACTER*80 HDFORM
      character*6 fmtreal
      COMMON /CONST/ROERR,TINY,IOPSS,SAFETY
      COMMON /DRY/HDRY,IWDFLG
      integer nsper,inbas,totalsteps,maxtimesteps,totalheads
      integer nstp(nsper),tmpnrow,tmpncol
      integer(kind=4),allocatable :: tmpkper(:,:,:),tmpkstp(:,:,:),
     +  tmpilay(:,:,:)
      real(kind=4), allocatable :: tmppertim(:,:,:),tmptotim(:,:,:)     !v4.6
      character*16 tmptext
      real(kind=4), allocatable :: heads(:,:,:,:,:)
      real perlen(nsper),tsmult(nsper)
      DATA HCNV/888.88/

c   read stress period/time step paramters from BAS file in order to
c   allocate arrays
      totalsteps=0
      maxtimesteps=0
      totim=0
      do nnn=1,nsper
          READ(INBAS,'(F10.0,I10.0,F10.0)')
     +        PERLEN(nnn),NSTP(nnn),TSMULT(nnn)
          totalsteps=totalsteps+nstp(nnn)
          totim=totim+perlen(nnn)
          if (nstp(nnn) .gt. maxtimesteps) then
               maxtimesteps=nstp(nnn)
          end if
      end do
      open(98,file='$~temp.bas',status='unknown')
      do nnn=nsper,1,-1
          write(98,'('//fmtreal(perlen(nnn))//',i10,'//
     +     fmtreal(tsmult(nnn))//','//fmtreal(totim)//')')
     +      perlen(nnn),nstp(nnn),tsmult(nnn),totim
          totim=totim-perlen(nnn)
      end do
      close(98)
      close(inbas)
      open(inbas,file='$~temp.bas',status='old')
      totalheads=totalsteps*nlay
      allocate(tmpkper(nlay,maxtimesteps,nsper),
     +         tmpkstp(nlay,maxtimesteps,nsper),
     +         tmpilay(nlay,maxtimesteps,nsper),
     +         tmppertim(nlay,maxtimesteps,nsper),
     +         tmptotim(nlay,maxtimesteps,nsper),
     +         heads(ncol,nrow,nlay,maxtimesteps,nsper))
C
C--IF HDFORM WAS ASSIGNED 'U', READ HEADS UNFORMATTED;
C--OTHERWISE, READ HEAD FILE WITH FORMAT GIVEN BY HDFORM
      LEN=INDEX(HDFORM,' ')-1
      IF(HDFORM(1:LEN).EQ.'U'.OR.HDFORM.EQ.'u') then
          open(98,file='$~temp.ufh',status='unknown',form='unformatted')
      else if(hdform.eq.'b'.or.hdform.eq.'B') then
          open(98,file='$~temp.hds',status='unknown',form='unformatted',
     +      access='transparent')
      else
          open(98,file='$~temp.hds',status='unknown')
      end if
      IF(HDFORM(1:LEN).EQ.'U'.OR.HDFORM.EQ.'u'.or.hdform.eq.'b'         !v4.6
     +    .or.hdform.eq.'B') THEN                                       !v4.6
          do kkk=1,nsper
              do lll=1,nstp(kkk)
                  do nnn=1,nlay
                      read(inh,end=11001) tmpkper(nnn,lll,kkk),
     +                                    tmpkstp(nnn,lll,kkk),
     +                                    tmppertim(nnn,lll,kkk),
     +                                    tmptotim(nnn,lll,kkk),
     +                                    tmptext,tmpnrow,tmpncol,
     +                                    tmpilay(nnn,lll,kkk)
                  read(inh)((heads(j,i,nnn,lll,kkk),j=1,ncol),i=1,nrow)
                  end do
              end do
          end do
          do kkk=nsper,1,-1
              do lll=nstp(kkk),1,-1
                  do nnn=1,nlay
                      if (tmpilay(nnn,lll,kkk).ne.nnn) then
                          goto 11001
                      endif
                      write(98) tmpkper(nnn,lll,kkk),
     +                          tmpkstp(nnn,lll,kkk),
     +                          tmppertim(nnn,lll,kkk),
     +                          tmptotim(nnn,lll,kkk),
     +                          tmptext,tmpnrow,tmpncol,
     +                          tmpilay(nnn,lll,kkk)
                  write(98) ((heads(j,i,nnn,lll,kkk),j=1,ncol),i=1,nrow)
                  end do
              end do
          end do
      else
          do kkk=1,nsper
              do lll=1,nstp(kkk)
                  do nnn=1,nlay
                      do i=1,nrow
           READ(INH,FMT=HDFORM(1:LEN)) (heads(J,I,nnn,lll,kkk),J=1,NCOL)
                      end do
                  end do
              end do
          end do
          do kkk=nsper,1,-1
              do lll=nstp(kkk),1,-1
                  do nnn=1,nlay
                      do i=1,nrow
           write(98,fmt=hdform(1:len)) (heads(j,i,nnn,lll,kkk),j=1,ncol)
                      end do
                  end do
              end do
          end do
      end if
      close(98)
      close(inh)
      IF(HDFORM(1:LEN).EQ.'U'.OR.HDFORM.EQ.'u') then
          open(inh,file='$~temp.ufh',status='old',form='unformatted')
      else if(hdform.eq.'b'.or.hdform.eq.'B') then
          open(inh,file='$~temp.hds',status='old',form='unformatted',
     +      access='transparent')
      else
          open(inh,file='$~temp.hds',status='unknown')
      end if
      goto 11002
11001 print*,'Error occurred while reading heads.'
      stop
11002 RETURN
      END subroutine reverseHeads





      SUBROUTINE reverseSS(nsper,iout,ncol,nrow,mxwel,nwells,well,
     & mxdrn,ndrain,drain,mxriv,nriver,river,mxstr,nstrem,stream,
     & mxghb,nbound,ghbnd,nrchop,irch,rech,nevtop,ievt,evtr,exdp,surf)
C **********************************************************************
C THIS SUBROUTINE READS INPUT DATA RELATED TO SINKS OR SOURCES,
C INCLUDING WELLS, DRAINS, RIVERS, STREAM, RECHARGE, EVAPOTRANSPORATION,
C OR GENERAL-HEAD BOUNDARY IF THEY ARE PRESENT IN THE HEAD SOLUTION and
c writes them out in reverse for use in transient backward tracking
C **********************************************************************
C     based on subroutine GETSS in P3DDATA3.FOR
c     v4.6 11-Jan-20001
C
c      CHARACTER*24 ANAME(6)
      character*80 dumline
      character*6 fmtreal
      real Stage,Cond,tmp3                                              !v4.6
      integer tmp1,tmp2                                                 !v4.6
      DIMENSION WELL(4,MXWEL),DRAIN(5,MXDRN),RIVER(5,MXRIV),
     & STREAM(5,MXSTR),GHBND(5,MXGHB),RECH(NCOL,NROW),IRCH(NCOL,NROW),
     & IEVT(NCOL,NROW),EVTR(NCOL,NROW),EXDP(NCOL,NROW),
     & SURF(NCOL,NROW)
      COMMON /UNIT/INBCF,INWEL,INDRN,INRIV,INEVT,INGHB,INRCH,INSTR
      COMMON /STR/NSS,NTRIB,NDIV,ICALC
      integer iwel(nsper),idrn(nsper),iriv(nsper),istr(nsper),
     +          ighb(nsper)
      type wellinfo
          integer kk,ii,jj
          real qq
      end type
      type (wellinfo),allocatable :: welltmp(:,:)
      type drninfo
          integer kk,ii,jj
          real stage,cond
      end type
      type(drninfo),allocatable :: drntmp(:,:)
      type rivinfo
          integer kk,ii,jj
          real stage,cond
      end type
      type(rivinfo),allocatable :: rivtmp(:,:)
      type strinfo
          integer kk,ii,jj
          real stage,cond
      end type
      type(strinfo),allocatable :: strtmp(:,:)
      type ghbinfo
          integer kk,ii,jj
          real stage,cond
      end type
      type(ghbinfo),allocatable :: ghbtmp(:,:)
      real, allocatable :: rech1(:,:,:),surf1(:,:,:),evtr1(:,:,:),
     +           exdp1(:,:,:)
      integer, allocatable :: irch1(:,:,:),ievt1(:,:,:)

      IF(INWEL.EQ.0) GOTO 10001                                         ! WELLS
      open(98,file='$~temp.wel',status='unknown')
      allocate(welltmp(mxwel,nsper))
      do nnn=1,nsper
          READ(INWEL,'(I10)') IWEL(nnn)
          IF(IWEL(nnn).GE.0) THEN
              DO I=1,IWEL(nnn)
                  READ(INWEL,'(3I10,F10.0)') welltmp(i,nnn)%kk,
     +            welltmp(i,nnn)%ii,welltmp(i,nnn)%jj,welltmp(i,nnn)%qq
              end do
          ELSE
              iwel(nnn)=iwel(nnn-1)
              do i=1,iwel(nnn)
                  welltmp(i,nnn)%kk=welltmp(i,nnn-1)%kk
                  welltmp(i,nnn)%ii=welltmp(i,nnn-1)%ii
                  welltmp(i,nnn)%jj=welltmp(i,nnn-1)%jj
                  welltmp(i,nnn)%qq=welltmp(i,nnn-1)%qq
              end do
          ENDIF
      end do
      do nnn=nsper,1,-1
          write(98,'(I10)') iwel(nnn)
          do i=1,iwel(nnn)
              write(98,'(3i10,'//fmtreal(welltmp(i,nnn)%qq)//')')
     +            welltmp(i,nnn)%kk,
     +            welltmp(i,nnn)%ii,welltmp(i,nnn)%jj,welltmp(i,nnn)%qq
          end do
      end do
      close(98)
      close(inwel)
      open(inwel,file='$~temp.wel',status='old')
      deallocate(welltmp)

10001 IF(INDRN.EQ.0) then                                               ! DRAINS
          GOTO 10002
      end if
      open(98,file='$~temp.drn',status='unknown')
      allocate(drntmp(mxdrn,nsper))
      do nnn=1,nsper
          READ(INDRN,'(I10)') IDRN(nnn)
          IF(IDRN(nnn).GE.0) THEN
              DO I=1,IDRN(nnn)
                  READ(INDRN,'(3I10,2F10.0)') drntmp(i,nnn)%kk,
     +            drntmp(i,nnn)%ii,drntmp(i,nnn)%jj,drntmp(i,nnn)%stage,
     +            drntmp(i,nnn)%cond
              end do
          ELSE
              idrn(nnn)=idrn(nnn-1)
              do i=1,idrn(nnn)
                  drntmp(i,nnn)%kk=drntmp(i,nnn-1)%kk
                  drntmp(i,nnn)%ii=drntmp(i,nnn-1)%ii
                  drntmp(i,nnn)%jj=drntmp(i,nnn-1)%jj
                  drntmp(i,nnn)%stage=drntmp(i,nnn-1)%stage
                  drntmp(i,nnn)%cond=drntmp(i,nnn-1)%cond
              end do
          ENDIF
      end do
      do nnn=nsper,1,-1
          write(98,'(I10)') idrn(nnn)
          do i=1,idrn(nnn)
              write(98,'(3i10,'//fmtreal(drntmp(i,nnn)%stage)//','//
     +             fmtreal(drntmp(i,nnn)%cond)//')')
     +            drntmp(i,nnn)%kk,drntmp(i,nnn)%ii,drntmp(i,nnn)%jj,
     +            drntmp(i,nnn)%stage,drntmp(i,nnn)%cond
          end do
      end do
      close(98)
      close(indrn)
      open(indrn,file='$~temp.drn',status='old')
      deallocate(drntmp)

10002 IF(INRIV.EQ.0) then                                               ! RIVERS
          GOTO 10003
      end if
      open(98,file='$~temp.riv',status='unknown')
      allocate(rivtmp(mxriv,nsper))
      do nnn=1,nsper
          READ(INRIV,'(I10)') IRIV(nnn)
          IF(IRIV(nnn).GE.0) THEN
              DO I=1,IRIV(nnn)
                  READ(INRIV,'(3I10,2F10.0)') rivtmp(i,nnn)%kk,
     +            rivtmp(i,nnn)%ii,rivtmp(i,nnn)%jj,rivtmp(i,nnn)%stage,
     +            rivtmp(i,nnn)%cond
              end do
          ELSE
              iriv(nnn)=iriv(nnn-1)
              do i=1,iriv(nnn)
                  rivtmp(i,nnn)%kk=rivtmp(i,nnn-1)%kk
                  rivtmp(i,nnn)%ii=rivtmp(i,nnn-1)%ii
                  rivtmp(i,nnn)%jj=rivtmp(i,nnn-1)%jj
                  rivtmp(i,nnn)%stage=rivtmp(i,nnn-1)%stage
                  rivtmp(i,nnn)%cond=rivtmp(i,nnn-1)%cond
              end do
          ENDIF
      end do
      do nnn=nsper,1,-1
          write(98,'(I10)') iriv(nnn)
          do i=1,iriv(nnn)
              write(98,'(3i10,'//fmtreal(rivtmp(i,nnn)%stage)//','//
     +             fmtreal(rivtmp(i,nnn)%cond)//')')
     +            rivtmp(i,nnn)%kk,rivtmp(i,nnn)%ii,rivtmp(i,nnn)%jj,
     +            rivtmp(i,nnn)%stage,rivtmp(i,nnn)%cond
          end do
      end do
      close(98)
      close(inriv)
      open(inriv,file='$~temp.riv',status='old')
      deallocate(rivtmp)

10003 IF(INSTR.EQ.0) then                                               ! STREAMS
          GOTO 10004
      end if
      open(98,file='$~temp.str',status='unknown')
      allocate(strtmp(mxstr,nsper))
      read(instr,'(a80)') dumline
      do nnn=1,nsper
          READ(INSTR,'(I10)') ISTR(nnn)
          IF(ISTR(nnn).GE.0) THEN
              DO I=1,ISTR(nnn)
                  READ(INSTR,'(5I5,f15.0,2F10.0)') strtmp(i,nnn)%kk,
     +            strtmp(i,nnn)%ii,strtmp(i,nnn)%jj,tmp1,tmp2,tmp3,
     +            strtmp(i,nnn)%stage,strtmp(i,nnn)%cond
              end do
              IF(ICALC.GT.0) THEN
                  DO Nm=1,ISTR(nnn)
                      READ(INSTR,'(F10.0)') tmp1
                  end do
              ENDIF
              IF(NTRIB.GT.0) THEN
                  DO  Nm=1,NSS
                      READ(INSTR,'(I5)') tmp1
                  end do
              ENDIF
              IF(NDIV.GT.0) THEN
                  DO  Nm=1,NSS
                      READ(INSTR,'(I10)') tmp1
                  end do
              end if
          ELSE
              istr(nnn)=istr(nnn-1)
              do i=1,istr(nnn)
                  strtmp(i,nnn)%kk=strtmp(i,nnn-1)%kk
                  strtmp(i,nnn)%ii=strtmp(i,nnn-1)%ii
                  strtmp(i,nnn)%jj=strtmp(i,nnn-1)%jj
                  strtmp(i,nnn)%stage=strtmp(i,nnn-1)%stage
                  strtmp(i,nnn)%cond=strtmp(i,nnn-1)%cond
              end do
          ENDIF
      end do
      do nnn=nsper,1,-1
          write(98,'(I10)') istr(nnn)
          do i=1,istr(nnn)
            write(98,'(5i10,f15.0,'//fmtreal(strtmp(i,nnn)%stage)//','//
     +            fmtreal(strtmp(i,nnn)%cond)//')')
     +            strtmp(i,nnn)%kk,strtmp(i,nnn)%ii,strtmp(i,nnn)%jj,
     +            0,0,0.0,
     +            strtmp(i,nnn)%stage,strtmp(i,nnn)%cond
c JPK it is necessary to write out tmp1,tmp2,tmp3, even though we don't do anything with them
          end do
      end do
      close(98)
      close(instr)
      open(instr,file='$~temp.str',status='old')
      deallocate(strtmp)

10004 IF(INGHB.EQ.0) then                                               ! GHBs
          GOTO 10005
      end if
      open(98,file='$~temp.ghb',status='unknown')
      allocate(rivtmp(mxghb,nsper))
      do nnn=1,nsper
          READ(INGHB,'(I10)') IGHB(nnn)
          IF(IGHB(nnn).GE.0) THEN
              DO I=1,IGHB(nnn)
                  READ(INGHB,'(3I10,2F10.0)') ghbtmp(i,nnn)%kk,
     +            ghbtmp(i,nnn)%ii,ghbtmp(i,nnn)%jj,ghbtmp(i,nnn)%stage,
     +            ghbtmp(i,nnn)%cond
              end do
          ELSE
              ighb(nnn)=ighb(nnn-1)
              do i=1,ighb(nnn)
                  ghbtmp(i,nnn)%kk=ghbtmp(i,nnn-1)%kk
                  ghbtmp(i,nnn)%ii=ghbtmp(i,nnn-1)%ii
                  ghbtmp(i,nnn)%jj=ghbtmp(i,nnn-1)%jj
                  ghbtmp(i,nnn)%stage=ghbtmp(i,nnn-1)%stage
                  ghbtmp(i,nnn)%cond=ghbtmp(i,nnn-1)%cond
              end do
          ENDIF
      end do
      do nnn=nsper,1,-1
          write(98,'(I10)') ighb(nnn)
          do i=1,ighb(nnn)
              write(98,'(3i10,'//fmtreal(ghbtmp(i,nnn)%stage)//','//
     +             fmtreal(ghbtmp(i,nnn)%cond)//')')
     +            ghbtmp(i,nnn)%kk,ghbtmp(i,nnn)%ii,ghbtmp(i,nnn)%jj,
     +            ghbtmp(i,nnn)%stage,ghbtmp(i,nnn)%cond
          end do
      end do
      close(98)
      close(inghb)
      open(inghb,file='$~temp.ghb',status='old')
      deallocate(ghbtmp)

10005 IF(INRCH.EQ.0) then                                               ! RECHARGE
          GOTO 10006
      end if
      open(98,file='$~temp.rch',status='unknown')
      allocate(rech1(ncol,nrow,nsper),irch1(ncol,nrow,nsper))
      do nnn=1,nsper                                                    ! read
          READ(INRCH,'(2i10)') INRECH,INIRCH
C--IF INRECH=>0 THEN CALL RARRAY TO READ RECHARGE RATES
          IF(INRECH.GE.0) THEN
              CALL RARRAY(RECH,' ',NROW,NCOL,0,INRCH,IOUT)
              do i=1,nrow
                  do j=1,ncol
                      rech1(j,i,nnn)=rech(j,i)
                  end do
              end do
          ELSE
              do i=1,nrow
                  do j=1,ncol
                      rech1(j,i,nnn)=rech1(j,i,nnn-1)
                    end do
              end do
          ENDIF
C--IF NRCHOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.
          IF(NRCHOP.EQ.2.AND.INIRCH.GE.0) THEN
              CALL IARRAY(IRCH,' ',NROW,NCOL,0,INRCH,IOUT)
              do i=1,nrow
                  do j=1,ncol
                      irch1(j,i,nnn)=irch(j,i)
                    end do
              end do
          ELSEIF(NRCHOP.EQ.2.AND.INIRCH.LT.0) THEN
              do i=1,nrow
                  do j=1,ncol
                      irch1(j,i,nnn)=irch1(j,i,nnn-1)
                    end do
              end do
          end if
      end do

      do nnn=nsper,1,-1                                                 ! write
          write(98,'(2I10)') 1,1
          do i=1,nrow
              do j=1,ncol
                  rech(j,i)=rech1(j,i,nnn)
              end do
          end do
          call Rwrite(rech,'RECHARGE                ',
     +                    nrow,ncol,0,inrch,98,0)
          IF(NRCHOP.EQ.2) THEN
              do i=1,nrow
                  do j=1,ncol
                      irch(j,i)=irch1(j,i,nnn)
                  end do
              end do
              call Iwrite(irch,' ',nrow,ncol,0,0,inrch,98,0)
          end if
      end do
      close(98)
      close(inrch)
      open(inrch,file='$~temp.rch',status='old')
      deallocate(rech1,irch1)

10006 IF(INEVT.EQ.0) then                                               ! EVAPOTRANSPIRATION
          GOTO 10007
      end if
      open(98,file='$~temp.evt',status='unknown')
      allocate(surf1(ncol,nrow,nsper),evtr1(ncol,nrow,nsper),
     +    exdp1(ncol,nrow,nsper),ievt1(ncol,nrow,nsper))
      do nnn=1,nsper
C--READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.
          READ(INEVT,'(4i10)') INSURF,INEVTR,INEXDP,INIEVT              ! read
C--IF INSURF=>0 THEN CALL MODULE RARRAY TO READ SURFACE.
          IF(INSURF.GE.0) THEN
                CALL RARRAY(SURF,' ',NROW,NCOL,0,INEVT,IOUT)
                  do i=1,nrow
                      do j=1,ncol
                          surf1(j,i,nnn)=surf(j,i)
                        end do
                  end do
          ELSE
                  do i=1,nrow
                      do j=1,ncol
                          surf1(j,i,nnn)=surf1(j,i,nnn-1)
                      end do
                  end do
          ENDIF
C
          IF(INEVTR.GE.0) THEN
              CALL RARRAY(EVTR,' ',NROW,NCOL,0,INEVT,IOUT)
                  do i=1,nrow
                      do j=1,ncol
                          evtr1(j,i,nnn)=evtr(j,i)
                      end do
                  end do
          ELSE
                  do i=1,nrow
                      do j=1,ncol
                          evtr1(j,i,nnn)=evtr1(j,i,nnn-1)
                      end do
                  end do
          ENDIF
C---IF INEXDP=>0 CALL MODULE RARRAY TO READ EXTINCTION DEPTH
          IF(INEXDP.GE.0) THEN
              CALL RARRAY(EXDP,' ',NROW,NCOL,0,INEVT,IOUT)
                  do i=1,nrow
                      do j=1,ncol
                          exdp1(j,i,nnn)=exdp(j,i)
                          end do
                  end do
          ELSE
                  do i=1,nrow
                      do j=1,ncol
                          exdp1(j,i,nnn)=exdp1(j,i,nnn-1)
                      end do
                  end do
          ENDIF
C--IF OPTION(NEVTOP) IS 2 THEN WE NEED AN INDICATOR ARRAY.
          IF(NEVTOP.EQ.2.AND.INIEVT.GE.0) THEN
              CALL IARRAY(IEVT,' ',NROW,NCOL,0,INEVT,IOUT)
              do i=1,nrow
                  do j=1,ncol
                      ievt1(j,i,nnn)=ievt(j,i)
                    end do
              end do
          ELSEIF(NEVTOP.EQ.2.AND.INIEVT.LT.0) THEN
              do i=1,nrow
                  do j=1,ncol
                      ievt1(j,i,nnn)=ievt1(j,i,nnn-1)
                  end do
              end do
          ENDIF
      end do

      do nnn=nsper,1,-1                                                 ! write
          write(98,'(4i10)') 1,1,1,1
          do i=1,nrow
              do j=1,ncol
                  surf(j,i)=surf1(j,i,nnn)
                  evtr(j,i)=evtr1(j,i,nnn)
                  exdp(j,i)=exdp1(j,i,nnn)
              end do
          end do
          call Rwrite(surf,' ',nrow,ncol,0,0,98,0)
          call Rwrite(evtr,' ',nrow,ncol,0,0,98,0)
          call Rwrite(exdp,' ',nrow,ncol,0,0,98,0)
          if (nevtop.eq.2) then
              do i=1,nrow
                  do j=1,ncol
                      ievt(j,i)=ievt1(j,i,nnn)
                  end do
              end do
              call Iwrite(ievt,' ',nrow,ncol,0,0,98,0)
          endif
      end do
      close(98)
      close(inevt)
      open(inevt,file='$~temp.evt',status='old')
      deallocate(surf1,evtr1,exdp1,ievt1)

10007 return
      end subroutine reverseSS


      SUBROUTINE Rwrite(A,ANAME,II,JJ,K,IN,IOUT,iprn)
C **********************************************************************
C THIS SUBROUTINE IS USED TO WRITE 1 OR 2D REAL ARRAYS IN THE FORM
C READABLE BY MODFLOW ARRAY READERS U2DREL/U1DREL OR MT3D's RARRAY.
C **********************************************************************
C cz, last modified: Mon  08-02-1993
C
      INTEGER   II,JJ,K,IN,IOUT,IPRN,ErrCode,ifmt
      REAL      A,CONST
      LOGICAL   UNIFORM,opd
      CHARACTER ANAME*24,FMTIN*20,ErrPointer*50
      DIMENSION A(JJ,II)
      COMMON    /SubErrCode/ErrCode,ErrPointer
c
c--initialize i/o format
      fmtin='(6x,10f11.0)'
c
c--initialize constants
c      uniform=.false.
c      const=0.
c      if(IN.ne.IOUT) goto 20
c
c--check whether a is constant if no external file is used
c      oldval=a(1,1)
c      do i=1,ii
c        do j=1,jj
c          if(abs(a(j,i)-oldval).gt.1.e-5*oldval) then
c            goto 10
c          else
c            oldval=a(j,i)
c          endif
c        enddo
c      enddo
c      uniform=.true.
c      const=oldval
c   10 continue
c
c--assign a print format
c      if(ii.eq.1) then
c        assign 200 to ifmt
c      elseif(jj.le.10) then
c        assign 201 to ifmt
c      else
        assign 205 to ifmt
c      endif
c
c--write array control record
c  ==========================
c   20 if(.not.uniform) then
c        if(k.gt.0) then
c          WRITE (IOUT,1,err=9999,iostat=ErrCode)
c     &                 IN,CONST,FMTIN,IPRN,aname(1:15),k
c        else
          WRITE (IOUT,2,err=9999,iostat=ErrCode)
     &                 in,CONST,FMTIN,IPRN,aname(1:15)
c        endif
c      else
c        if(k.gt.0) then
c          WRITE (IOUT,3,err=9999,iostat=ErrCode) 0,CONST,aname(1:15),k
c        else
c          WRITE (IOUT,4,err=9999,iostat=ErrCode) 0,CONST,aname(1:15)
c        endif
c      endif
c    1 FORMAT(I10,1p,E10.3,A20,I10,3x,a15,' layer:',i2)
    2 FORMAT(I10,1p,E10.3,A20,I10,3x,a15)
c    3 FORMAT(I10,1p,E10.3,       33x,a15,' layer:',i2)
c    4 FORMAT(I10,1p,E10.3,       33x,a15)
c
c--write array values.
c      inquire(iabs(IN),opened=opd,err=5)
c    5 continue
c      if(uniform) then                   !no array
c        goto 9999
c      elseif(IN.ne.Iout) then            !binary
c        if(opd) then
c          write(iabs(IN))
c          write(iabs(IN),err=9999,iostat=ErrCode) A
c        endif
c      elseif(ii.eq.1) then               !one row
c        write (IOUT,fmt=ifmt,err=9999,iostat=ErrCode)
c     &   (A(J,ii),J=1,JJ)
c      else                               !multiple rows
        do i=1,ii
          write (IOUT,fmt=ifmt,err=9999,iostat=ErrCode)
     &     i,(A(J,I),J=1,JJ)
        end do
c      endif
c  200 format(6x,10g11.4)
c  201 format('R-',i3.3,1x,1p,10e11.4)
  205 format('R-',i3.3,1x,1p,10e11.4/(6x,1p,10e11.4))
C
C--RETURN
 9999 RETURN
      END
C
C
      SUBROUTINE Iwrite(IA,ANAME,II,JJ,K,IN,IOUT,iprn)
C **********************************************************************
C THIS SUBROUTINE IS USED TO WRITE 1 OR 2D INTEGER ARRAYS IN THE FORM
C READABLE BY MODFLOW ARRAY READERS U2DINT OR MT3D's IARRAY.
C **********************************************************************
C cz, last modified: Mon  08-02-1993
C
      INTEGER    II,JJ,K,IN,IOUT,IPRN,IA,ICONST,ErrCode,iRange
      LOGICAL    UNIFORM
      CHARACTER  ANAME*24,ERRPOINTER*50
      character*20 FMTIN(2)
      DIMENSION  IA(JJ,II)
      COMMON    /SubErrCode/ErrCode,ErrPointer
c
c--initialize i/o format
      fmtin(1)='(6x,20i3)'
      fmtin(2)='(6x,10i10)'
c
c--check whether Ia is constant
      uniform=.false.
      iconst=0.
      ioldval=ia(1,1)
      do i=1,ii
        do j=1,jj
          if(ia(j,i).ne.ioldval) then
            goto 10
          else
            ioldval=ia(j,i)
          endif
        enddo
      enddo
      uniform=.true.
      iconst=ioldval
   10 continue
c
c--assign a print format
      iRange=1
      do i=1,ii
        do j=1,jj
          if(abs(ia(j,i)).gt.99) then
            iRange=2
            goto 20
          endif
        enddo
      enddo
   20 continue
      IF(iRange.eq.1) then
        if(ii.eq.1) then
          assign 100 to ifmt
        elseif(jj.le.20) then
          assign 101 to ifmt
        else
          assign 105 to ifmt
        endif
      ELSEIF(iRange.eq.2) then
        if(ii.eq.1) then
          assign 200 to ifmt
        elseif(jj.le.10) then
          assign 201 to ifmt
        else
          assign 205 to ifmt
        endif
      ENDIF
c
c--write array control record
      if(.not.uniform) then
        if(k.gt.0) then
          WRITE (IOUT,1,err=9999,iostat=ErrCode)
     &                 IN,iCONST,FMTIN(iRange),IPRN,aname(1:15),k
        else
          WRITE (IOUT,2,err=9999,iostat=ErrCode)
     &                 IN,iCONST,FMTIN(iRange),IPRN,aname(1:15)
        endif
      else
        if(k.gt.0) then
          WRITE (IOUT,3,err=9999,iostat=ErrCode) 0,iCONST,aname(1:15),k
        else
          WRITE (IOUT,4,err=9999,iostat=ErrCode) 0,iCONST,aname(1:15)
        endif
      endif
    1 FORMAT(I10,I10,A20,I10,3x,a15,' layer:',i2)
    2 FORMAT(I10,I10,A20,I10,3x,a15)
    3 FORMAT(I10,I10,       33x,a15,' layer:',i2)
    4 FORMAT(I10,I10,       33x,a15)
c
c--write array values
      if(uniform) goto 9999
      if(ii.eq.1) then
        write (IOUT,fmt=ifmt,err=9999,iostat=ErrCode)
     &   (iA(J,ii),J=1,JJ)
      else
        do i=1,ii
          write (IOUT,fmt=ifmt,err=9999,iostat=ErrCode)
     &     i,(iA(J,I),J=1,JJ)
        enddo
      endif
c
  105 format('R-',i3.3,1x,20i3/(6x,20i3))
  205 format('R-',i3.3,1x,10i10/(6x,10i10))
  101 format('R-',i3.3,1x,20i3)
  201 format('R-',i3.3,1x,10i10)
  100 format(6x,20i3)
  200 format(6x,10i10)
C
C--RETURN
 9999 RETURN
      END
