C
      SUBROUTINE VFACE(NCOL,NROW,NLAY,IBOUND,H,KWTBL,DELR,DELC,
     &	HY,TRPY,VCON,MXGHB,NBOUND,GHBND,NRCHOP,IRCH,RECH,
     &  NEVTOP,IEVT,EVTR,EXDP,SURF,QX,QY,QZ,idirection)
C ****************************************************************
C THIS ROUTINE CALCULATES COMPONENTS OF THE SPECIFIC DISCHARGE
C AT CELL INTERFACES.
C ****************************************************************
C VER 3.00: Tue  06-25-1991
C
      DIMENSION IBOUND(NCOL,NROW,NLAY),H(NCOL,NROW,NLAY),
     & DELR(NCOL),DELC(NROW),KWTBL(NCOL,NROW),
     & HY(NCOL,NROW,NLAY),TRPY(NLAY),VCON(NCOL,NROW,NLAY),
     & QX(NCOL+1,NROW,NLAY),QY(NCOL,NROW+1,NLAY),
     & QZ(NCOL,NROW,NLAY+1),GHBND(5,MXGHB),
     & IRCH(NCOL,NROW),RECH(NCOL,NROW),IEVT(NCOL,NROW),
     & EVTR(NCOL,NROW),EXDP(NCOL,NROW),SURF(NCOL,NROW)
      COMMON /UNIT/INBCF,INWEL,INDRN,INRIV,INEVT,INGHB,INRCH,INSTR
C
C--COMPUTE INTERNODAL SPECIFIC DISCHARGE IN THE X (J) DIRECTION
      IF(NCOL.LT.2) THEN
        GOTO 1
      ENDIF
      DO 10 K=1,NLAY
      DO 15 I=1,NROW
      DO 20 J=1,NCOL+1
      IF(J.EQ.1 .OR. J.EQ.NCOL+1) THEN
        QX(J,I,K)=0
      ELSEIF(IBOUND(J-1,I,K).EQ.0 .OR. IBOUND(J,I,K).EQ.0) THEN
        QX(J,I,K)=0
      ELSE
        IF(HY(J,I,K).EQ.0. .OR. HY(J-1,I,K).EQ.0.) THEN
          XCON=0.
        ELSE
          XCON=2./(DELR(J)/HY(J,I,K)+DELR(J-1)/HY(J-1,I,K))
        ENDIF
        QX(J,I,K)=-XCON*(H(J,I,K)-H(J-1,I,K))
      ENDIF
   20 CONTINUE
   15 CONTINUE
   10 CONTINUE
C
C--REPEAT IN THE Y (I) DIRECTION
    1 IF(NROW.LT.2) THEN
        GOTO 2
      ENDIF
      DO 30 K=1,NLAY
      DO 35 J=1,NCOL
      DO 40 I=1,NROW+1
      IF(I.EQ.1 .OR. I.EQ.NROW+1) THEN
        QY(J,I,K)=0
      ELSEIF(IBOUND(J,I-1,K).EQ.0 .OR. IBOUND(J,I,K).EQ.0) THEN
        QY(J,I,K)=0
      ELSE
        IF(TRPY(K).EQ.0..OR.HY(J,I,K).EQ.0..OR.HY(J,I-1,K).EQ.0.) THEN
          YCON=0
        ELSE
          YCON=2./(DELC(I)/(TRPY(K)*HY(J,I,K))
     &    +DELC(I-1)/(TRPY(K)*HY(J,I-1,K)))
        ENDIF
        QY(J,I,K)=-YCON*(H(J,I,K)-H(J,I-1,K))
      ENDIF
   40 CONTINUE
   35 CONTINUE
   30 CONTINUE
C
C--REPEAT IN THE Z (K) DIRECTION
    2 IF(NLAY.LT.2) THEN
        GOTO 3
      ENDIF
      DO 50 I=1,NROW
      DO 55 J=1,NCOL
      DO 60 K=1,NLAY+1
      IF(K.EQ.1 .OR. K.EQ.NLAY+1) THEN
        QZ(J,I,K)=0
      ELSEIF(IBOUND(J,I,K-1).EQ.0 .OR. IBOUND(J,I,K).EQ.0) THEN
        QZ(J,I,K)=0
      ELSE
        QZ(J,I,K)=-VCON(J,I,K-1)*(H(J,I,K)-H(J,I,K-1))
      ENDIF
   60 CONTINUE
   55 CONTINUE
   50 CONTINUE
C
C--LOCATE TOP ACTIVE CELLS
    3 DO 70 I=1,NROW
      DO 75 J=1,NCOL
      DO 80 K=1,NLAY
      IF(IBOUND(J,I,K).EQ.0.AND.K.LT.NLAY) THEN
        GOTO 80
      ELSE
        KWTBL(J,I)=K
        GOTO 75
      ENDIF
   80 CONTINUE
   75 CONTINUE
   70 CONTINUE
C
C--IF RECHARGE NOT ZERO, SET QZ AT WATER TABLE EQUAL TO RECHARGE RATE
      IF(NLAY.LT.2) GOTO 444
      IF(INRCH.EQ.0) GOTO 5
      DO 90 I=1,NROW
      DO 91 J=1,NCOL
      IF(NRCHOP.EQ.1) THEN
        LR=1
      ELSEIF(NRCHOP.EQ.3) THEN
        LR=KWTBL(J,I)
      ELSE
        LR=IRCH(J,I)
      ENDIF
      IF(LR.EQ.KWTBL(J,I).AND.IBOUND(J,I,LR).GT.0) THEN
        QZ(J,I,LR)=QZ(J,I,LR)+RECH(J,I)
      ENDIF
   91 CONTINUE
   90 CONTINUE
C
C--IF EVAPOTRANSPORATION RATE NOT ZERO,
C--SUBSTRACT ET RATE FROM QZ AT WATER TABLE
    5 IF(INEVT.EQ.0) GOTO 444
C
      DO 100 I=1,NROW
      DO 110 J=1,NCOL
      IF(NEVTOP.EQ.1) THEN
        LE=1
      ELSEIF(NEVTOP.EQ.2) THEN
        LE=IEVT(J,I)
      ELSEIF(NEVTOP.EQ.3) THEN
        LE=KWTBL(J,I)
      ENDIF
      IF(LE.NE.KWTBL(J,I)) GOTO 110
      IF(IBOUND(J,I,LE).LE.0) GOTO 110
C
      C=EVTR(J,I)
      S=SURF(J,I)
      HH=H(J,I,LE)
C
C--IF AQUIFER HEAD => SURF,SET Q=MAX ET RATE
C--ELSE LINEAR RANGE BETWEEN MAX ET AND ZERO
      IF(HH.GE.S) THEN
        Q=-C
      ELSE
        X=EXDP(J,I)
        D=S-HH
        IF(D.GE.X) THEN
          Q=0
        ELSE
          Q=C*D/X-C
        ENDIF
      ENDIF
C
      QZ(J,I,LE)=QZ(J,I,LE)+Q
  110 CONTINUE
  100 CONTINUE
C
C--IF AT GENERAL-HEAD BOUNDARY AND QX, QY, OR QZ =0 AT ONE INTERFACE,
C--SET IT EQUAL TO THAT ON THE OTHER INTERFACE
  444 IF(INGHB.EQ.0) GOTO 6
      DO 200 NB=1,NBOUND
	K=GHBND(1,NB)
	I=GHBND(2,NB)
	J=GHBND(3,NB)
        IF(J.EQ.1) QX(J,I,K)=QX(J+1,I,K)
        IF(J.EQ.NCOL) QX(J+1,I,K)=QX(J,I,K)
        IF(I.EQ.1) QY(J,I,K)=QY(J,I+1,K)
        IF(I.EQ.NROW) QY(J,I+1,K)=QY(J,I,K)
        IF(K.EQ.1) QZ(J,I,K)=QZ(J,I,K+1)
        IF(K.EQ.NLAY) QZ(J,I,K+1)=QZ(J,I,K)
  200 CONTINUE
C
C--IF AT CONSTANT HEAD BOUNDARY,
C--APPLY THE SAME PROCEDURE AS FOR GENREAL-HEAD BOUNDARY
    6 DO 300 K=1,NLAY
      DO 301 I=1,NROW
      DO 302 J=1,NCOL
        IF(IBOUND(J,I,K).GE.0) GOTO 302
        IF(J.EQ.1) QX(J,I,K)=QX(J+1,I,K)
        IF(J.EQ.NCOL) QX(J+1,I,K)=QX(J,I,K)
        IF(I.EQ.1) QY(J,I,K)=QY(J,I+1,K)
        IF(I.EQ.NROW) QY(J,I+1,K)=QY(J,I,K)
        IF(K.EQ.1) QZ(J,I,K)=QZ(J,I,K+1)
        IF(K.EQ.NLAY) QZ(J,I,K+1)=QZ(J,I,K)
  302 CONTINUE
  301 CONTINUE
  300 CONTINUE
C
      RETURN
      END
C
C
      SUBROUTINE VPOINT(P,V,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,KWTBL,
     &  IBOUND,H,DELR,DELC,DZ,XBC,YBC,ZBC,HTOP,PRSITY,QX,QY,QZ,
     +  idirection)
C *********************************************************************
C THIS ROUTINE CALCULATES THE SEEPAGE VELOCITY V AT POINT P BASED ON
C LINEAR INTERPOLATION OF SEEPAGE VELOCITIES AT THE INTERFACES BETWEEN
C NEIGHBORING CELLS IN THE X-, Y- AND Z- DIRECTIONS, RESPECTIVELY.
C *********************************************************************
C VER 3.11: Sun  06-21-1992
C
      DIMENSION DELR(NCOL),DELC(NROW),DZ(NCOL,NROW,NLAY),
     & XBC(NCOL),YBC(NROW),ZBC(NCOL,NROW,NLAY),H(NCOL,NROW,NLAY),
     & HTOP(NCOL,NROW),IBOUND(NCOL,NROW,NLAY),PRSITY(NCOL,NROW,NLAY),
     & QX(NCOL+1,NROW,NLAY),QY(NCOL,NROW+1,NLAY),
     & QZ(NCOL,NROW,NLAY+1),KWTBL(NCOL,NROW),P(3),V(3),PSCAL(3)
      COMMON /VP/JP,IP,KP
      COMMON /LC/LAYCON(80)
C
C--LOCATE THE POSITION OF POINT P IN THE FINITE-DIFFERENCE GRID.
C--IF P IS NOT WITHIN ACTIVE FLOW DOMAIN, RETURN
      HORIGN=HTOP(1,1)
      CALL LOCATE(P,DT,IEXIT,NCOL,NROW,NLAY,PSCAL,DELR,DELC,DZ,
     &  XBC,YBC,ZBC,IBOUND,H,KWTBL,HTOP,QZ)
      IF(IEXIT.NE.0) RETURN
C
C--INTERPOLATE THE X COMPONENT OF THE SPECIFIC DISCHARGE AT P
C--BETWEEN TWO CELL INTERFACES
      IF(NCOL.LE.1) THEN
        V(1)=0
      ELSE
        QXTMP1=QX(JP,IP,KP)
        QXTMP2=QX(JP+1,IP,KP)
        ALPHA=(P(1)-XBC(JP)+DELR(JP)/2.)/DELR(JP)
        IF(ALPHA.LT.0) ALPHA=0
        V(1)=ALPHA*QXTMP2+(1.-ALPHA)*QXTMP1
      ENDIF
C
C--INTERPOLATE THE Y COMPONENT
      IF(NROW.LE.1) THEN
        V(2)=0
      ELSE
        QYTMP1=QY(JP,IP,KP)
        QYTMP2=QY(JP,IP+1,KP)
        ALPHA=(P(2)-YBC(IP)+DELC(IP)/2.)/DELC(IP)
        IF(ALPHA.LT.0) ALPHA=0
        V(2)=ALPHA*QYTMP2+(1.-ALPHA)*QYTMP1
      ENDIF
C
C--INTERPOLATE THE Z COMPONENT
      IF(NLAY.LE.1) THEN
        V(3)=0
      ELSE
        QZTMP1=QZ(JP,IP,KP)
        QZTMP2=QZ(JP,IP,KP+1)
        IF(LAYCON(KP).NE.0.AND.
     &  HORIGN-H(JP,IP,KP).GT.ZBC(JP,IP,KP)-DZ(JP,IP,KP)/2.) THEN
          WTBL=HORIGN-H(JP,IP,KP)
          THKSAT=ZBC(JP,IP,KP)+DZ(JP,IP,KP)/2.-WTBL
          ALPHA=(P(3)-WTBL)/THKSAT
        ELSE
          ALPHA=(P(3)-ZBC(JP,IP,KP)+DZ(JP,IP,KP)/2.)/DZ(JP,IP,KP)
        ENDIF
        IF(ALPHA.LT.0) ALPHA=0
        V(3)=ALPHA*QZTMP2+(1.-ALPHA)*QZTMP1
      ENDIF
C
C--CONVERT SPECIFIC DISCHARGE INTO SEEPAGE VELOCITY
      DO 1000 N=1,3
      IF(PRSITY(JP,IP,KP).EQ.0.) THEN
        V(N)=0.
      ELSE
        V(N)=V(N)/PRSITY(JP,IP,KP)
      ENDIF
 1000 CONTINUE
C
C--NORMAL RETURN
      RETURN
      END
