C
      PROGRAM P3DCAPT
C *********************************************************************
C Postprocessor of PATH3D (V3.0) for creating captured particle plots.
C Input:  P3DCAPT.DAT file generated by P3D;
C Output: CAPTXYZ.DAT with X, Y, Z, XI, YI, ZI, Time, SinkType.
C *********************************************************************
C
      CHARACTER*80 FLNAME,RX*1,RY*1,RZ*1,TYPE*5
C
C--OPEN INPUT FILE
      WRITE(*,*) 'Enter Name of P3DCAPT Data File',
     & ' (Default: P3DCAPT.DAT): '
      READ(*,'(A80)') FLNAME
      IF(FLNAME.EQ.' ') FLNAME='P3DCAPT.DAT'
      OPEN(15,FILE=FLNAME)
C
C--READ HEADER
      READ(15,*,ERR=16) NCOL,NROW,NLAY,RX,XTRANS,RY,YTRANS,RZ,ZTRANS
      GOTO 20
   16 WRITE(*,*) 'STOP.  P3DCAPT DATA FILE HEADER INCORRECT.'
      STOP
   20 CONTINUE
C
C--SET UP COORDINATE TRANSFORMATION
      IXAXIS=1
      IYAXIS=1
      IZAXIS=1
      IF(RX.EQ.'-') IXAXIS=-1
      IF(RY.EQ.'-') IYAXIS=-1
      IF(RZ.EQ.'-') IZAXIS=-1
C
C--OPEN OUTPUT FILES
      OPEN(20,FILE='CAPTXYZ.DAT')
C
C--READ AND PERFORM COORDINATE TRANSFORMATION
   21 READ(15,*,END=25) NP,XX,YY,ZZ,TIME,XI,YI,ZI,TYPE
        XX=IXAXIS*(XX-XTRANS)
        YY=IYAXIS*(YY-YTRANS)
        ZZ=IZAXIS*(ZZ-ZTRANS)
        XI=IXAXIS*(XI-XTRANS)
        YI=IYAXIS*(YI-YTRANS)
        ZI=IZAXIS*(ZI-ZTRANS)
C
C--WRITE TO OUTPUT FILE
        WRITE(20,30) XX,YY,ZZ,XI,YI,ZI,TIME,TYPE
C
        GOTO 21
   25 CONTINUE
   30 FORMAT(1X,7(G13.5,1X),2X,'''',A5,'''')
C
C--DONE
      STOP
      END
