C
      PROGRAM P3DFRONT
C *********************************************************************
C Postprocessor of PATH3D (V3.0) for creating capture zone front plots.
C Input:  P3DFRONT.DAT file generated by P3D;
C Output: FRONTXYZ.DAT with X, Y, Z, Time and Particle Number.
C *********************************************************************
C
      PARAMETER (NPMAX=10000)
      CHARACTER*80 FLNAME,RX*1,RY*1,RZ*1
      COMMON PARTNO(NPMAX),XX(NPMAX),YY(NPMAX),ZZ(NPMAX),TIME(NPMAX)
C
C--OPEN INPUT FILE
      WRITE(*,*) 'Enter Name of P3DFRONT Data File',
     & ' (Default: P3DFRONT.DAT): '
      READ(*,'(A80)') FLNAME
      IF(FLNAME.EQ.' ') FLNAME='P3DFRONT.DAT'
      OPEN(15,FILE=FLNAME)
C
C--READ HEADER
      READ(15,*,ERR=16) NCOL,NROW,NLAY,RX,XTRANS,RY,YTRANS,RZ,ZTRANS
      GOTO 20
   16 WRITE(*,*) 'STOP.  P3DFRONT DATA FILE HEADER INCORRECT.'
      STOP
   20 CONTINUE
C
C--READ AND SORT
      NP=1
   21 READ(15,*,END=25) PARTNO(NP),XX(NP),YY(NP),ZZ(NP),TIME(NP)
        NP=NP+1
        IF(NP.GT.NPMAX) THEN
          WRITE(*,*) 'STOP.  [NPMAX] DIMENSIONED TOO SMALL.'
          STOP
        ENDIF
        GOTO 21
   25 CONTINUE
      NP=NP-1
      IF(NP.GT.1) CALL SORT5A(NP,TIME,XX,YY,ZZ,PARTNO)
      NB=1
      DO 27 N=1,NP
        IF(N.EQ.NP.OR.TIME(N+1).NE.TIME(NB)) THEN
          NLAST=N
          LENGTH=NLAST-NB+1
          IF(LENGTH.GT.1)
     &     CALL SORT5A(LENGTH,PARTNO(NB),XX(NB),YY(NB),ZZ(NB),TIME(NB))
          NB=NLAST+1
         ENDIF
   27 CONTINUE
C
C--SETUP COORDINATE TRANSFORMATION
      IXAXIS=1
      IYAXIS=1
      IZAXIS=1
      IF(RX.EQ.'-') IXAXIS=-1
      IF(RY.EQ.'-') IYAXIS=-1
      IF(RZ.EQ.'-') IZAXIS=-1
C
C--OPEN OUTPUT FILES
      OPEN(20,FILE='FRONTXYZ.DAT')
C
      DO 30 N=1,NP
        XP=IXAXIS*(XX(N)-XTRANS)
        YP=IYAXIS*(YY(N)-YTRANS)
        ZP=IZAXIS*(ZZ(N)-ZTRANS)
        WRITE(20,*) XP,YP,ZP,TIME(N),INT(PARTNO(N))
   30 CONTINUE
C
C--DONE
      STOP
      END
C
C
      SUBROUTINE SORT5A(N,RA,RB,RC,RD,RE)
      DIMENSION RA(N),RB(N),RC(N),RD(N),RE(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
          RRC=RC(L)
          RRD=RD(L)
          RRE=RE(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RRC=RC(IR)
          RRD=RD(IR)
          RRE=RE(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          RC(IR)=RC(1)
          RD(IR)=RD(1)
          RE(IR)=RE(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RC(1)=RRC
            RD(1)=RRD
            RE(1)=RRE
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            RC(I)=RC(J)
            RD(I)=RD(J)
            RE(I)=RE(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
        RC(I)=RRC
        RD(I)=RRD
        RE(I)=RRE
      GO TO 10
      END
