C
      PROGRAM P3DPLOT
C **************************************************************
C Postprocessor of PATH3D (V3.0) for creating pathline plots.
C Input:  P3DPLOT.DAT file generated by P3D;
C Output: PATHXYZ.DAT, PATHXY.BLN, PATHYZ.BLN and PATHXZ.BLN.
C **************************************************************
C
      PARAMETER (NPMAX=9999999)
      CHARACTER*80 FLNAME,RX*1,RY*1,RZ*1
      COMMON XX(NPMAX),YY(NPMAX),ZZ(NPMAX)
C
C--OPEN INPUT FILE
      WRITE(*,*) 'Enter Name of P3DPLOT Data File',
     & ' (Default: P3DPLOT.DAT): '
      READ(*,'(A80)') FLNAME
      IF(FLNAME.EQ.' ') FLNAME='P3DPLOT.DAT'
      OPEN(15,FILE=FLNAME)
C
C--READ HEADER
      READ(15,*,ERR=16) NCOL,NROW,NLAY,RX,XTRANS,RY,YTRANS,RZ,ZTRANS
      GOTO 20
   16 WRITE(*,*) 'STOP.  P3DPLOT DATA FILE HEADER INCORRECT.'
      STOP
   20 CONTINUE
C
C--OPEN OUTPUT FILES
      OPEN(20,FILE='PATHXYZ.DAT')
      IF(NCOL.GT.1.AND.NROW.GT.1) OPEN(21,FILE='PATHXY.BLN')
      IF(NROW.GT.1.AND.NLAY.GT.1) OPEN(22,FILE='PATHYZ.BLN')
      IF(NCOL.GT.1.AND.NLAY.GT.1) OPEN(23,FILE='PATHXZ.BLN')
C
C--INITIALIZE
      NCOUNT=1
      NP=1
      ICODE=0
C
C--SETUP COORDINATE TRANSFORMATION
      IXAXIS=1
      IYAXIS=1
      IZAXIS=1
      IF(RX.EQ.'-') IXAXIS=-1
      IF(RY.EQ.'-') IYAXIS=-1
      IF(RZ.EQ.'-') IZAXIS=-1
C
C--READ ONE RECORD AT A TIME
    1 READ(15,*,END=200,ERR=2) NUM, X,Y,Z
c     if(num.lt.ncount) then
c       ncount=1
c       np=1
c       backspace (15)
c       goto 1
c     endif
C
C--TRANSFORM COORDINATES
      XP=IXAXIS*(X-XTRANS)
      YP=IYAXIS*(Y-YTRANS)
      ZP=IZAXIS*(Z-ZTRANS)
C
C--WRITE TO 'POST DATA' OUTPUT FILE
      WRITE(20,*) XP,YP,ZP, NUM
C
C--SAVE INTERMMEDIATE POSITIONS OF A PARTICLE IN ARRAY
    2 IF(NUM.EQ.NCOUNT) THEN
        XX(NP)=XP
        YY(NP)=YP
        ZZ(NP)=ZP
        NP=NP+1
        IF(NP.GT.NPMAX) THEN
          WRITE(*,*) 'STOP.  [NPMAX] DIMENSIONED TOO SMALL.'
          STOP
        ENDIF
C
C--WRITE TO 'LINE SEGMENT' OUTPUT FILE
      ELSE
        IF(NP.GE.3) THEN
          IF(NCOL.GT.1.AND.NROW.GT.1) THEN
            WRITE(21,100) NP-1,ICODE,NCOUNT
            WRITE(21,'(2G15.7)') (XX(N),YY(N),N=1,NP-1)
          ENDIF
          IF(NROW.GT.1.AND.NLAY.GT.1) THEN
            WRITE(22,100) NP-1,ICODE,NCOUNT
            WRITE(22,'(2G15.7)') (YY(N),ZZ(N),N=1,NP-1)
          ENDIF
          IF(NCOL.GT.1.AND.NLAY.GT.1) THEN
            WRITE(23,100) NP-1,ICODE,NCOUNT
            WRITE(23,'(2G15.7)') (XX(N),ZZ(N),N=1,NP-1)
          ENDIF
        ENDIF
        IF(NUM.LT.NCOUNT) THEN
          NCOUNT=1
        ELSE
          NCOUNT=NCOUNT+1
        ENDIF
        NP=1
        GOTO 2
      ENDIF
      GOTO 1
C
C--WRITE LAST PARTICLE TO 'LINE SEGMENT' OUTPUT FILE
  200 CONTINUE
        IF(NP.GE.3) THEN
        IF(NCOL.GT.1.AND.NROW.GT.1) THEN
          WRITE(21,100) NP-1,ICODE,NCOUNT
          WRITE(21,'(2G15.7)') (XX(N),YY(N),N=1,NP-1)
        ENDIF
        IF(NROW.GT.1.AND.NLAY.GT.1) THEN
          WRITE(22,100) NP-1,ICODE,NCOUNT
          WRITE(22,'(2G15.7)') (YY(N),ZZ(N),N=1,NP-1)
        ENDIF
        IF(NCOL.GT.1.AND.NLAY.GT.1) THEN
          WRITE(23,100) NP-1,ICODE,NCOUNT
          WRITE(23,'(2G15.7)') (XX(N),ZZ(N),N=1,NP-1)
        ENDIF
      ENDIF
  100 FORMAT(1X,2I8,5X,'*\Particle No.=',I8)
C
C--DONE
      STOP
      END
